import{S as J0,i as Q0,s as Z0,e as o,k as c,w as f,t as a,M as ex,c as n,d as t,m as l,a as s,x as g,h as i,b as d,G as r,g as m,y as h,q as u,o as _,B as b,v as rx,L as yT}from"../../chunks/vendor-hf-doc-builder.js";import{D as v}from"../../chunks/Docstring-hf-doc-builder.js";import{C as ip}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Z}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as TT}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function tx(xr){let T,F;return T=new ip({props:{code:`completed = False
while not completed:
    _, completed = constraint.update(constraint.advance())`,highlighted:`completed = <span class="hljs-literal">False</span>
<span class="hljs-keyword">while</span> <span class="hljs-keyword">not</span> completed:
    _, completed = constraint.update(constraint.advance())`}}),{c(){f(T.$$.fragment)},l(y){g(T.$$.fragment,y)},m(y,x){h(T,y,x),F=!0},p:yT,i(y){F||(u(T.$$.fragment,y),F=!0)},o(y){_(T.$$.fragment,y),F=!1},d(y){b(T,y)}}}function ox(xr){let T,F,y,x,I;return x=new ip({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer, TextStreamer

tok = AutoTokenizer.from_pretrained("gpt2")
model = AutoModelForCausalLM.from_pretrained("gpt2")
inputs = tok(["An increasing sequence: one,"], return_tensors="pt")
streamer = TextStreamer(tok)

# Despite returning the usual output, the streamer will also print the generated text to stdout.
_ = model.generate(**inputs, streamer=streamer, max_new_tokens=20)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer, TextStreamer

<span class="hljs-meta">&gt;&gt;&gt; </span>tok = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tok([<span class="hljs-string">&quot;An increasing sequence: one,&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>streamer = TextStreamer(tok)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Despite returning the usual output, the streamer will also print the generated text to stdout.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>_ = model.generate(**inputs, streamer=streamer, max_new_tokens=<span class="hljs-number">20</span>)
An increasing sequence: one, two, three, four, five, six, seven, eight, nine, ten, eleven,`}}),{c(){T=o("p"),F=a("Examples:"),y=c(),f(x.$$.fragment)},l($){T=n($,"P",{});var S=s(T);F=i(S,"Examples:"),S.forEach(t),y=l($),g(x.$$.fragment,$)},m($,S){m($,T,S),r(T,F),m($,y,S),h(x,$,S),I=!0},p:yT,i($){I||(u(x.$$.fragment,$),I=!0)},o($){_(x.$$.fragment,$),I=!1},d($){$&&t(T),$&&t(y),b(x,$)}}}function nx(xr){let T,F,y,x,I;return x=new ip({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer, TextIteratorStreamer
from threading import Thread

tok = AutoTokenizer.from_pretrained("gpt2")
model = AutoModelForCausalLM.from_pretrained("gpt2")
inputs = tok(["An increasing sequence: one,"], return_tensors="pt")
streamer = TextIteratorStreamer(tok)

# Run the generation in a separate thread, so that we can fetch the generated text in a non-blocking way.
generation_kwargs = dict(inputs, streamer=streamer, max_new_tokens=20)
thread = Thread(target=model.generate, kwargs=generation_kwargs)
thread.start()
generated_text = ""
for new_text in streamer:
    generated_text += new_text
generated_text`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer, TextIteratorStreamer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> threading <span class="hljs-keyword">import</span> Thread

<span class="hljs-meta">&gt;&gt;&gt; </span>tok = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tok([<span class="hljs-string">&quot;An increasing sequence: one,&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>streamer = TextIteratorStreamer(tok)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Run the generation in a separate thread, so that we can fetch the generated text in a non-blocking way.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generation_kwargs = <span class="hljs-built_in">dict</span>(inputs, streamer=streamer, max_new_tokens=<span class="hljs-number">20</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>thread = Thread(target=model.generate, kwargs=generation_kwargs)
<span class="hljs-meta">&gt;&gt;&gt; </span>thread.start()
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = <span class="hljs-string">&quot;&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> new_text <span class="hljs-keyword">in</span> streamer:
<span class="hljs-meta">... </span>    generated_text += new_text
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text
<span class="hljs-string">&#x27;An increasing sequence: one, two, three, four, five, six, seven, eight, nine, ten, eleven,&#x27;</span>`}}),{c(){T=o("p"),F=a("Examples:"),y=c(),f(x.$$.fragment)},l($){T=n($,"P",{});var S=s(T);F=i(S,"Examples:"),S.forEach(t),y=l($),g(x.$$.fragment,$)},m($,S){m($,T,S),r(T,F),m($,y,S),h(x,$,S),I=!0},p:yT,i($){I||(u(x.$$.fragment,$),I=!0)},o($){_(x.$$.fragment,$),I=!1},d($){$&&t(T),$&&t(y),b(x,$)}}}function sx(xr){let T,F,y,x,I,$,S,Mc,Gf,cp,L,Hf,vs,Rf,Uf,$s,Kf,Yf,Ts,Xf,Jf,ys,Qf,Zf,ks,eg,rg,xs,tg,og,ws,ng,sg,Ls,ag,ig,lp,Es,cg,dp,er,wr,jc,yt,lg,Gc,dg,pp,K,pg,Ps,mg,fg,Fs,gg,hg,Ss,ug,_g,mp,Ds,bg,fp,kt,gp,Re,vg,Hc,$g,Tg,zs,yg,kg,hp,Y,qs,Rc,xg,wg,Lg,Os,Uc,Eg,Pg,Fg,Bs,Kc,Sg,Dg,zg,Is,Yc,qg,Og,up,E,Bg,Xc,Ig,Ag,Jc,Cg,Ng,Qc,Wg,Vg,Zc,Mg,jg,el,Gg,Hg,rl,Rg,Ug,_p,A,Kg,tl,Yg,Xg,ol,Jg,Qg,nl,Zg,eh,sl,rh,th,bp,C,oh,al,nh,sh,il,ah,ih,cl,ch,lh,ll,dh,ph,vp,xt,$p,Lr,mh,dl,fh,gh,Tp,N,hh,pl,uh,_h,ml,bh,vh,fl,$h,Th,gl,yh,kh,yp,As,xh,kp,rr,Er,hl,wt,wh,ul,Lh,xp,tr,Lt,Eh,_l,Ph,wp,or,Et,Fh,bl,Sh,Lp,ee,Pt,Dh,vl,zh,qh,Pr,Ft,Oh,$l,Bh,Ep,nr,Fr,Tl,St,Ih,yl,Ah,Pp,sr,Dt,Ch,kl,Nh,Fp,ar,zt,Wh,xl,Vh,Sp,re,qt,Mh,wl,jh,Gh,Sr,Ot,Hh,Ll,Rh,Dp,ir,Dr,El,Bt,Uh,Pl,Kh,zp,cr,It,Yh,Fl,Xh,qp,lr,At,Jh,Sl,Qh,Op,dr,zr,Dl,Ct,Zh,zl,eu,Bp,pr,Nt,ru,ql,tu,Ip,mr,Wt,ou,Ol,nu,Ap,fr,qr,Bl,Vt,su,Il,au,Cp,Or,iu,Cs,cu,lu,Np,te,Mt,du,Al,pu,mu,Br,jt,fu,Cl,gu,Wp,oe,Gt,hu,D,uu,Ns,_u,bu,Ws,vu,$u,Nl,Tu,yu,Wl,Vl,ku,xu,Vs,wu,Lu,Ms,Eu,Pu,Fu,js,Ht,Vp,ne,Rt,Su,Ml,Du,zu,Ir,Ut,qu,jl,Ou,Mp,se,Kt,Bu,Gs,Hs,Iu,Au,Cu,Rs,Yt,jp,ae,Xt,Nu,Us,Ks,Wu,Vu,Mu,Ys,Jt,Gp,ie,Qt,ju,Xs,Js,Gu,Hu,Ru,Qs,Zt,Hp,ce,eo,Uu,Zs,ea,Ku,Yu,Xu,ra,ro,Rp,le,to,Ju,ta,oa,Qu,Zu,e_,na,oo,Up,de,no,r_,sa,aa,t_,o_,n_,ia,so,Kp,pe,ao,s_,Ar,ca,a_,i_,io,c_,l_,d_,la,co,Yp,me,lo,p_,Cr,da,m_,f_,po,g_,h_,u_,pa,mo,Xp,fe,fo,__,ma,fa,b_,v_,$_,ga,go,Jp,ge,ho,T_,Nr,ha,y_,k_,uo,x_,w_,L_,ua,_o,Qp,he,bo,E_,Ue,_a,P_,F_,ba,S_,D_,vo,z_,q_,O_,va,$o,Zp,ue,To,B_,$a,Ta,I_,A_,C_,ya,yo,em,_e,ko,N_,Wr,ka,W_,V_,Gl,M_,j_,G_,xa,xo,rm,be,wo,H_,Ke,wa,R_,U_,Hl,K_,Y_,Rl,X_,J_,Q_,La,Lo,tm,ve,Eo,Z_,Ul,eb,rb,Vr,Po,tb,Kl,ob,om,$e,Fo,nb,j,sb,Ea,ab,ib,Yl,cb,lb,Xl,Jl,db,pb,Pa,mb,fb,gb,Fa,So,nm,Te,Do,hb,Ql,ub,_b,Mr,zo,bb,Zl,vb,sm,ye,qo,$b,Sa,Da,Tb,yb,kb,za,Oo,am,ke,Bo,xb,qa,Oa,wb,Lb,Eb,Ba,Io,im,xe,Ao,Pb,Ia,Aa,Fb,Sb,Db,Ca,Co,cm,we,No,zb,Na,Wa,qb,Ob,Bb,Va,Wo,lm,Le,Vo,Ib,Ma,ja,Ab,Cb,Nb,Ga,Mo,dm,Ee,jo,Wb,jr,Ha,Vb,Mb,Go,jb,Gb,Hb,Ra,Ho,pm,Pe,Ro,Rb,Ua,Ka,Ub,Kb,Yb,Ya,Uo,mm,Fe,Ko,Xb,Xa,Ja,Jb,Qb,Zb,Qa,Yo,fm,Se,Xo,ev,Gr,Za,rv,tv,ed,ov,nv,sv,ei,Jo,gm,De,Qo,av,rd,iv,cv,Hr,Zo,lv,td,dv,hm,ze,en,pv,z,mv,ri,fv,gv,ti,hv,uv,od,_v,bv,nd,sd,vv,$v,oi,Tv,yv,ni,kv,xv,wv,si,rn,um,qe,tn,Lv,ad,Ev,Pv,Rr,on,Fv,id,Sv,_m,Oe,nn,Dv,ai,ii,zv,qv,Ov,ci,sn,bm,Be,an,Bv,li,di,Iv,Av,Cv,pi,cn,vm,Ie,ln,Nv,mi,fi,Wv,Vv,Mv,gi,dn,$m,Ae,pn,jv,hi,ui,Gv,Hv,Rv,_i,mn,Tm,Ce,fn,Uv,Ur,bi,Kv,Yv,cd,Xv,Jv,Qv,vi,gn,ym,Ne,hn,Zv,$i,Ti,e1,r1,t1,yi,un,km,gr,Kr,ld,_n,o1,dd,n1,xm,Yr,s1,ki,a1,i1,wm,We,bn,c1,pd,l1,d1,xi,vn,Lm,hr,$n,p1,wi,Tn,Em,Ve,yn,m1,kn,f1,md,g1,h1,u1,Li,xn,Pm,Me,wn,_1,Ln,b1,fd,v1,$1,T1,Ei,En,Fm,ur,Xr,gd,Pn,y1,hd,k1,Sm,Jr,x1,Pi,w1,L1,Dm,k,Fn,E1,ud,P1,F1,_d,S1,D1,Qr,z1,bd,q1,O1,Zr,Sn,B1,vd,I1,A1,et,Dn,C1,$d,N1,W1,rt,zn,V1,Td,M1,j1,tt,qn,G1,On,H1,yd,R1,U1,K1,ot,Bn,Y1,kd,X1,J1,nt,In,Q1,xd,Z1,e2,Ye,An,r2,Cn,t2,wd,o2,n2,s2,Ld,a2,zm,_r,Nn,i2,Fi,Si,c2,l2,qm,br,Wn,d2,Vn,p2,Di,m2,f2,Om,G,Mn,g2,Ed,h2,u2,B,jn,_2,Pd,b2,v2,vr,$2,Fd,T2,y2,Sd,k2,x2,w2,Dd,zd,L2,E2,je,P2,qd,F2,S2,Od,D2,z2,Bd,q2,O2,B2,Id,I2,A2,st,Gn,C2,Ad,N2,Bm,$r,at,Cd,Hn,W2,Nd,V2,Im,H,Rn,M2,Tr,j2,zi,G2,H2,qi,R2,U2,K2,Oi,Un,Y2,Bi,Kn,Am,q,Yn,X2,Ii,Ai,J2,Q2,Z2,Xn,e$,Jn,r$,t$,o$,Ci,n$,Qn,s$,a$,Ni,Zn,i$,Wi,es,Cm,R,rs,c$,Vi,Mi,l$,d$,p$,ji,ts,m$,Gi,os,Nm,yr,it,Wd,ns,f$,Vd,g$,Wm,Ge,ss,h$,Md,u$,_$,Hi,b$,as,v$,Vm,He,is,$$,jd,T$,y$,Ri,k$,cs,x$,Mm,kr,ct,Gd,ls,w$,Hd,L$,jm,O,ds,E$,Rd,P$,F$,lt,S$,dt,ps,D$,Ud,z$,q$,pt,ms,O$,Kd,B$,I$,mt,fs,A$,Yd,C$,Gm,U,gs,N$,Xd,W$,V$,ft,M$,gt,hs,j$,Jd,G$,Hm;return $=new Z({}),yt=new Z({}),kt=new ip({props:{code:`from transformers import GPT2Tokenizer, GPT2LMHeadModel

tokenizer = GPT2Tokenizer.from_pretrained("gpt2")
model = GPT2LMHeadModel.from_pretrained("gpt2")

inputs = tokenizer("Hello, my dog is cute and ", return_tensors="pt")
generation_output = model.generate(**inputs, return_dict_in_generate=True, output_scores=True)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer, GPT2LMHeadModel

tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
model = GPT2LMHeadModel.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)

inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute and &quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
generation_output = model.generate(**inputs, return_dict_in_generate=<span class="hljs-literal">True</span>, output_scores=<span class="hljs-literal">True</span>)`}}),xt=new ip({props:{code:"generation_output[:2]",highlighted:'generation_output[:<span class="hljs-number">2</span>]'}}),wt=new Z({}),Lt=new v({props:{name:"class transformers.generation.GreedySearchDecoderOnlyOutput",anchor:"transformers.generation.GreedySearchDecoderOnlyOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.GreedySearchDecoderOnlyOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.GreedySearchDecoderOnlyOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Processed prediction scores of the language modeling head (scores for each vocabulary token before SoftMax)
at each generation step. Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for
each generated token), with each tensor of shape <code>(batch_size, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.GreedySearchDecoderOnlyOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"attentions"},{anchor:"transformers.generation.GreedySearchDecoderOnlyOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, generated_length, hidden_size)</code>.`,name:"hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L83"}}),Et=new v({props:{name:"class transformers.generation.GreedySearchEncoderDecoderOutput",anchor:"transformers.generation.GreedySearchEncoderDecoderOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Processed prediction scores of the language modeling head (scores for each vocabulary token before SoftMax)
at each generation step. Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for
each generated token), with each tensor of shape <code>(batch_size, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer of the decoder) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.`,name:"encoder_attentions"},{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.`,name:"encoder_hidden_states"},{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"decoder_attentions"},{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"cross_attentions"},{anchor:"transformers.generation.GreedySearchEncoderDecoderOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, generated_length, hidden_size)</code>.`,name:"decoder_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L179"}}),Pt=new v({props:{name:"class transformers.generation.FlaxGreedySearchOutput",anchor:"transformers.generation.FlaxGreedySearchOutput",parameters:[{name:"sequences",val:": ndarray = None"}],parametersDescription:[{anchor:"transformers.generation.FlaxGreedySearchOutput.sequences",description:`<strong>sequences</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, max_length)</code>) &#x2014;
The generated sequences.`,name:"sequences"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_utils.py#L55"}}),Ft=new v({props:{name:"replace",anchor:"transformers.generation.FlaxGreedySearchOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/flax/struct.py#L108"}}),St=new Z({}),Dt=new v({props:{name:"class transformers.generation.SampleDecoderOnlyOutput",anchor:"transformers.generation.SampleDecoderOnlyOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.SampleDecoderOnlyOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size*num_return_sequences, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.SampleDecoderOnlyOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Processed prediction scores of the language modeling head (scores for each vocabulary token before SoftMax)
at each generation step. Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for
each generated token), with each tensor of shape <code>(batch_size*num_return_sequences, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.SampleDecoderOnlyOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(num_return_sequences*batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"attentions"},{anchor:"transformers.generation.SampleDecoderOnlyOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(num_return_sequences*batch_size, generated_length, hidden_size)</code>.`,name:"hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L221"}}),zt=new v({props:{name:"class transformers.generation.SampleEncoderDecoderOutput",anchor:"transformers.generation.SampleEncoderDecoderOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.SampleEncoderDecoderOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size*num_return_sequences, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.SampleEncoderDecoderOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Processed prediction scores of the language modeling head (scores for each vocabulary token before SoftMax)
at each generation step. Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for
each generated token), with each tensor of shape <code>(batch_size*num_return_sequences, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.SampleEncoderDecoderOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer of the decoder) of shape
<code>(batch_size*num_return_sequences, num_heads, sequence_length, sequence_length)</code>.`,name:"encoder_attentions"},{anchor:"transformers.generation.SampleEncoderDecoderOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size*num_return_sequences, sequence_length, hidden_size)</code>.`,name:"encoder_hidden_states"},{anchor:"transformers.generation.SampleEncoderDecoderOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_return_sequences, num_heads, generated_length, sequence_length)</code>.`,name:"decoder_attentions"},{anchor:"transformers.generation.SampleEncoderDecoderOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"cross_attentions"},{anchor:"transformers.generation.SampleEncoderDecoderOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_return_sequences, generated_length, hidden_size)</code>.`,name:"decoder_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L250"}}),qt=new v({props:{name:"class transformers.generation.FlaxSampleOutput",anchor:"transformers.generation.FlaxSampleOutput",parameters:[{name:"sequences",val:": ndarray = None"}],parametersDescription:[{anchor:"transformers.generation.FlaxSampleOutput.sequences",description:`<strong>sequences</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, max_length)</code>) &#x2014;
The generated sequences.`,name:"sequences"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_utils.py#L69"}}),Ot=new v({props:{name:"replace",anchor:"transformers.generation.FlaxSampleOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/flax/struct.py#L108"}}),Bt=new Z({}),It=new v({props:{name:"class transformers.generation.BeamSearchDecoderOnlyOutput",anchor:"transformers.generation.BeamSearchDecoderOnlyOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"sequences_scores",val:": typing.Optional[torch.FloatTensor] = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"beam_indices",val:": typing.Optional[torch.LongTensor] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.BeamSearchDecoderOnlyOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size*num_return_sequences, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.BeamSearchDecoderOnlyOutput.sequences_scores",description:`<strong>sequences_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size*num_return_sequences)</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Final beam scores of the generated <code>sequences</code>.`,name:"sequences_scores"},{anchor:"transformers.generation.BeamSearchDecoderOnlyOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam transition scores for each vocabulary token at each generation step. Beam transition scores consisting
of log probabilities of tokens conditioned on log softmax of previously generated tokens in this beam.
Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for each generated token),
with each tensor of shape <code>(batch_size*num_beams*num_return_sequences, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.BeamSearchDecoderOnlyOutput.beam_indices",description:`<strong>beam_indices</strong> (<code>torch.LongTensor</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam indices of generated token id at each generation step. <code>torch.LongTensor</code> of shape
<code>(batch_size*num_return_sequences, sequence_length)</code>.`,name:"beam_indices"},{anchor:"transformers.generation.BeamSearchDecoderOnlyOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams, num_heads, generated_length, sequence_length)</code>.`,name:"attentions"},{anchor:"transformers.generation.BeamSearchDecoderOnlyOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams*num_return_sequences, generated_length, hidden_size)</code>.`,name:"hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L293"}}),At=new v({props:{name:"class transformers.generation.BeamSearchEncoderDecoderOutput",anchor:"transformers.generation.BeamSearchEncoderDecoderOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"sequences_scores",val:": typing.Optional[torch.FloatTensor] = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"beam_indices",val:": typing.Optional[torch.LongTensor] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size*num_return_sequences, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.sequences_scores",description:`<strong>sequences_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size*num_return_sequences)</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Final beam scores of the generated <code>sequences</code>.`,name:"sequences_scores"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam transition scores for each vocabulary token at each generation step. Beam transition scores consisting
of log probabilities of tokens conditioned on log softmax of previously generated tokens in this beam.
Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for each generated token),
with each tensor of shape <code>(batch_size*num_beams, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.beam_indices",description:`<strong>beam_indices</strong> (<code>torch.LongTensor</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam indices of generated token id at each generation step. <code>torch.LongTensor</code> of shape
<code>(batch_size*num_return_sequences, sequence_length)</code>.`,name:"beam_indices"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer of the decoder) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.`,name:"encoder_attentions"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size*num_beams*num_return_sequences, sequence_length, hidden_size)</code>.`,name:"encoder_hidden_states"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams*num_return_sequences, num_heads, generated_length, sequence_length)</code>.`,name:"decoder_attentions"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"cross_attentions"},{anchor:"transformers.generation.BeamSearchEncoderDecoderOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams*num_return_sequences, generated_length, hidden_size)</code>.`,name:"decoder_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L328"}}),Ct=new Z({}),Nt=new v({props:{name:"class transformers.generation.BeamSampleDecoderOnlyOutput",anchor:"transformers.generation.BeamSampleDecoderOnlyOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"sequences_scores",val:": typing.Optional[torch.FloatTensor] = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"beam_indices",val:": typing.Optional[torch.LongTensor] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.BeamSampleDecoderOnlyOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size*num_return_sequences, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.BeamSampleDecoderOnlyOutput.sequences_scores",description:`<strong>sequences_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_return_sequence)</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Final beam scores of the generated <code>sequences</code>.`,name:"sequences_scores"},{anchor:"transformers.generation.BeamSampleDecoderOnlyOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam transition scores for each vocabulary token at each generation step. Beam transition scores consisting
of log probabilities of tokens conditioned on log softmax of previously generated tokens in this beam.
Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for each generated token),
with each tensor of shape <code>(batch_size*num_beams*num_return_sequences, config.vocab_size)</code>.`,name:"scores"},{anchor:"transformers.generation.BeamSampleDecoderOnlyOutput.beam_indices",description:`<strong>beam_indices</strong> (<code>torch.LongTensor</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam indices of generated token id at each generation step. <code>torch.LongTensor</code> of shape
<code>(batch_size*num_return_sequences, sequence_length)</code>.`,name:"beam_indices"},{anchor:"transformers.generation.BeamSampleDecoderOnlyOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams, num_heads, generated_length, sequence_length)</code>.`,name:"attentions"},{anchor:"transformers.generation.BeamSampleDecoderOnlyOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams, generated_length, hidden_size)</code>.`,name:"hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L378"}}),Wt=new v({props:{name:"class transformers.generation.BeamSampleEncoderDecoderOutput",anchor:"transformers.generation.BeamSampleEncoderDecoderOutput",parameters:[{name:"sequences",val:": LongTensor = None"},{name:"sequences_scores",val:": typing.Optional[torch.FloatTensor] = None"},{name:"scores",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"beam_indices",val:": typing.Optional[torch.LongTensor] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"}],parametersDescription:[{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.sequences",description:`<strong>sequences</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size*num_beams, sequence_length)</code>) &#x2014;
The generated sequences. The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter
if all batches finished early due to the <code>eos_token_id</code>.`,name:"sequences"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.sequences_scores",description:`<strong>sequences_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_return_sequence)</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Final beam scores of the generated <code>sequences</code>.`,name:"sequences_scores"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.scores",description:`<strong>scores</strong> (<code>tuple(torch.FloatTensor)</code> <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam transition scores for each vocabulary token at each generation step. Beam transition scores consisting
of log probabilities of tokens conditioned on log softmax of previously generated tokens in this beam.
Tuple of <code>torch.FloatTensor</code> with up to <code>max_new_tokens</code> elements (one element for each generated token),
with each tensor of shape <code>(batch_size*num_beams, config.vocab_size)</code>).`,name:"scores"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.beam_indices",description:`<strong>beam_indices</strong> (<code>torch.LongTensor</code>, <em>optional</em>, returned when <code>output_scores=True</code> is passed or when <code>config.output_scores=True</code>) &#x2014;
Beam indices of generated token id at each generation step. <code>torch.LongTensor</code> of shape
<code>(batch_size*num_return_sequences, sequence_length)</code>.`,name:"beam_indices"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer of the decoder) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.`,name:"encoder_attentions"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size*num_beams, sequence_length, hidden_size)</code>.`,name:"encoder_hidden_states"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams, num_heads, generated_length, sequence_length)</code>.`,name:"decoder_attentions"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or <code>config.output_attentions=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size, num_heads, generated_length, sequence_length)</code>.`,name:"cross_attentions"},{anchor:"transformers.generation.BeamSampleEncoderDecoderOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple (one element for each generated token) of tuples (one element for each layer of the decoder) of
<code>torch.FloatTensor</code> of shape <code>(batch_size*num_beams, generated_length, hidden_size)</code>.`,name:"decoder_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L413"}}),Vt=new Z({}),Mt=new v({props:{name:"class transformers.LogitsProcessor",anchor:"transformers.LogitsProcessor",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L51"}}),jt=new v({props:{name:"__call__",anchor:"transformers.LogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],parametersDescription:[{anchor:"transformers.LogitsProcessor.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LogitsProcessor.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L54",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),Gt=new v({props:{name:"class transformers.LogitsProcessorList",anchor:"transformers.LogitsProcessorList",parameters:[{name:"iterable",val:" = ()"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L73"}}),Ht=new v({props:{name:"__call__",anchor:"transformers.LogitsProcessorList.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.LogitsProcessorList.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LogitsProcessorList.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L80",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),Rt=new v({props:{name:"class transformers.LogitsWarper",anchor:"transformers.LogitsWarper",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L62"}}),Ut=new v({props:{name:"__call__",anchor:"transformers.LogitsWarper.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],parametersDescription:[{anchor:"transformers.LogitsWarper.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LogitsWarper.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L65",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),Kt=new v({props:{name:"class transformers.MinLengthLogitsProcessor",anchor:"transformers.MinLengthLogitsProcessor",parameters:[{name:"min_length",val:": int"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int]]"}],parametersDescription:[{anchor:"transformers.MinLengthLogitsProcessor.min_length",description:`<strong>min_length</strong> (<code>int</code>) &#x2014;
The minimum length below which the score of <code>eos_token_id</code> is set to <code>-float(&quot;Inf&quot;)</code>.`,name:"min_length"},{anchor:"transformers.MinLengthLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>) &#x2014;
The id of the <em>end-of-sequence</em> token. Optionally, use a list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L96"}}),Yt=new v({props:{name:"__call__",anchor:"transformers.MinLengthLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L119"}}),Xt=new v({props:{name:"class transformers.MinNewTokensLengthLogitsProcessor",anchor:"transformers.MinNewTokensLengthLogitsProcessor",parameters:[{name:"prompt_length_to_skip",val:": int"},{name:"min_new_tokens",val:": int"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int]]"}],parametersDescription:[{anchor:"transformers.MinNewTokensLengthLogitsProcessor.prompt_length_to_skip",description:`<strong>prompt_length_to_skip</strong> (<code>int</code>) &#x2014;
The input tokens length.`,name:"prompt_length_to_skip"},{anchor:"transformers.MinNewTokensLengthLogitsProcessor.min_new_tokens",description:`<strong>min_new_tokens</strong> (<code>int</code>) &#x2014;
The minimum <em>new</em> tokens length below which the score of <code>eos_token_id</code> is set to <code>-float(&quot;Inf&quot;)</code>.`,name:"min_new_tokens"},{anchor:"transformers.MinNewTokensLengthLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>) &#x2014;
The id of the <em>end-of-sequence</em> token. Optionally, use a list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L127"}}),Jt=new v({props:{name:"__call__",anchor:"transformers.MinNewTokensLengthLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L157"}}),Qt=new v({props:{name:"class transformers.TemperatureLogitsWarper",anchor:"transformers.TemperatureLogitsWarper",parameters:[{name:"temperature",val:": float"}],parametersDescription:[{anchor:"transformers.TemperatureLogitsWarper.temperature",description:`<strong>temperature</strong> (<code>float</code>) &#x2014;
The value used to module the logits distribution.`,name:"temperature"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L166"}}),Zt=new v({props:{name:"__call__",anchor:"transformers.TemperatureLogitsWarper.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L181"}}),eo=new v({props:{name:"class transformers.RepetitionPenaltyLogitsProcessor",anchor:"transformers.RepetitionPenaltyLogitsProcessor",parameters:[{name:"penalty",val:": float"}],parametersDescription:[{anchor:"transformers.RepetitionPenaltyLogitsProcessor.repetition_penalty",description:`<strong>repetition_penalty</strong> (<code>float</code>) &#x2014;
The parameter for repetition penalty. 1.0 means no penalty. See <a href="https://arxiv.org/pdf/1909.05858.pdf" rel="nofollow">this
paper</a> for more details.`,name:"repetition_penalty"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L186"}}),ro=new v({props:{name:"__call__",anchor:"transformers.RepetitionPenaltyLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L202"}}),to=new v({props:{name:"class transformers.TopPLogitsWarper",anchor:"transformers.TopPLogitsWarper",parameters:[{name:"top_p",val:": float"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.TopPLogitsWarper.top_p",description:`<strong>top_p</strong> (<code>float</code>) &#x2014;
If set to &lt; 1, only the smallest set of most probable tokens with probabilities that add up to <code>top_p</code> or
higher are kept for generation.`,name:"top_p"},{anchor:"transformers.TopPLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.TopPLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L240"}}),oo=new v({props:{name:"__call__",anchor:"transformers.TopPLogitsWarper.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L263"}}),no=new v({props:{name:"class transformers.TopKLogitsWarper",anchor:"transformers.TopKLogitsWarper",parameters:[{name:"top_k",val:": int"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.TopKLogitsWarper.top_k",description:`<strong>top_k</strong> (<code>int</code>) &#x2014;
The number of highest probability vocabulary tokens to keep for top-k-filtering.`,name:"top_k"},{anchor:"transformers.TopKLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.TopKLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L279"}}),so=new v({props:{name:"__call__",anchor:"transformers.TopKLogitsWarper.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L299"}}),ao=new v({props:{name:"class transformers.TypicalLogitsWarper",anchor:"transformers.TypicalLogitsWarper",parameters:[{name:"mass",val:": float = 0.9"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.TypicalLogitsWarper.mass",description:`<strong>mass</strong> (<code>float</code>) &#x2014;
Value of typical_p between 0 and 1 inclusive, defaults to 0.9.`,name:"mass"},{anchor:"transformers.TypicalLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.TypicalLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L307"}}),co=new v({props:{name:"__call__",anchor:"transformers.TypicalLogitsWarper.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L330"}}),lo=new v({props:{name:"class transformers.NoRepeatNGramLogitsProcessor",anchor:"transformers.NoRepeatNGramLogitsProcessor",parameters:[{name:"ngram_size",val:": int"}],parametersDescription:[{anchor:"transformers.NoRepeatNGramLogitsProcessor.ngram_size",description:`<strong>ngram_size</strong> (<code>int</code>) &#x2014;
All ngrams of size <code>ngram_size</code> can only occur once.`,name:"ngram_size"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L474"}}),mo=new v({props:{name:"__call__",anchor:"transformers.NoRepeatNGramLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L489"}}),fo=new v({props:{name:"class transformers.NoBadWordsLogitsProcessor",anchor:"transformers.NoBadWordsLogitsProcessor",parameters:[{name:"bad_words_ids",val:": typing.List[typing.List[int]]"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int]]"}],parametersDescription:[{anchor:"transformers.NoBadWordsLogitsProcessor.bad_words_ids",description:`<strong>bad_words_ids</strong> (<code>List[List[int]]</code>) &#x2014;
List of list of token ids that are not allowed to be generated. In order to get the token ids of the words
that should not appear in the generated text, use <code>tokenizer(bad_words, add_prefix_space=True, add_special_tokens=False).input_ids</code>.`,name:"bad_words_ids"},{anchor:"transformers.NoBadWordsLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>) &#x2014;
The id of the <em>end-of-sequence</em> token. Optionally, use a list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L541"}}),go=new v({props:{name:"__call__",anchor:"transformers.NoBadWordsLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L589"}}),ho=new v({props:{name:"class transformers.PrefixConstrainedLogitsProcessor",anchor:"transformers.PrefixConstrainedLogitsProcessor",parameters:[{name:"prefix_allowed_tokens_fn",val:": typing.Callable[[int, torch.Tensor], typing.List[int]]"},{name:"num_beams",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L675"}}),_o=new v({props:{name:"__call__",anchor:"transformers.PrefixConstrainedLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L692"}}),bo=new v({props:{name:"class transformers.HammingDiversityLogitsProcessor",anchor:"transformers.HammingDiversityLogitsProcessor",parameters:[{name:"diversity_penalty",val:": float"},{name:"num_beams",val:": int"},{name:"num_beam_groups",val:": int"}],parametersDescription:[{anchor:"transformers.HammingDiversityLogitsProcessor.diversity_penalty",description:`<strong>diversity_penalty</strong> (<code>float</code>) &#x2014;
This value is subtracted from a beam&#x2019;s score if it generates a token same as any beam from other group at a
particular time. Note that <code>diversity_penalty</code> is only effective if <code>group beam search</code> is enabled.`,name:"diversity_penalty"},{anchor:"transformers.HammingDiversityLogitsProcessor.num_beams",description:`<strong>num_beams</strong> (<code>int</code>) &#x2014;
Number of beams used for group beam search. See <a href="https://arxiv.org/pdf/1610.02424.pdf" rel="nofollow">this paper</a> for more
details.`,name:"num_beams"},{anchor:"transformers.HammingDiversityLogitsProcessor.num_beam_groups",description:`<strong>num_beam_groups</strong> (<code>int</code>) &#x2014;
Number of groups to divide <code>num_beams</code> into in order to ensure diversity among different groups of beams.
See <a href="https://arxiv.org/pdf/1610.02424.pdf" rel="nofollow">this paper</a> for more details.`,name:"num_beam_groups"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L701"}}),$o=new v({props:{name:"__call__",anchor:"transformers.HammingDiversityLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"},{name:"current_tokens",val:": LongTensor"},{name:"beam_group_idx",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L732"}}),To=new v({props:{name:"class transformers.ForcedBOSTokenLogitsProcessor",anchor:"transformers.ForcedBOSTokenLogitsProcessor",parameters:[{name:"bos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.ForcedBOSTokenLogitsProcessor.bos_token_id",description:`<strong>bos_token_id</strong> (<code>int</code>) &#x2014;
The id of the token to force as the first generated token.`,name:"bos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L761"}}),yo=new v({props:{name:"__call__",anchor:"transformers.ForcedBOSTokenLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L773"}}),ko=new v({props:{name:"class transformers.ForcedEOSTokenLogitsProcessor",anchor:"transformers.ForcedEOSTokenLogitsProcessor",parameters:[{name:"max_length",val:": int"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int]]"}],parametersDescription:[{anchor:"transformers.ForcedEOSTokenLogitsProcessor.max_length",description:`<strong>max_length</strong> (<code>int</code>) &#x2014;
The maximum length of the sequence to be generated.`,name:"max_length"},{anchor:"transformers.ForcedEOSTokenLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>) &#x2014;
The id of the token to force as the last generated token when <code>max_length</code> is reached. Optionally, use a
list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L782"}}),xo=new v({props:{name:"__call__",anchor:"transformers.ForcedEOSTokenLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L800"}}),wo=new v({props:{name:"class transformers.InfNanRemoveLogitsProcessor",anchor:"transformers.InfNanRemoveLogitsProcessor",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L810"}}),Lo=new v({props:{name:"__call__",anchor:"transformers.InfNanRemoveLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/logits_process.py#L816"}}),Eo=new v({props:{name:"class transformers.TFLogitsProcessor",anchor:"transformers.TFLogitsProcessor",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L53"}}),Po=new v({props:{name:"__call__",anchor:"transformers.TFLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],parametersDescription:[{anchor:"transformers.TFLogitsProcessor.__call__.input_ids",description:`<strong>input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFLogitsProcessor.__call__.scores",description:`<strong>scores</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search.`,name:"scores"},{anchor:"transformers.TFLogitsProcessor.__call__.cur_len",description:`<strong>cur_len</strong> (<code>int</code>) &#x2014;
The current length of valid input sequence tokens. In the TF implementation, the input_ids&#x2019; sequence length
is the maximum length generate can produce, and we need to know which of its tokens are valid.
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"cur_len"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L56",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>tf.Tensor</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),Fo=new v({props:{name:"class transformers.TFLogitsProcessorList",anchor:"transformers.TFLogitsProcessorList",parameters:[{name:"iterable",val:" = ()"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L75"}}),So=new v({props:{name:"__call__",anchor:"transformers.TFLogitsProcessorList.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFLogitsProcessorList.__call__.input_ids",description:`<strong>input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFLogitsProcessorList.__call__.scores",description:`<strong>scores</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search.`,name:"scores"},{anchor:"transformers.TFLogitsProcessorList.__call__.cur_len",description:`<strong>cur_len</strong> (<code>int</code>) &#x2014;
The current length of valid input sequence tokens. In the TF implementation, the input_ids&#x2019; sequence length
is the maximum length generate can produce, and we need to know which of its tokens are valid.
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"cur_len"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L82",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>tf.Tensor</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),Do=new v({props:{name:"class transformers.TFLogitsWarper",anchor:"transformers.TFLogitsWarper",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L64"}}),zo=new v({props:{name:"__call__",anchor:"transformers.TFLogitsWarper.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],parametersDescription:[{anchor:"transformers.TFLogitsWarper.__call__.input_ids",description:`<strong>input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFLogitsWarper.__call__.scores",description:`<strong>scores</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search.`,name:"scores"},{anchor:"transformers.TFLogitsWarper.__call__.cur_len",description:`<strong>cur_len</strong> (<code>int</code>) &#x2014;
The current length of valid input sequence tokens. In the TF implementation, the input_ids&#x2019; sequence length
is the maximum length generate can produce, and we need to know which of its tokens are valid.
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"cur_len"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L67",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>tf.Tensor</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),qo=new v({props:{name:"class transformers.TFTemperatureLogitsWarper",anchor:"transformers.TFTemperatureLogitsWarper",parameters:[{name:"temperature",val:": float"}],parametersDescription:[{anchor:"transformers.TFTemperatureLogitsWarper.temperature",description:`<strong>temperature</strong> (<code>float</code>) &#x2014;
The value used to module the logits distribution.`,name:"temperature"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L98"}}),Oo=new v({props:{name:"__call__",anchor:"transformers.TFTemperatureLogitsWarper.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L113"}}),Bo=new v({props:{name:"class transformers.TFTopPLogitsWarper",anchor:"transformers.TFTopPLogitsWarper",parameters:[{name:"top_p",val:": float"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.TFTopPLogitsWarper.top_p",description:`<strong>top_p</strong> (<code>float</code>) &#x2014;
If set to &lt; 1, only the smallest set of most probable tokens with probabilities that add up to <code>top_p</code> or
higher are kept for generation.`,name:"top_p"},{anchor:"transformers.TFTopPLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.TFTopPLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L146"}}),Io=new v({props:{name:"__call__",anchor:"transformers.TFTopPLogitsWarper.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L168"}}),Ao=new v({props:{name:"class transformers.TFTopKLogitsWarper",anchor:"transformers.TFTopKLogitsWarper",parameters:[{name:"top_k",val:": int"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.TFTopKLogitsWarper.top_k",description:`<strong>top_k</strong> (<code>int</code>) &#x2014;
The number of highest probability vocabulary tokens to keep for top-k-filtering.`,name:"top_k"},{anchor:"transformers.TFTopKLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.TFTopKLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L118"}}),Co=new v({props:{name:"__call__",anchor:"transformers.TFTopKLogitsWarper.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L138"}}),No=new v({props:{name:"class transformers.TFMinLengthLogitsProcessor",anchor:"transformers.TFMinLengthLogitsProcessor",parameters:[{name:"min_length",val:": int"},{name:"eos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.TFMinLengthLogitsProcessor.min_length",description:`<strong>min_length</strong> (<code>int</code>) &#x2014;
The minimum length below which the score of <code>eos_token_id</code> is set to <code>-float(&quot;Inf&quot;)</code>.`,name:"min_length"},{anchor:"transformers.TFMinLengthLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>) &#x2014;
The id of the <em>end-of-sequence</em> token.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L200"}}),Wo=new v({props:{name:"__call__",anchor:"transformers.TFMinLengthLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L226"}}),Vo=new v({props:{name:"class transformers.TFNoBadWordsLogitsProcessor",anchor:"transformers.TFNoBadWordsLogitsProcessor",parameters:[{name:"bad_words_ids",val:": typing.List[typing.List[int]]"},{name:"eos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.TFNoBadWordsLogitsProcessor.bad_words_ids",description:`<strong>bad_words_ids</strong> (<code>List[List[int]]</code>) &#x2014;
List of list of token ids that are not allowed to be generated. In order to get the tokens of the words
that should not appear in the generated text, use <code>tokenizer(bad_word, add_prefix_space=True).input_ids</code>.`,name:"bad_words_ids"},{anchor:"transformers.TFNoBadWordsLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>) &#x2014;
The id of the <em>end-of-sequence</em> token.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L286"}}),Mo=new v({props:{name:"__call__",anchor:"transformers.TFNoBadWordsLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L362"}}),jo=new v({props:{name:"class transformers.TFNoRepeatNGramLogitsProcessor",anchor:"transformers.TFNoRepeatNGramLogitsProcessor",parameters:[{name:"ngram_size",val:": int"}],parametersDescription:[{anchor:"transformers.TFNoRepeatNGramLogitsProcessor.ngram_size",description:`<strong>ngram_size</strong> (<code>int</code>) &#x2014;
All ngrams of size <code>ngram_size</code> can only occur once.`,name:"ngram_size"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L383"}}),Ho=new v({props:{name:"__call__",anchor:"transformers.TFNoRepeatNGramLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L422"}}),Ro=new v({props:{name:"class transformers.TFRepetitionPenaltyLogitsProcessor",anchor:"transformers.TFRepetitionPenaltyLogitsProcessor",parameters:[{name:"penalty",val:": float"}],parametersDescription:[{anchor:"transformers.TFRepetitionPenaltyLogitsProcessor.repetition_penalty",description:`<strong>repetition_penalty</strong> (<code>float</code>) &#x2014;
The parameter for repetition penalty. 1.0 means no penalty. See <a href="https://arxiv.org/pdf/1909.05858.pdf" rel="nofollow">this
paper</a> for more details.`,name:"repetition_penalty"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L236"}}),Uo=new v({props:{name:"__call__",anchor:"transformers.TFRepetitionPenaltyLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L278"}}),Ko=new v({props:{name:"class transformers.TFForcedBOSTokenLogitsProcessor",anchor:"transformers.TFForcedBOSTokenLogitsProcessor",parameters:[{name:"bos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.TFForcedBOSTokenLogitsProcessor.bos_token_id",description:`<strong>bos_token_id</strong> (<code>int</code>) &#x2014;
The id of the token to force as the first generated token.`,name:"bos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L443"}}),Yo=new v({props:{name:"__call__",anchor:"transformers.TFForcedBOSTokenLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L457"}}),Xo=new v({props:{name:"class transformers.TFForcedEOSTokenLogitsProcessor",anchor:"transformers.TFForcedEOSTokenLogitsProcessor",parameters:[{name:"max_length",val:": int"},{name:"eos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.TFForcedEOSTokenLogitsProcessor.max_length",description:`<strong>max_length</strong> (<code>int</code>) &#x2014;
The maximum length of the sequence to be generated.`,name:"max_length"},{anchor:"transformers.TFForcedEOSTokenLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>) &#x2014;
The id of the token to force as the last generated token when <code>max_length</code> is reached.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L473"}}),Jo=new v({props:{name:"__call__",anchor:"transformers.TFForcedEOSTokenLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": Tensor"},{name:"scores",val:": Tensor"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_logits_process.py#L490"}}),Qo=new v({props:{name:"class transformers.FlaxLogitsProcessor",anchor:"transformers.FlaxLogitsProcessor",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L50"}}),Zo=new v({props:{name:"__call__",anchor:"transformers.FlaxLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"}],parametersDescription:[{anchor:"transformers.FlaxLogitsProcessor.__call__.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxLogitsProcessor.__call__.scores",description:`<strong>scores</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L53",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>jnp.ndarray</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),en=new v({props:{name:"class transformers.FlaxLogitsProcessorList",anchor:"transformers.FlaxLogitsProcessorList",parameters:[{name:"iterable",val:" = ()"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L72"}}),rn=new v({props:{name:"__call__",anchor:"transformers.FlaxLogitsProcessorList.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxLogitsProcessorList.__call__.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxLogitsProcessorList.__call__.scores",description:`<strong>scores</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L79",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>jnp.ndarray</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),tn=new v({props:{name:"class transformers.FlaxLogitsWarper",anchor:"transformers.FlaxLogitsWarper",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L61"}}),on=new v({props:{name:"__call__",anchor:"transformers.FlaxLogitsWarper.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"}],parametersDescription:[{anchor:"transformers.FlaxLogitsWarper.__call__.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxLogitsWarper.__call__.scores",description:`<strong>scores</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be logits for each vocabulary when not using beam
search or log softmax for each vocabulary token when using beam search
kwargs &#x2014;
Additional logits processor specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L64",returnDescription:`
<p>The processed prediction scores.</p>
`,returnType:`
<p><code>jnp.ndarray</code> of shape <code>(batch_size, config.vocab_size)</code></p>
`}}),nn=new v({props:{name:"class transformers.FlaxTemperatureLogitsWarper",anchor:"transformers.FlaxTemperatureLogitsWarper",parameters:[{name:"temperature",val:": float"}],parametersDescription:[{anchor:"transformers.FlaxTemperatureLogitsWarper.temperature",description:`<strong>temperature</strong> (<code>float</code>) &#x2014;
The value used to module the logits distribution.`,name:"temperature"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L95"}}),sn=new v({props:{name:"__call__",anchor:"transformers.FlaxTemperatureLogitsWarper.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L110"}}),an=new v({props:{name:"class transformers.FlaxTopPLogitsWarper",anchor:"transformers.FlaxTopPLogitsWarper",parameters:[{name:"top_p",val:": float"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.FlaxTopPLogitsWarper.top_p",description:`<strong>top_p</strong> (<code>float</code>) &#x2014;
If set to &lt; 1, only the smallest set of most probable tokens with probabilities that add up to <code>top_p</code> or
higher are kept for generation.`,name:"top_p"},{anchor:"transformers.FlaxTopPLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.FlaxTopPLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L115"}}),cn=new v({props:{name:"__call__",anchor:"transformers.FlaxTopPLogitsWarper.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L137"}}),ln=new v({props:{name:"class transformers.FlaxTopKLogitsWarper",anchor:"transformers.FlaxTopKLogitsWarper",parameters:[{name:"top_k",val:": int"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.FlaxTopKLogitsWarper.top_k",description:`<strong>top_k</strong> (<code>int</code>) &#x2014;
The number of highest probability vocabulary tokens to keep for top-k-filtering.`,name:"top_k"},{anchor:"transformers.FlaxTopKLogitsWarper.filter_value",description:`<strong>filter_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>-float(&quot;Inf&quot;)</code>) &#x2014;
All filtered values will be set to this float value.`,name:"filter_value"},{anchor:"transformers.FlaxTopKLogitsWarper.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimum number of tokens that cannot be filtered.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L157"}}),dn=new v({props:{name:"__call__",anchor:"transformers.FlaxTopKLogitsWarper.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L177"}}),pn=new v({props:{name:"class transformers.FlaxForcedBOSTokenLogitsProcessor",anchor:"transformers.FlaxForcedBOSTokenLogitsProcessor",parameters:[{name:"bos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.FlaxForcedBOSTokenLogitsProcessor.bos_token_id",description:`<strong>bos_token_id</strong> (<code>int</code>) &#x2014;
The id of the token to force as the first generated token.`,name:"bos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L192"}}),mn=new v({props:{name:"__call__",anchor:"transformers.FlaxForcedBOSTokenLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L204"}}),fn=new v({props:{name:"class transformers.FlaxForcedEOSTokenLogitsProcessor",anchor:"transformers.FlaxForcedEOSTokenLogitsProcessor",parameters:[{name:"max_length",val:": int"},{name:"eos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.FlaxForcedEOSTokenLogitsProcessor.max_length",description:`<strong>max_length</strong> (<code>int</code>) &#x2014;
The maximum length of the sequence to be generated.`,name:"max_length"},{anchor:"transformers.FlaxForcedEOSTokenLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>) &#x2014;
The id of the token to force as the last generated token when <code>max_length</code> is reached.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L214"}}),gn=new v({props:{name:"__call__",anchor:"transformers.FlaxForcedEOSTokenLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L229"}}),hn=new v({props:{name:"class transformers.FlaxMinLengthLogitsProcessor",anchor:"transformers.FlaxMinLengthLogitsProcessor",parameters:[{name:"min_length",val:": int"},{name:"eos_token_id",val:": int"}],parametersDescription:[{anchor:"transformers.FlaxMinLengthLogitsProcessor.min_length",description:`<strong>min_length</strong> (<code>int</code>) &#x2014;
The minimum length below which the score of <code>eos_token_id</code> is set to <code>-float(&quot;Inf&quot;)</code>.`,name:"min_length"},{anchor:"transformers.FlaxMinLengthLogitsProcessor.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>) &#x2014;
The id of the <em>end-of-sequence</em> token.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L239"}}),un=new v({props:{name:"__call__",anchor:"transformers.FlaxMinLengthLogitsProcessor.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"scores",val:": ndarray"},{name:"cur_len",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/flax_logits_process.py#L260"}}),_n=new Z({}),bn=new v({props:{name:"class transformers.StoppingCriteria",anchor:"transformers.StoppingCriteria",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L33"}}),vn=new v({props:{name:"__call__",anchor:"transformers.StoppingCriteria.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.StoppingCriteria.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.StoppingCriteria.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be scores for each vocabulary token before SoftMax
or scores for each vocabulary token after SoftMax.
kwargs &#x2014;
Additional stopping criteria specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L36",returnDescription:`
<p><code>bool</code>. <code>False</code> indicates we should continue, <code>True</code> indicates we should stop.</p>
`}}),$n=new v({props:{name:"class transformers.StoppingCriteriaList",anchor:"transformers.StoppingCriteriaList",parameters:[{name:"iterable",val:" = ()"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L110"}}),Tn=new v({props:{name:"__call__",anchor:"transformers.StoppingCriteriaList.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.StoppingCriteriaList.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.StoppingCriteriaList.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be scores for each vocabulary token before SoftMax
or scores for each vocabulary token after SoftMax.
kwargs &#x2014;
Additional stopping criteria specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L111",returnDescription:`
<p><code>bool</code>. <code>False</code> indicates we should continue, <code>True</code> indicates we should stop.</p>
`}}),yn=new v({props:{name:"class transformers.MaxLengthCriteria",anchor:"transformers.MaxLengthCriteria",parameters:[{name:"max_length",val:": int"}],parametersDescription:[{anchor:"transformers.MaxLengthCriteria.max_length",description:`<strong>max_length</strong> (<code>int</code>) &#x2014;
The maximum length that the output sequence can have in number of tokens.`,name:"max_length"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L41"}}),xn=new v({props:{name:"__call__",anchor:"transformers.MaxLengthCriteria.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MaxLengthCriteria.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.MaxLengthCriteria.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be scores for each vocabulary token before SoftMax
or scores for each vocabulary token after SoftMax.
kwargs &#x2014;
Additional stopping criteria specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L54",returnDescription:`
<p><code>bool</code>. <code>False</code> indicates we should continue, <code>True</code> indicates we should stop.</p>
`}}),wn=new v({props:{name:"class transformers.MaxTimeCriteria",anchor:"transformers.MaxTimeCriteria",parameters:[{name:"max_time",val:": float"},{name:"initial_timestamp",val:": typing.Optional[float] = None"}],parametersDescription:[{anchor:"transformers.MaxTimeCriteria.max_time",description:`<strong>max_time</strong> (<code>float</code>) &#x2014;
The maximum allowed time in seconds for the generation.`,name:"max_time"},{anchor:"transformers.MaxTimeCriteria.initial_time",description:`<strong>initial_time</strong> (<code>float</code>, <em>optional</em>, defaults to <code>time.time()</code>) &#x2014;
The start of the generation allowed time.`,name:"initial_time"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L88"}}),En=new v({props:{name:"__call__",anchor:"transformers.MaxTimeCriteria.__call__",parameters:[{name:"input_ids",val:": LongTensor"},{name:"scores",val:": FloatTensor"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MaxTimeCriteria.__call__.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21894/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.MaxTimeCriteria.__call__.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.vocab_size)</code>) &#x2014;
Prediction scores of a language modeling head. These can be scores for each vocabulary token before SoftMax
or scores for each vocabulary token after SoftMax.
kwargs &#x2014;
Additional stopping criteria specific kwargs.`,name:"scores"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/stopping_criteria.py#L105",returnDescription:`
<p><code>bool</code>. <code>False</code> indicates we should continue, <code>True</code> indicates we should stop.</p>
`}}),Pn=new Z({}),Fn=new v({props:{name:"class transformers.Constraint",anchor:"transformers.Constraint",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L5"}}),Qr=new TT({props:{anchor:"transformers.Constraint.example",$$slots:{default:[tx]},$$scope:{ctx:xr}}}),Sn=new v({props:{name:"advance",anchor:"transformers.Constraint.advance",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L48",returnDescription:`
<p>Must be a tensor of a list of indexable tokens, not some integer.</p>
`,returnType:`
<p>token_ids(<code>torch.tensor</code>)</p>
`}}),Dn=new v({props:{name:"copy",anchor:"transformers.Constraint.copy",parameters:[{name:"stateful",val:" = False"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L113",returnDescription:`
<p>The same constraint as the one being called from.</p>
`,returnType:`
<p>constraint(<code>Constraint</code>)</p>
`}}),zn=new v({props:{name:"does_advance",anchor:"transformers.Constraint.does_advance",parameters:[{name:"token_id",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L60"}}),qn=new v({props:{name:"remaining",anchor:"transformers.Constraint.remaining",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L104"}}),Bn=new v({props:{name:"reset",anchor:"transformers.Constraint.reset",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L94"}}),In=new v({props:{name:"test",anchor:"transformers.Constraint.test",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L24"}}),An=new v({props:{name:"update",anchor:"transformers.Constraint.update",parameters:[{name:"token_id",val:": int"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L69",returnDescription:`
<p>Whether this constraint has become one step closer to being fulfuilled.
completed(<code>bool</code>):
Whether this constraint has been completely fulfilled by this token being generated.
reset (<code>bool</code>):
Whether this constraint has reset its progress by this token being generated.</p>
`,returnType:`
<p>stepped(<code>bool</code>)</p>
`}}),Nn=new v({props:{name:"class transformers.PhrasalConstraint",anchor:"transformers.PhrasalConstraint",parameters:[{name:"token_ids",val:": typing.List[int]"}],parametersDescription:[{anchor:"transformers.PhrasalConstraint.token_ids",description:`<strong>token_ids</strong> (<code>List[int]</code>) &#x2014;
The id of the token that must be generated by the output.`,name:"token_ids"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L129"}}),Wn=new v({props:{name:"class transformers.DisjunctiveConstraint",anchor:"transformers.DisjunctiveConstraint",parameters:[{name:"nested_token_ids",val:": typing.List[typing.List[int]]"}],parametersDescription:[{anchor:"transformers.DisjunctiveConstraint.nested_token_ids",description:"<strong>nested_token_ids</strong> (<code>List[List[int]]</code>) &#x2014; a list of words, where each word is a list of ids. This constraint",name:"nested_token_ids"},{anchor:"transformers.DisjunctiveConstraint.is",description:"<strong>is</strong> fulfilled by generating just one from the list of words. &#x2014;",name:"is"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L261"}}),Mn=new v({props:{name:"class transformers.ConstraintListState",anchor:"transformers.ConstraintListState",parameters:[{name:"constraints",val:": typing.List[transformers.generation.beam_constraints.Constraint]"}],parametersDescription:[{anchor:"transformers.ConstraintListState.constraints",description:`<strong>constraints</strong> (<code>List[Constraint]</code>) &#x2014;
A list of <a href="/docs/transformers/pr_21894/en/internal/generation_utils#transformers.Constraint">Constraint</a> objects that must be fulfilled by the beam scorer.`,name:"constraints"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L350"}}),jn=new v({props:{name:"advance",anchor:"transformers.ConstraintListState.advance",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L382"}}),Gn=new v({props:{name:"reset",anchor:"transformers.ConstraintListState.reset",parameters:[{name:"token_ids",val:": typing.Optional[typing.List[int]]"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_constraints.py#L417"}}),Hn=new Z({}),Rn=new v({props:{name:"class transformers.BeamScorer",anchor:"transformers.BeamScorer",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L87"}}),Un=new v({props:{name:"process",anchor:"transformers.BeamScorer.process",parameters:[{name:"input_ids",val:": LongTensor"},{name:"next_scores",val:": FloatTensor"},{name:"next_tokens",val:": LongTensor"},{name:"next_indices",val:": LongTensor"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.BeamScorer.process.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size * num_beams, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using any class inheriting from <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.BeamScorer.process.next_scores",description:`<strong>next_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, 2 * num_beams)</code>) &#x2014;
Current scores of the top <code>2 * num_beams</code> non-finished beam hypotheses.`,name:"next_scores"},{anchor:"transformers.BeamScorer.process.next_tokens",description:`<strong>next_tokens</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, 2 * num_beams)</code>) &#x2014;
<code>input_ids</code> of the tokens corresponding to the top <code>2 * num_beams</code> non-finished beam hypotheses.`,name:"next_tokens"},{anchor:"transformers.BeamScorer.process.next_indices",description:`<strong>next_indices</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, 2 * num_beams)</code>) &#x2014;
Beam indices indicating to which beam hypothesis the <code>next_tokens</code> correspond.`,name:"next_indices"},{anchor:"transformers.BeamScorer.process.pad_token_id",description:`<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The id of the <em>padding</em> token.`,name:"pad_token_id"},{anchor:"transformers.BeamScorer.process.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>, <em>optional</em>) &#x2014;
The id of the <em>end-of-sequence</em> token. Optionally, use a list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L93",returnDescription:`
<p>A dictionary composed of the fields as defined above:</p>
<ul>
<li><strong>next_beam_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) \u2014 Updated scores of all
non-finished beams.</li>
<li><strong>next_beam_tokens</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) \u2014 Next tokens to be added
to the non-finished beam_hypotheses.</li>
<li><strong>next_beam_indices</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) \u2014 Beam indices
indicating to which beam the next tokens shall be added.</li>
</ul>
`,returnType:`
<p><code>UserDict</code></p>
`}}),Kn=new v({props:{name:"finalize",anchor:"transformers.BeamScorer.finalize",parameters:[{name:"input_ids",val:": LongTensor"},{name:"next_scores",val:": FloatTensor"},{name:"next_tokens",val:": LongTensor"},{name:"next_indices",val:": LongTensor"},{name:"max_length",val:": int"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.BeamScorer.finalize.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size * num_beams, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using any class inheriting from <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.BeamScorer.finalize.final_beam_scores",description:`<strong>final_beam_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) &#x2014;
The final scores of all non-finished beams.`,name:"final_beam_scores"},{anchor:"transformers.BeamScorer.finalize.final_beam_tokens",description:`<strong>final_beam_tokens</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) &#x2014;
The last tokens to be added to the non-finished beam_hypotheses.`,name:"final_beam_tokens"},{anchor:"transformers.BeamScorer.finalize.final_beam_indices",description:`<strong>final_beam_indices</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) &#x2014;
The beam indices indicating to which beam the <code>final_beam_tokens</code> shall be added.`,name:"final_beam_indices"},{anchor:"transformers.BeamScorer.finalize.pad_token_id",description:`<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The id of the <em>padding</em> token.`,name:"pad_token_id"},{anchor:"transformers.BeamScorer.finalize.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>, <em>optional</em>) &#x2014;
The id of the <em>end-of-sequence</em> token. Optionally, use a list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L105",returnDescription:`
<p>The generated sequences.
The second dimension (sequence_length) is either equal to <code>max_length</code> or shorter if all batches finished early
due to the <code>eos_token_id</code>.</p>
`,returnType:`
<p><code>torch.LongTensor</code> of shape <code>(batch_size * num_return_sequences, sequence_length)</code></p>
`}}),Yn=new v({props:{name:"class transformers.BeamSearchScorer",anchor:"transformers.BeamSearchScorer",parameters:[{name:"batch_size",val:": int"},{name:"num_beams",val:": int"},{name:"device",val:": device"},{name:"length_penalty",val:": typing.Optional[float] = 1.0"},{name:"do_early_stopping",val:": typing.Union[bool, str, NoneType] = False"},{name:"num_beam_hyps_to_keep",val:": typing.Optional[int] = 1"},{name:"num_beam_groups",val:": typing.Optional[int] = 1"},{name:"max_length",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"transformers.BeamSearchScorer.batch_size",description:`<strong>batch_size</strong> (<code>int</code>) &#x2014;
Batch Size of <code>input_ids</code> for which standard beam search decoding is run in parallel.`,name:"batch_size"},{anchor:"transformers.BeamSearchScorer.num_beams",description:`<strong>num_beams</strong> (<code>int</code>) &#x2014;
Number of beams for beam search.`,name:"num_beams"},{anchor:"transformers.BeamSearchScorer.device",description:`<strong>device</strong> (<code>torch.device</code>) &#x2014;
Defines the device type (<em>e.g.</em>, <code>&quot;cpu&quot;</code> or <code>&quot;cuda&quot;</code>) on which this instance of <code>BeamSearchScorer</code> will be
allocated.`,name:"device"},{anchor:"transformers.BeamSearchScorer.length_penalty",description:`<strong>length_penalty</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
Exponential penalty to the length that is used with beam-based generation. It is applied as an exponent to
the sequence length, which in turn is used to divide the score of the sequence. Since the score is the log
likelihood of the sequence (i.e. negative), <code>length_penalty</code> &gt; 0.0 promotes longer sequences, while
<code>length_penalty</code> &lt; 0.0 encourages shorter sequences.`,name:"length_penalty"},{anchor:"transformers.BeamSearchScorer.do_early_stopping",description:`<strong>do_early_stopping</strong> (<code>bool</code> or <code>str</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Controls the stopping condition for beam-based methods, like beam-search. It accepts the following values:
<code>True</code>, where the generation stops as soon as there are <code>num_beams</code> complete candidates; <code>False</code>, where an
heuristic is applied and the generation stops when is it very unlikely to find better candidates;
<code>&quot;never&quot;</code>, where the beam search procedure only stops when there cannot be better candidates (canonical
beam search algorithm).`,name:"do_early_stopping"},{anchor:"transformers.BeamSearchScorer.num_beam_hyps_to_keep",description:`<strong>num_beam_hyps_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of beam hypotheses that shall be returned upon calling
<code>~transformer.BeamSearchScorer.finalize</code>.`,name:"num_beam_hyps_to_keep"},{anchor:"transformers.BeamSearchScorer.num_beam_groups",description:`<strong>num_beam_groups</strong> (<code>int</code>) &#x2014;
Number of groups to divide <code>num_beams</code> into in order to ensure diversity among different groups of beams.
See <a href="https://arxiv.org/pdf/1610.02424.pdf" rel="nofollow">this paper</a> for more details.`,name:"num_beam_groups"},{anchor:"transformers.BeamSearchScorer.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The maximum length of the sequence to be generated.`,name:"max_length"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L119"}}),Zn=new v({props:{name:"process",anchor:"transformers.BeamSearchScorer.process",parameters:[{name:"input_ids",val:": LongTensor"},{name:"next_scores",val:": FloatTensor"},{name:"next_tokens",val:": LongTensor"},{name:"next_indices",val:": LongTensor"},{name:"pad_token_id",val:": typing.Optional[int] = None"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int], NoneType] = None"},{name:"beam_indices",val:": typing.Optional[torch.LongTensor] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L205"}}),es=new v({props:{name:"finalize",anchor:"transformers.BeamSearchScorer.finalize",parameters:[{name:"input_ids",val:": LongTensor"},{name:"final_beam_scores",val:": FloatTensor"},{name:"final_beam_tokens",val:": LongTensor"},{name:"final_beam_indices",val:": LongTensor"},{name:"max_length",val:": int"},{name:"pad_token_id",val:": typing.Optional[int] = None"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int], NoneType] = None"},{name:"beam_indices",val:": typing.Optional[torch.LongTensor] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L303"}}),rs=new v({props:{name:"class transformers.ConstrainedBeamSearchScorer",anchor:"transformers.ConstrainedBeamSearchScorer",parameters:[{name:"batch_size",val:": int"},{name:"num_beams",val:": int"},{name:"constraints",val:": typing.List[transformers.generation.beam_constraints.Constraint]"},{name:"device",val:": device"},{name:"length_penalty",val:": typing.Optional[float] = 1.0"},{name:"do_early_stopping",val:": typing.Union[bool, str, NoneType] = False"},{name:"num_beam_hyps_to_keep",val:": typing.Optional[int] = 1"},{name:"num_beam_groups",val:": typing.Optional[int] = 1"},{name:"max_length",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"transformers.ConstrainedBeamSearchScorer.batch_size",description:`<strong>batch_size</strong> (<code>int</code>) &#x2014;
Batch Size of <code>input_ids</code> for which standard beam search decoding is run in parallel.`,name:"batch_size"},{anchor:"transformers.ConstrainedBeamSearchScorer.num_beams",description:`<strong>num_beams</strong> (<code>int</code>) &#x2014;
Number of beams for beam search.`,name:"num_beams"},{anchor:"transformers.ConstrainedBeamSearchScorer.constraints",description:`<strong>constraints</strong> (<code>List[Constraint]</code>) &#x2014;
A list of positive constraints represented as <code>Constraint</code> objects that must be fulfilled in the generation
output. For more information, the documentation of <a href="/docs/transformers/pr_21894/en/internal/generation_utils#transformers.Constraint">Constraint</a> should be read.`,name:"constraints"},{anchor:"transformers.ConstrainedBeamSearchScorer.device",description:`<strong>device</strong> (<code>torch.device</code>) &#x2014;
Defines the device type (<em>e.g.</em>, <code>&quot;cpu&quot;</code> or <code>&quot;cuda&quot;</code>) on which this instance of <code>BeamSearchScorer</code> will be
allocated.`,name:"device"},{anchor:"transformers.ConstrainedBeamSearchScorer.length_penalty",description:`<strong>length_penalty</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
Exponential penalty to the length that is used with beam-based generation. It is applied as an exponent to
the sequence length, which in turn is used to divide the score of the sequence. Since the score is the log
likelihood of the sequence (i.e. negative), <code>length_penalty</code> &gt; 0.0 promotes longer sequences, while
<code>length_penalty</code> &lt; 0.0 encourages shorter sequences.`,name:"length_penalty"},{anchor:"transformers.ConstrainedBeamSearchScorer.do_early_stopping",description:`<strong>do_early_stopping</strong> (<code>bool</code> or <code>str</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Controls the stopping condition for beam-based methods, like beam-search. It accepts the following values:
<code>True</code>, where the generation stops as soon as there are <code>num_beams</code> complete candidates; <code>False</code>, where an
heuristic is applied and the generation stops when is it very unlikely to find better candidates;
<code>&quot;never&quot;</code>, where the beam search procedure only stops when there cannot be better candidates (canonical
beam search algorithm).`,name:"do_early_stopping"},{anchor:"transformers.ConstrainedBeamSearchScorer.num_beam_hyps_to_keep",description:`<strong>num_beam_hyps_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of beam hypotheses that shall be returned upon calling
<code>~transformer.BeamSearchScorer.finalize</code>.`,name:"num_beam_hyps_to_keep"},{anchor:"transformers.ConstrainedBeamSearchScorer.num_beam_groups",description:`<strong>num_beam_groups</strong> (<code>int</code>) &#x2014;
Number of groups to divide <code>num_beams</code> into in order to ensure diversity among different groups of beams.
See <a href="https://arxiv.org/pdf/1610.02424.pdf" rel="nofollow">this paper</a> for more details.`,name:"num_beam_groups"},{anchor:"transformers.ConstrainedBeamSearchScorer.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The maximum length of the sequence to be generated.`,name:"max_length"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L395"}}),ts=new v({props:{name:"process",anchor:"transformers.ConstrainedBeamSearchScorer.process",parameters:[{name:"input_ids",val:": LongTensor"},{name:"next_scores",val:": FloatTensor"},{name:"next_tokens",val:": LongTensor"},{name:"next_indices",val:": LongTensor"},{name:"scores_for_all_vocab",val:": FloatTensor"},{name:"pad_token_id",val:": typing.Optional[int] = None"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int], NoneType] = None"}],parametersDescription:[{anchor:"transformers.ConstrainedBeamSearchScorer.process.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size * num_beams, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using any class inheriting from <a href="/docs/transformers/pr_21894/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. See
<a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and <a href="/docs/transformers/pr_21894/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.ConstrainedBeamSearchScorer.process.next_scores",description:`<strong>next_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, 2 * num_beams)</code>) &#x2014;
Current scores of the top <code>2 * num_beams</code> non-finished beam hypotheses.`,name:"next_scores"},{anchor:"transformers.ConstrainedBeamSearchScorer.process.next_tokens",description:`<strong>next_tokens</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, 2 * num_beams)</code>) &#x2014;
<code>input_ids</code> of the tokens corresponding to the top <code>2 * num_beams</code> non-finished beam hypotheses.`,name:"next_tokens"},{anchor:"transformers.ConstrainedBeamSearchScorer.process.next_indices",description:`<strong>next_indices</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, 2 * num_beams)</code>) &#x2014;
Beam indices indicating to which beam hypothesis the <code>next_tokens</code> correspond.`,name:"next_indices"},{anchor:"transformers.ConstrainedBeamSearchScorer.process.scores_for_all_vocab",description:`<strong>scores_for_all_vocab</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams, sequence_length)</code>) &#x2014;
The scores of all tokens in the vocabulary for each of the beam hypotheses.`,name:"scores_for_all_vocab"},{anchor:"transformers.ConstrainedBeamSearchScorer.process.pad_token_id",description:`<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The id of the <em>padding</em> token.`,name:"pad_token_id"},{anchor:"transformers.ConstrainedBeamSearchScorer.process.eos_token_id",description:`<strong>eos_token_id</strong> (<code>Union[int, List[int]]</code>, <em>optional</em>) &#x2014;
The id of the <em>end-of-sequence</em> token. Optionally, use a list to set multiple <em>end-of-sequence</em> tokens.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L489",returnDescription:`
<p>A dictionary composed of the fields as defined above:</p>
<ul>
<li>
<p><strong>next_beam_scores</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) \u2014 Updated scores of
all
non-finished beams.</p>
</li>
<li>
<p><strong>next_beam_tokens</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) \u2014 Next tokens to be
added
to the non-finished beam_hypotheses.</p>
</li>
<li>
<p><strong>next_beam_indices</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size * num_beams)</code>) \u2014 Beam indices
indicating to which beam the next tokens shall be added.</p>
</li>
</ul>
`,returnType:`
<p><code>UserDict</code></p>
`}}),os=new v({props:{name:"finalize",anchor:"transformers.ConstrainedBeamSearchScorer.finalize",parameters:[{name:"input_ids",val:": LongTensor"},{name:"final_beam_scores",val:": FloatTensor"},{name:"final_beam_tokens",val:": LongTensor"},{name:"final_beam_indices",val:": LongTensor"},{name:"max_length",val:": int"},{name:"pad_token_id",val:": typing.Optional[int] = None"},{name:"eos_token_id",val:": typing.Union[int, typing.List[int], NoneType] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/beam_search.py#L774"}}),ns=new Z({}),ss=new v({props:{name:"transformers.top_k_top_p_filtering",anchor:"transformers.top_k_top_p_filtering",parameters:[{name:"logits",val:": FloatTensor"},{name:"top_k",val:": int = 0"},{name:"top_p",val:": float = 1.0"},{name:"filter_value",val:": float = -inf"},{name:"min_tokens_to_keep",val:": int = 1"}],parametersDescription:[{anchor:"transformers.top_k_top_p_filtering.top_k",description:`<strong>top_k</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
If &gt; 0, only keep the top k tokens with highest probability (top-k filtering)`,name:"top_k"},{anchor:"transformers.top_k_top_p_filtering.top_p",description:`<strong>top_p</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
If &lt; 1.0, only keep the top tokens with cumulative probability &gt;= top_p (nucleus filtering). Nucleus
filtering is described in Holtzman et al. (<a href="http://arxiv.org/abs/1904.09751" rel="nofollow">http://arxiv.org/abs/1904.09751</a>)`,name:"top_p"},{anchor:"transformers.top_k_top_p_filtering.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimumber of tokens we keep per batch example in the output.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/utils.py#L3975"}}),is=new v({props:{name:"transformers.tf_top_k_top_p_filtering",anchor:"transformers.tf_top_k_top_p_filtering",parameters:[{name:"logits",val:""},{name:"top_k",val:" = 0"},{name:"top_p",val:" = 1.0"},{name:"filter_value",val:" = -inf"},{name:"min_tokens_to_keep",val:" = 1"}],parametersDescription:[{anchor:"transformers.tf_top_k_top_p_filtering.top_k",description:`<strong>top_k</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
If &gt; 0, only keep the top k tokens with highest probability (top-k filtering)`,name:"top_k"},{anchor:"transformers.tf_top_k_top_p_filtering.top_p",description:`<strong>top_p</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
If &lt; 1.0, only keep the top tokens with cumulative probability &gt;= top_p (nucleus filtering). Nucleus
filtering is described in Holtzman et al. (<a href="http://arxiv.org/abs/1904.09751" rel="nofollow">http://arxiv.org/abs/1904.09751</a>)`,name:"top_p"},{anchor:"transformers.tf_top_k_top_p_filtering.min_tokens_to_keep",description:`<strong>min_tokens_to_keep</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Minimumber of tokens we keep per batch example in the output.`,name:"min_tokens_to_keep"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/tf_utils.py#L3056"}}),ls=new Z({}),ds=new v({props:{name:"class transformers.TextStreamer",anchor:"transformers.TextStreamer",parameters:[{name:"tokenizer",val:": AutoTokenizer"},{name:"skip_prompt",val:": bool = False"},{name:"**decode_kwargs",val:""}],parametersDescription:[{anchor:"transformers.TextStreamer.tokenizer",description:`<strong>tokenizer</strong> (<code>AutoTokenizer</code>) &#x2014;
The tokenized used to decode the tokens.`,name:"tokenizer"},{anchor:"transformers.TextStreamer.skip_prompt",description:`<strong>skip_prompt</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to skip the prompt to <code>.generate()</code> or not. Useful e.g. for chatbots.`,name:"skip_prompt"},{anchor:"transformers.TextStreamer.decode_kwargs",description:`<strong>decode_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments to pass to the tokenizer&#x2019;s <code>decode</code> method.`,name:"decode_kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/streamers.py#L38"}}),lt=new TT({props:{anchor:"transformers.TextStreamer.example",$$slots:{default:[ox]},$$scope:{ctx:xr}}}),ps=new v({props:{name:"end",anchor:"transformers.TextStreamer.end",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/streamers.py#L106"}}),ms=new v({props:{name:"on_finalized_text",anchor:"transformers.TextStreamer.on_finalized_text",parameters:[{name:"text",val:": str"},{name:"stream_end",val:": bool = False"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/streamers.py#L120"}}),fs=new v({props:{name:"put",anchor:"transformers.TextStreamer.put",parameters:[{name:"value",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/streamers.py#L76"}}),gs=new v({props:{name:"class transformers.TextIteratorStreamer",anchor:"transformers.TextIteratorStreamer",parameters:[{name:"tokenizer",val:": AutoTokenizer"},{name:"skip_prompt",val:": bool = False"},{name:"**decode_kwargs",val:""}],parametersDescription:[{anchor:"transformers.TextIteratorStreamer.tokenizer",description:`<strong>tokenizer</strong> (<code>AutoTokenizer</code>) &#x2014;
The tokenized used to decode the tokens.`,name:"tokenizer"},{anchor:"transformers.TextIteratorStreamer.skip_prompt",description:`<strong>skip_prompt</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to skip the prompt to <code>.generate()</code> or not. Useful e.g. for chatbots.`,name:"skip_prompt"},{anchor:"transformers.TextIteratorStreamer.decode_kwargs",description:`<strong>decode_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments to pass to the tokenizer&#x2019;s <code>decode</code> method.`,name:"decode_kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/streamers.py#L125"}}),ft=new TT({props:{anchor:"transformers.TextIteratorStreamer.example",$$slots:{default:[nx]},$$scope:{ctx:xr}}}),hs=new v({props:{name:"on_finalized_text",anchor:"transformers.TextIteratorStreamer.on_finalized_text",parameters:[{name:"text",val:": str"},{name:"stream_end",val:": bool = False"}],source:"https://github.com/huggingface/transformers/blob/vr_21894/src/transformers/generation/streamers.py#L167"}}),{c(){T=o("meta"),F=c(),y=o("h1"),x=o("a"),I=o("span"),f($.$$.fragment),S=c(),Mc=o("span"),Gf=a("Utilities for Generation"),cp=c(),L=o("p"),Hf=a("This page lists all the utility functions used by "),vs=o("a"),Rf=a("generate()"),Uf=a(`,
`),$s=o("a"),Kf=a("greedy_search()"),Yf=a(`,
`),Ts=o("a"),Xf=a("contrastive_search()"),Jf=a(`,
`),ys=o("a"),Qf=a("sample()"),Zf=a(`,
`),ks=o("a"),eg=a("beam_search()"),rg=a(`,
`),xs=o("a"),tg=a("beam_sample()"),og=a(`,
`),ws=o("a"),ng=a("group_beam_search()"),sg=a(`, and
`),Ls=o("a"),ag=a("constrained_beam_search()"),ig=a("."),lp=c(),Es=o("p"),cg=a("Most of those are only useful if you are studying the code of the generate methods in the library."),dp=c(),er=o("h2"),wr=o("a"),jc=o("span"),f(yt.$$.fragment),lg=c(),Gc=o("span"),dg=a("Generate Outputs"),pp=c(),K=o("p"),pg=a("The output of "),Ps=o("a"),mg=a("generate()"),fg=a(` is an instance of a subclass of
`),Fs=o("a"),gg=a("ModelOutput"),hg=a(`. This output is a data structure containing all the information returned
by `),Ss=o("a"),ug=a("generate()"),_g=a(", but that can also be used as tuple or dictionary."),mp=c(),Ds=o("p"),bg=a("Here\u2019s an example:"),fp=c(),f(kt.$$.fragment),gp=c(),Re=o("p"),vg=a("The "),Hc=o("code"),$g=a("generation_output"),Tg=a(" object is a "),zs=o("a"),yg=a("GreedySearchDecoderOnlyOutput"),kg=a(`, as we can
see in the documentation of that class below, it means it has the following attributes:`),hp=c(),Y=o("ul"),qs=o("li"),Rc=o("code"),xg=a("sequences"),wg=a(": the generated sequences of tokens"),Lg=c(),Os=o("li"),Uc=o("code"),Eg=a("scores"),Pg=a(" (optional): the prediction scores of the language modelling head, for each generation step"),Fg=c(),Bs=o("li"),Kc=o("code"),Sg=a("hidden_states"),Dg=a(" (optional): the hidden states of the model, for each generation step"),zg=c(),Is=o("li"),Yc=o("code"),qg=a("attentions"),Og=a(" (optional): the attention weights of the model, for each generation step"),up=c(),E=o("p"),Bg=a("Here we have the "),Xc=o("code"),Ig=a("scores"),Ag=a(" since we passed along "),Jc=o("code"),Cg=a("output_scores=True"),Ng=a(", but we don\u2019t have "),Qc=o("code"),Wg=a("hidden_states"),Vg=a(` and
`),Zc=o("code"),Mg=a("attentions"),jg=a(" because we didn\u2019t pass "),el=o("code"),Gg=a("output_hidden_states=True"),Hg=a(" or "),rl=o("code"),Rg=a("output_attentions=True"),Ug=a("."),_p=c(),A=o("p"),Kg=a(`You can access each attribute as you would usually do, and if that attribute has not been returned by the model, you
will get `),tl=o("code"),Yg=a("None"),Xg=a(". Here for instance "),ol=o("code"),Jg=a("generation_output.scores"),Qg=a(` are all the generated prediction scores of the
language modeling head, and `),nl=o("code"),Zg=a("generation_output.attentions"),eh=a(" is "),sl=o("code"),rh=a("None"),th=a("."),bp=c(),C=o("p"),oh=a("When using our "),al=o("code"),nh=a("generation_output"),sh=a(" object as a tuple, it only keeps the attributes that don\u2019t have "),il=o("code"),ah=a("None"),ih=a(` values.
Here, for instance, it has two elements, `),cl=o("code"),ch=a("loss"),lh=a(" then "),ll=o("code"),dh=a("logits"),ph=a(", so"),vp=c(),f(xt.$$.fragment),$p=c(),Lr=o("p"),mh=a("will return the tuple "),dl=o("code"),fh=a("(generation_output.sequences, generation_output.scores)"),gh=a(" for instance."),Tp=c(),N=o("p"),hh=a("When using our "),pl=o("code"),uh=a("generation_output"),_h=a(" object as a dictionary, it only keeps the attributes that don\u2019t have "),ml=o("code"),bh=a("None"),vh=a(`
values. Here, for instance, it has two keys that are `),fl=o("code"),$h=a("sequences"),Th=a(" and "),gl=o("code"),yh=a("scores"),kh=a("."),yp=c(),As=o("p"),xh=a("We document here all output types."),kp=c(),rr=o("h3"),Er=o("a"),hl=o("span"),f(wt.$$.fragment),wh=c(),ul=o("span"),Lh=a("GreedySearchOutput"),xp=c(),tr=o("div"),f(Lt.$$.fragment),Eh=c(),_l=o("p"),Ph=a("Base class for outputs of decoder-only generation models using greedy search."),wp=c(),or=o("div"),f(Et.$$.fragment),Fh=c(),bl=o("p"),Sh=a(`Base class for outputs of encoder-decoder generation models using greedy search. Hidden states and attention
weights of the decoder (respectively the encoder) can be accessed via the encoder_attentions and the
encoder_hidden_states attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),Lp=c(),ee=o("div"),f(Pt.$$.fragment),Dh=c(),vl=o("p"),zh=a("Flax Base class for outputs of decoder-only generation models using greedy search."),qh=c(),Pr=o("div"),f(Ft.$$.fragment),Oh=c(),$l=o("p"),Bh=a("\u201CReturns a new object replacing the specified fields with new values."),Ep=c(),nr=o("h3"),Fr=o("a"),Tl=o("span"),f(St.$$.fragment),Ih=c(),yl=o("span"),Ah=a("SampleOutput"),Pp=c(),sr=o("div"),f(Dt.$$.fragment),Ch=c(),kl=o("p"),Nh=a("Base class for outputs of decoder-only generation models using sampling."),Fp=c(),ar=o("div"),f(zt.$$.fragment),Wh=c(),xl=o("p"),Vh=a(`Base class for outputs of encoder-decoder generation models using sampling. Hidden states and attention weights of
the decoder (respectively the encoder) can be accessed via the encoder_attentions and the encoder_hidden_states
attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),Sp=c(),re=o("div"),f(qt.$$.fragment),Mh=c(),wl=o("p"),jh=a("Flax Base class for outputs of decoder-only generation models using sampling."),Gh=c(),Sr=o("div"),f(Ot.$$.fragment),Hh=c(),Ll=o("p"),Rh=a("\u201CReturns a new object replacing the specified fields with new values."),Dp=c(),ir=o("h3"),Dr=o("a"),El=o("span"),f(Bt.$$.fragment),Uh=c(),Pl=o("span"),Kh=a("BeamSearchOutput"),zp=c(),cr=o("div"),f(It.$$.fragment),Yh=c(),Fl=o("p"),Xh=a("Base class for outputs of decoder-only generation models using beam search."),qp=c(),lr=o("div"),f(At.$$.fragment),Jh=c(),Sl=o("p"),Qh=a(`Base class for outputs of encoder-decoder generation models using beam search. Hidden states and attention weights
of the decoder (respectively the encoder) can be accessed via the encoder_attentions and the encoder_hidden_states
attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),Op=c(),dr=o("h3"),zr=o("a"),Dl=o("span"),f(Ct.$$.fragment),Zh=c(),zl=o("span"),eu=a("BeamSampleOutput"),Bp=c(),pr=o("div"),f(Nt.$$.fragment),ru=c(),ql=o("p"),tu=a("Base class for outputs of decoder-only generation models using beam sample."),Ip=c(),mr=o("div"),f(Wt.$$.fragment),ou=c(),Ol=o("p"),nu=a(`Base class for outputs of encoder-decoder generation models using beam sampling. Hidden states and attention
weights of the decoder (respectively the encoder) can be accessed via the encoder_attentions and the
encoder_hidden_states attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),Ap=c(),fr=o("h2"),qr=o("a"),Bl=o("span"),f(Vt.$$.fragment),su=c(),Il=o("span"),au=a("LogitsProcessor"),Cp=c(),Or=o("p"),iu=a("A "),Cs=o("a"),cu=a("LogitsProcessor"),lu=a(` can be used to modify the prediction scores of a language model head for
generation.`),Np=c(),te=o("div"),f(Mt.$$.fragment),du=c(),Al=o("p"),pu=a("Abstract base class for all logit processors that can be applied during generation."),mu=c(),Br=o("div"),f(jt.$$.fragment),fu=c(),Cl=o("p"),gu=a("Torch method for processing logits."),Wp=c(),oe=o("div"),f(Gt.$$.fragment),hu=c(),D=o("p"),uu=a("This class can be used to create a list of "),Ns=o("a"),_u=a("LogitsProcessor"),bu=a(" or "),Ws=o("a"),vu=a("LogitsWarper"),$u=a(` to subsequently process a
`),Nl=o("code"),Tu=a("scores"),yu=a(" input tensor. This class inherits from list and adds a specific "),Wl=o("em"),Vl=o("strong"),ku=a("call"),xu=a(` method to apply each
`),Vs=o("a"),wu=a("LogitsProcessor"),Lu=a(" or "),Ms=o("a"),Eu=a("LogitsWarper"),Pu=a(" to the inputs."),Fu=c(),js=o("div"),f(Ht.$$.fragment),Vp=c(),ne=o("div"),f(Rt.$$.fragment),Su=c(),Ml=o("p"),Du=a("Abstract base class for all logit warpers that can be applied during generation with multinomial sampling."),zu=c(),Ir=o("div"),f(Ut.$$.fragment),qu=c(),jl=o("p"),Ou=a("Torch method for warping logits."),Mp=c(),se=o("div"),f(Kt.$$.fragment),Bu=c(),Gs=o("p"),Hs=o("a"),Iu=a("LogitsProcessor"),Au=a(" enforcing a min-length by setting EOS probability to 0."),Cu=c(),Rs=o("div"),f(Yt.$$.fragment),jp=c(),ae=o("div"),f(Xt.$$.fragment),Nu=c(),Us=o("p"),Ks=o("a"),Wu=a("LogitsProcessor"),Vu=a(" enforcing a min-length of new tokens by setting EOS (End-Of-Sequence) token probability to 0."),Mu=c(),Ys=o("div"),f(Jt.$$.fragment),Gp=c(),ie=o("div"),f(Qt.$$.fragment),ju=c(),Xs=o("p"),Js=o("a"),Gu=a("LogitsWarper"),Hu=a(" for temperature (exponential scaling output probability distribution)."),Ru=c(),Qs=o("div"),f(Zt.$$.fragment),Hp=c(),ce=o("div"),f(eo.$$.fragment),Uu=c(),Zs=o("p"),ea=o("a"),Ku=a("LogitsProcessor"),Yu=a(" enforcing an exponential penalty on repeated sequences."),Xu=c(),ra=o("div"),f(ro.$$.fragment),Rp=c(),le=o("div"),f(to.$$.fragment),Ju=c(),ta=o("p"),oa=o("a"),Qu=a("LogitsWarper"),Zu=a(" that performs top-p, i.e. restricting to top tokens summing to prob_cut_off <= prob_cut_off."),e_=c(),na=o("div"),f(oo.$$.fragment),Up=c(),de=o("div"),f(no.$$.fragment),r_=c(),sa=o("p"),aa=o("a"),t_=a("LogitsWarper"),o_=a(" that performs top-k, i.e. restricting to the k highest probability elements."),n_=c(),ia=o("div"),f(so.$$.fragment),Kp=c(),pe=o("div"),f(ao.$$.fragment),s_=c(),Ar=o("p"),ca=o("a"),a_=a("LogitsWarper"),i_=a(" that performs typical decoding. See "),io=o("a"),c_=a(`Typical Decoding for Natural Language
Generation`),l_=a(" for more information."),d_=c(),la=o("div"),f(co.$$.fragment),Yp=c(),me=o("div"),f(lo.$$.fragment),p_=c(),Cr=o("p"),da=o("a"),m_=a("LogitsProcessor"),f_=a(` that enforces no repetition of n-grams. See
`),po=o("a"),g_=a("Fairseq"),h_=a("."),u_=c(),pa=o("div"),f(mo.$$.fragment),Xp=c(),fe=o("div"),f(fo.$$.fragment),__=c(),ma=o("p"),fa=o("a"),b_=a("LogitsProcessor"),v_=a(" that enforces that specified sequences will never be sampled."),$_=c(),ga=o("div"),f(go.$$.fragment),Jp=c(),ge=o("div"),f(ho.$$.fragment),T_=c(),Nr=o("p"),ha=o("a"),y_=a("LogitsProcessor"),k_=a(` that enforces constrained generation and is useful for prefix-conditioned constrained
generation. See `),uo=o("a"),x_=a("Autoregressive Entity Retrieval"),w_=a(" for more information."),L_=c(),ua=o("div"),f(_o.$$.fragment),Qp=c(),he=o("div"),f(bo.$$.fragment),E_=c(),Ue=o("p"),_a=o("a"),P_=a("LogitsProcessor"),F_=a(` that enforces diverse beam search. Note that this logits processor is only effective for
`),ba=o("a"),S_=a("PreTrainedModel.group_beam_search()"),D_=a(". See "),vo=o("a"),z_=a(`Diverse Beam Search: Decoding Diverse Solutions from Neural Sequence
Models`),q_=a(" for more details."),O_=c(),va=o("div"),f($o.$$.fragment),Zp=c(),ue=o("div"),f(To.$$.fragment),B_=c(),$a=o("p"),Ta=o("a"),I_=a("LogitsProcessor"),A_=a(" that enforces the specified token as the first generated token."),C_=c(),ya=o("div"),f(yo.$$.fragment),em=c(),_e=o("div"),f(ko.$$.fragment),N_=c(),Wr=o("p"),ka=o("a"),W_=a("LogitsProcessor"),V_=a(" that enforces the specified token as the last generated token when "),Gl=o("code"),M_=a("max_length"),j_=a(" is reached."),G_=c(),xa=o("div"),f(xo.$$.fragment),rm=c(),be=o("div"),f(wo.$$.fragment),H_=c(),Ke=o("p"),wa=o("a"),R_=a("LogitsProcessor"),U_=a(" that removes all "),Hl=o("code"),K_=a("nan"),Y_=a(" and "),Rl=o("code"),X_=a("inf"),J_=a(` values to avoid the generation method to fail. Note that using
the logits processor should only be used if necessary since it can slow down the generation method.`),Q_=c(),La=o("div"),f(Lo.$$.fragment),tm=c(),ve=o("div"),f(Eo.$$.fragment),Z_=c(),Ul=o("p"),eb=a("Abstract base class for all logit processors that can be applied during generation."),rb=c(),Vr=o("div"),f(Po.$$.fragment),tb=c(),Kl=o("p"),ob=a("TF method for processing logits."),om=c(),$e=o("div"),f(Fo.$$.fragment),nb=c(),j=o("p"),sb=a("This class can be used to create a list of "),Ea=o("a"),ab=a("TFLogitsProcessor"),ib=a(" to subsequently process a "),Yl=o("code"),cb=a("scores"),lb=a(` input tensor.
This class inherits from list and adds a specific `),Xl=o("em"),Jl=o("strong"),db=a("call"),pb=a(" method to apply each "),Pa=o("a"),mb=a("TFLogitsProcessor"),fb=a(` to the
inputs.`),gb=c(),Fa=o("div"),f(So.$$.fragment),nm=c(),Te=o("div"),f(Do.$$.fragment),hb=c(),Ql=o("p"),ub=a("Abstract base class for all logit warpers that can be applied during generation with multinomial sampling."),_b=c(),Mr=o("div"),f(zo.$$.fragment),bb=c(),Zl=o("p"),vb=a("TF method for warping logits."),sm=c(),ye=o("div"),f(qo.$$.fragment),$b=c(),Sa=o("p"),Da=o("a"),Tb=a("TFLogitsWarper"),yb=a(" for temperature (exponential scaling output probability distribution)."),kb=c(),za=o("div"),f(Oo.$$.fragment),am=c(),ke=o("div"),f(Bo.$$.fragment),xb=c(),qa=o("p"),Oa=o("a"),wb=a("TFLogitsWarper"),Lb=a(" that performs top-p, i.e. restricting to top tokens summing to <= prob_cut_off."),Eb=c(),Ba=o("div"),f(Io.$$.fragment),im=c(),xe=o("div"),f(Ao.$$.fragment),Pb=c(),Ia=o("p"),Aa=o("a"),Fb=a("TFLogitsWarper"),Sb=a(" that performs top-k, i.e. restricting to the k highest probability elements."),Db=c(),Ca=o("div"),f(Co.$$.fragment),cm=c(),we=o("div"),f(No.$$.fragment),zb=c(),Na=o("p"),Wa=o("a"),qb=a("TFLogitsProcessor"),Ob=a(" enforcing a min-length by setting EOS probability to 0."),Bb=c(),Va=o("div"),f(Wo.$$.fragment),lm=c(),Le=o("div"),f(Vo.$$.fragment),Ib=c(),Ma=o("p"),ja=o("a"),Ab=a("TFLogitsProcessor"),Cb=a(" that enforces that specified sequences will never be sampled."),Nb=c(),Ga=o("div"),f(Mo.$$.fragment),dm=c(),Ee=o("div"),f(jo.$$.fragment),Wb=c(),jr=o("p"),Ha=o("a"),Vb=a("TFLogitsProcessor"),Mb=a(` that enforces no repetition of n-grams. See
`),Go=o("a"),jb=a("Fairseq"),Gb=a("."),Hb=c(),Ra=o("div"),f(Ho.$$.fragment),pm=c(),Pe=o("div"),f(Ro.$$.fragment),Rb=c(),Ua=o("p"),Ka=o("a"),Ub=a("TFLogitsProcessor"),Kb=a(" enforcing an exponential penalty on repeated sequences."),Yb=c(),Ya=o("div"),f(Uo.$$.fragment),mm=c(),Fe=o("div"),f(Ko.$$.fragment),Xb=c(),Xa=o("p"),Ja=o("a"),Jb=a("TFLogitsProcessor"),Qb=a(" that enforces the specified token as the first generated token."),Zb=c(),Qa=o("div"),f(Yo.$$.fragment),fm=c(),Se=o("div"),f(Xo.$$.fragment),ev=c(),Gr=o("p"),Za=o("a"),rv=a("TFLogitsProcessor"),tv=a(" that enforces the specified token as the last generated token when "),ed=o("code"),ov=a("max_length"),nv=a(" is reached."),sv=c(),ei=o("div"),f(Jo.$$.fragment),gm=c(),De=o("div"),f(Qo.$$.fragment),av=c(),rd=o("p"),iv=a("Abstract base class for all logit processors that can be applied during generation."),cv=c(),Hr=o("div"),f(Zo.$$.fragment),lv=c(),td=o("p"),dv=a("Flax method for processing logits."),hm=c(),ze=o("div"),f(en.$$.fragment),pv=c(),z=o("p"),mv=a("This class can be used to create a list of "),ri=o("a"),fv=a("FlaxLogitsProcessor"),gv=a(" or "),ti=o("a"),hv=a("FlaxLogitsWarper"),uv=a(` to subsequently process
a `),od=o("code"),_v=a("scores"),bv=a(" input tensor. This class inherits from list and adds a specific "),nd=o("em"),sd=o("strong"),vv=a("call"),$v=a(` method to apply each
`),oi=o("a"),Tv=a("FlaxLogitsProcessor"),yv=a(" or "),ni=o("a"),kv=a("FlaxLogitsWarper"),xv=a(" to the inputs."),wv=c(),si=o("div"),f(rn.$$.fragment),um=c(),qe=o("div"),f(tn.$$.fragment),Lv=c(),ad=o("p"),Ev=a("Abstract base class for all logit warpers that can be applied during generation with multinomial sampling."),Pv=c(),Rr=o("div"),f(on.$$.fragment),Fv=c(),id=o("p"),Sv=a("Flax method for warping logits."),_m=c(),Oe=o("div"),f(nn.$$.fragment),Dv=c(),ai=o("p"),ii=o("a"),zv=a("FlaxLogitsWarper"),qv=a(" for temperature (exponential scaling output probability distribution)."),Ov=c(),ci=o("div"),f(sn.$$.fragment),bm=c(),Be=o("div"),f(an.$$.fragment),Bv=c(),li=o("p"),di=o("a"),Iv=a("FlaxLogitsWarper"),Av=a(" that performs top-p, i.e. restricting to top tokens summing to prob_cut_off <= prob_cut_off."),Cv=c(),pi=o("div"),f(cn.$$.fragment),vm=c(),Ie=o("div"),f(ln.$$.fragment),Nv=c(),mi=o("p"),fi=o("a"),Wv=a("FlaxLogitsWarper"),Vv=a(" that performs top-k, i.e. restricting to the k highest probability elements."),Mv=c(),gi=o("div"),f(dn.$$.fragment),$m=c(),Ae=o("div"),f(pn.$$.fragment),jv=c(),hi=o("p"),ui=o("a"),Gv=a("FlaxLogitsProcessor"),Hv=a(" that enforces the specified token as the first generated token."),Rv=c(),_i=o("div"),f(mn.$$.fragment),Tm=c(),Ce=o("div"),f(fn.$$.fragment),Uv=c(),Ur=o("p"),bi=o("a"),Kv=a("FlaxLogitsProcessor"),Yv=a(" that enforces the specified token as the last generated token when "),cd=o("code"),Xv=a("max_length"),Jv=a(" is reached."),Qv=c(),vi=o("div"),f(gn.$$.fragment),ym=c(),Ne=o("div"),f(hn.$$.fragment),Zv=c(),$i=o("p"),Ti=o("a"),e1=a("FlaxLogitsProcessor"),r1=a(" enforcing a min-length by setting EOS probability to 0."),t1=c(),yi=o("div"),f(un.$$.fragment),km=c(),gr=o("h2"),Kr=o("a"),ld=o("span"),f(_n.$$.fragment),o1=c(),dd=o("span"),n1=a("StoppingCriteria"),xm=c(),Yr=o("p"),s1=a("A "),ki=o("a"),a1=a("StoppingCriteria"),i1=a(" can be used to change when to stop generation (other than EOS token)."),wm=c(),We=o("div"),f(bn.$$.fragment),c1=c(),pd=o("p"),l1=a("Abstract base class for all stopping criteria that can be applied during generation."),d1=c(),xi=o("div"),f(vn.$$.fragment),Lm=c(),hr=o("div"),f($n.$$.fragment),p1=c(),wi=o("div"),f(Tn.$$.fragment),Em=c(),Ve=o("div"),f(yn.$$.fragment),m1=c(),kn=o("p"),f1=a("This class can be used to stop generation whenever the full generated number of tokens exceeds "),md=o("code"),g1=a("max_length"),h1=a(`. Keep
in mind for decoder-only type of transformers, this will include the initial prompted tokens.`),u1=c(),Li=o("div"),f(xn.$$.fragment),Pm=c(),Me=o("div"),f(wn.$$.fragment),_1=c(),Ln=o("p"),b1=a(`This class can be used to stop generation whenever the full generation exceeds some amount of time. By default, the
time will start being counted when you initialize this function. You can override this by passing an
`),fd=o("code"),v1=a("initial_time"),$1=a("."),T1=c(),Ei=o("div"),f(En.$$.fragment),Fm=c(),ur=o("h2"),Xr=o("a"),gd=o("span"),f(Pn.$$.fragment),y1=c(),hd=o("span"),k1=a("Constraints"),Sm=c(),Jr=o("p"),x1=a("A "),Pi=o("a"),w1=a("Constraint"),L1=a(" can be used to force the generation to include specific tokens or sequences in the output."),Dm=c(),k=o("div"),f(Fn.$$.fragment),E1=c(),ud=o("p"),P1=a(`Abstract base class for all constraints that can be applied during generation.
It must define how the constraint can be satisfied.`),F1=c(),_d=o("p"),S1=a("All classes that inherit Constraint must follow the requirement that"),D1=c(),f(Qr.$$.fragment),z1=c(),bd=o("p"),q1=a("will always terminate (halt)."),O1=c(),Zr=o("div"),f(Sn.$$.fragment),B1=c(),vd=o("p"),I1=a("When called, returns the token that would take this constraint one step closer to being fulfilled."),A1=c(),et=o("div"),f(Dn.$$.fragment),C1=c(),$d=o("p"),N1=a("Creates a new instance of this constraint."),W1=c(),rt=o("div"),f(zn.$$.fragment),V1=c(),Td=o("p"),M1=a("Reads in a token and returns whether it creates progress."),j1=c(),tt=o("div"),f(qn.$$.fragment),G1=c(),On=o("p"),H1=a("Returns the number of remaining steps of "),yd=o("code"),R1=a("advance()"),U1=a(" in order to complete this constraint."),K1=c(),ot=o("div"),f(Bn.$$.fragment),Y1=c(),kd=o("p"),X1=a(`Resets the state of this constraint to its initialization. We would call this in cases where the fulfillment of
a constraint is abrupted by an unwanted token.`),J1=c(),nt=o("div"),f(In.$$.fragment),Q1=c(),xd=o("p"),Z1=a("Tests whether this constraint has been properly defined."),e2=c(),Ye=o("div"),f(An.$$.fragment),r2=c(),Cn=o("p"),t2=a(`Reads in a token and returns booleans that indicate the progress made by it. This function will update the
state of this object unlikes `),wd=o("code"),o2=a("does_advance(self, token_id: int)"),n2=a("."),s2=c(),Ld=o("p"),a2=a(`This isn\u2019t to test whether a certain token will advance the progress; it\u2019s to update its state as if it has
been generated. This becomes important if token_id != desired token (refer to else statement in
PhrasalConstraint)`),zm=c(),_r=o("div"),f(Nn.$$.fragment),i2=c(),Fi=o("p"),Si=o("a"),c2=a("Constraint"),l2=a(" enforcing that an ordered sequence of tokens is included in the output."),qm=c(),br=o("div"),f(Wn.$$.fragment),d2=c(),Vn=o("p"),p2=a("A special "),Di=o("a"),m2=a("Constraint"),f2=a(" that is fulfilled by fulfilling just one of several constraints."),Om=c(),G=o("div"),f(Mn.$$.fragment),g2=c(),Ed=o("p"),h2=a("A class for beam scorers to track its progress through a list of constraints."),u2=c(),B=o("div"),f(jn.$$.fragment),_2=c(),Pd=o("p"),b2=a(`The list of tokens to generate such that we can make progress.
By \u201Clist\u201D we don\u2019t mean the list of token that will fully fulfill a constraint.`),v2=c(),vr=o("p"),$2=a("Given constraints "),Fd=o("code"),T2=a("c_i = {t_ij | j == # of tokens}"),y2=a(`, If we\u2019re not in the middle of progressing through a
specific constraint `),Sd=o("code"),k2=a("c_i"),x2=a(", we return:"),w2=c(),Dd=o("p"),zd=o("code"),L2=a("[t_k1 for k in indices of unfulfilled constraints]"),E2=c(),je=o("p"),P2=a(`If we are in the middle of a constraint, then we return:
`),qd=o("code"),F2=a("[t_ij]"),S2=a(", where "),Od=o("code"),D2=a("i"),z2=a(" is the index of the inprogress constraint, "),Bd=o("code"),q2=a("j"),O2=a(" is the next step for the constraint."),B2=c(),Id=o("p"),I2=a(`Though we don\u2019t care which constraint is fulfilled first, if we are in the progress of fulfilling a constraint,
that\u2019s the only one we\u2019ll return.`),A2=c(),st=o("div"),f(Gn.$$.fragment),C2=c(),Ad=o("p"),N2=a("token_ids: the tokens generated thus far to reset the state of the progress through constraints."),Bm=c(),$r=o("h2"),at=o("a"),Cd=o("span"),f(Hn.$$.fragment),W2=c(),Nd=o("span"),V2=a("BeamSearch"),Im=c(),H=o("div"),f(Rn.$$.fragment),M2=c(),Tr=o("p"),j2=a("Abstract base class for all beam scorers that are used for "),zi=o("a"),G2=a("beam_search()"),H2=a(` and
`),qi=o("a"),R2=a("beam_sample()"),U2=a("."),K2=c(),Oi=o("div"),f(Un.$$.fragment),Y2=c(),Bi=o("div"),f(Kn.$$.fragment),Am=c(),q=o("div"),f(Yn.$$.fragment),X2=c(),Ii=o("p"),Ai=o("a"),J2=a("BeamScorer"),Q2=a(" implementing standard beam search decoding."),Z2=c(),Xn=o("p"),e$=a("Adapted in part from "),Jn=o("a"),r$=a(`Facebook\u2019s XLM beam search
code`),t$=a("."),o$=c(),Ci=o("p"),n$=a("Reference for the diverse beam search algorithm and implementation "),Qn=o("a"),s$=a(`Ashwin Kalyan\u2019s DBS
implementation`),a$=c(),Ni=o("div"),f(Zn.$$.fragment),i$=c(),Wi=o("div"),f(es.$$.fragment),Cm=c(),R=o("div"),f(rs.$$.fragment),c$=c(),Vi=o("p"),Mi=o("a"),l$=a("BeamScorer"),d$=a(" implementing constrained beam search decoding."),p$=c(),ji=o("div"),f(ts.$$.fragment),m$=c(),Gi=o("div"),f(os.$$.fragment),Nm=c(),yr=o("h2"),it=o("a"),Wd=o("span"),f(ns.$$.fragment),f$=c(),Vd=o("span"),g$=a("Utilities"),Wm=c(),Ge=o("div"),f(ss.$$.fragment),h$=c(),Md=o("p"),u$=a("Filter a distribution of logits using top-k and/or nucleus (top-p) filtering"),_$=c(),Hi=o("p"),b$=a("From: "),as=o("a"),v$=a("https://gist.github.com/thomwolf/1a5a29f6962089e871b94cbd09daf317"),Vm=c(),He=o("div"),f(is.$$.fragment),$$=c(),jd=o("p"),T$=a("Filter a distribution of logits using top-k and/or nucleus (top-p) filtering"),y$=c(),Ri=o("p"),k$=a("From: "),cs=o("a"),x$=a("https://gist.github.com/thomwolf/1a5a29f6962089e871b94cbd09daf317"),Mm=c(),kr=o("h2"),ct=o("a"),Gd=o("span"),f(ls.$$.fragment),w$=c(),Hd=o("span"),L$=a("Streamers"),jm=c(),O=o("div"),f(ds.$$.fragment),E$=c(),Rd=o("p"),P$=a("Simple text streamer that prints the token(s) to stdout as soon as entire words are formed."),F$=c(),f(lt.$$.fragment),S$=c(),dt=o("div"),f(ps.$$.fragment),D$=c(),Ud=o("p"),z$=a("Flushes any remaining cache and prints a newline to stdout."),q$=c(),pt=o("div"),f(ms.$$.fragment),O$=c(),Kd=o("p"),B$=a("Prints the new text to stdout. If the stream is ending, also prints a newline."),I$=c(),mt=o("div"),f(fs.$$.fragment),A$=c(),Yd=o("p"),C$=a("Recives tokens, decodes them, and prints them to stdout as soon as they form entire words."),Gm=c(),U=o("div"),f(gs.$$.fragment),N$=c(),Xd=o("p"),W$=a(`Streamer that stores print-ready text in a queue, to be used by a downstream application as an iterator. This is
useful for applications that benefit from acessing the generated text in a non-blocking way (e.g. in an interactive
Gradio demo).`),V$=c(),f(ft.$$.fragment),M$=c(),gt=o("div"),f(hs.$$.fragment),j$=c(),Jd=o("p"),G$=a("Put the new text in the queue. If the stream is ending, also put a stop signal in the queue."),this.h()},l(e){const p=ex('[data-svelte="svelte-1phssyn"]',document.head);T=n(p,"META",{name:!0,content:!0}),p.forEach(t),F=l(e),y=n(e,"H1",{class:!0});var us=s(y);x=n(us,"A",{id:!0,class:!0,href:!0});var Qd=s(x);I=n(Qd,"SPAN",{});var Zd=s(I);g($.$$.fragment,Zd),Zd.forEach(t),Qd.forEach(t),S=l(us),Mc=n(us,"SPAN",{});var kT=s(Mc);Gf=i(kT,"Utilities for Generation"),kT.forEach(t),us.forEach(t),cp=l(e),L=n(e,"P",{});var P=s(L);Hf=i(P,"This page lists all the utility functions used by "),vs=n(P,"A",{href:!0});var xT=s(vs);Rf=i(xT,"generate()"),xT.forEach(t),Uf=i(P,`,
`),$s=n(P,"A",{href:!0});var wT=s($s);Kf=i(wT,"greedy_search()"),wT.forEach(t),Yf=i(P,`,
`),Ts=n(P,"A",{href:!0});var LT=s(Ts);Xf=i(LT,"contrastive_search()"),LT.forEach(t),Jf=i(P,`,
`),ys=n(P,"A",{href:!0});var ET=s(ys);Qf=i(ET,"sample()"),ET.forEach(t),Zf=i(P,`,
`),ks=n(P,"A",{href:!0});var PT=s(ks);eg=i(PT,"beam_search()"),PT.forEach(t),rg=i(P,`,
`),xs=n(P,"A",{href:!0});var FT=s(xs);tg=i(FT,"beam_sample()"),FT.forEach(t),og=i(P,`,
`),ws=n(P,"A",{href:!0});var ST=s(ws);ng=i(ST,"group_beam_search()"),ST.forEach(t),sg=i(P,`, and
`),Ls=n(P,"A",{href:!0});var DT=s(Ls);ag=i(DT,"constrained_beam_search()"),DT.forEach(t),ig=i(P,"."),P.forEach(t),lp=l(e),Es=n(e,"P",{});var zT=s(Es);cg=i(zT,"Most of those are only useful if you are studying the code of the generate methods in the library."),zT.forEach(t),dp=l(e),er=n(e,"H2",{class:!0});var Rm=s(er);wr=n(Rm,"A",{id:!0,class:!0,href:!0});var qT=s(wr);jc=n(qT,"SPAN",{});var OT=s(jc);g(yt.$$.fragment,OT),OT.forEach(t),qT.forEach(t),lg=l(Rm),Gc=n(Rm,"SPAN",{});var BT=s(Gc);dg=i(BT,"Generate Outputs"),BT.forEach(t),Rm.forEach(t),pp=l(e),K=n(e,"P",{});var ht=s(K);pg=i(ht,"The output of "),Ps=n(ht,"A",{href:!0});var IT=s(Ps);mg=i(IT,"generate()"),IT.forEach(t),fg=i(ht,` is an instance of a subclass of
`),Fs=n(ht,"A",{href:!0});var AT=s(Fs);gg=i(AT,"ModelOutput"),AT.forEach(t),hg=i(ht,`. This output is a data structure containing all the information returned
by `),Ss=n(ht,"A",{href:!0});var CT=s(Ss);ug=i(CT,"generate()"),CT.forEach(t),_g=i(ht,", but that can also be used as tuple or dictionary."),ht.forEach(t),mp=l(e),Ds=n(e,"P",{});var NT=s(Ds);bg=i(NT,"Here\u2019s an example:"),NT.forEach(t),fp=l(e),g(kt.$$.fragment,e),gp=l(e),Re=n(e,"P",{});var Ui=s(Re);vg=i(Ui,"The "),Hc=n(Ui,"CODE",{});var WT=s(Hc);$g=i(WT,"generation_output"),WT.forEach(t),Tg=i(Ui," object is a "),zs=n(Ui,"A",{href:!0});var VT=s(zs);yg=i(VT,"GreedySearchDecoderOnlyOutput"),VT.forEach(t),kg=i(Ui,`, as we can
see in the documentation of that class below, it means it has the following attributes:`),Ui.forEach(t),hp=l(e),Y=n(e,"UL",{});var ut=s(Y);qs=n(ut,"LI",{});var H$=s(qs);Rc=n(H$,"CODE",{});var MT=s(Rc);xg=i(MT,"sequences"),MT.forEach(t),wg=i(H$,": the generated sequences of tokens"),H$.forEach(t),Lg=l(ut),Os=n(ut,"LI",{});var R$=s(Os);Uc=n(R$,"CODE",{});var jT=s(Uc);Eg=i(jT,"scores"),jT.forEach(t),Pg=i(R$," (optional): the prediction scores of the language modelling head, for each generation step"),R$.forEach(t),Fg=l(ut),Bs=n(ut,"LI",{});var U$=s(Bs);Kc=n(U$,"CODE",{});var GT=s(Kc);Sg=i(GT,"hidden_states"),GT.forEach(t),Dg=i(U$," (optional): the hidden states of the model, for each generation step"),U$.forEach(t),zg=l(ut),Is=n(ut,"LI",{});var K$=s(Is);Yc=n(K$,"CODE",{});var HT=s(Yc);qg=i(HT,"attentions"),HT.forEach(t),Og=i(K$," (optional): the attention weights of the model, for each generation step"),K$.forEach(t),ut.forEach(t),up=l(e),E=n(e,"P",{});var W=s(E);Bg=i(W,"Here we have the "),Xc=n(W,"CODE",{});var RT=s(Xc);Ig=i(RT,"scores"),RT.forEach(t),Ag=i(W," since we passed along "),Jc=n(W,"CODE",{});var UT=s(Jc);Cg=i(UT,"output_scores=True"),UT.forEach(t),Ng=i(W,", but we don\u2019t have "),Qc=n(W,"CODE",{});var KT=s(Qc);Wg=i(KT,"hidden_states"),KT.forEach(t),Vg=i(W,` and
`),Zc=n(W,"CODE",{});var YT=s(Zc);Mg=i(YT,"attentions"),YT.forEach(t),jg=i(W," because we didn\u2019t pass "),el=n(W,"CODE",{});var XT=s(el);Gg=i(XT,"output_hidden_states=True"),XT.forEach(t),Hg=i(W," or "),rl=n(W,"CODE",{});var JT=s(rl);Rg=i(JT,"output_attentions=True"),JT.forEach(t),Ug=i(W,"."),W.forEach(t),_p=l(e),A=n(e,"P",{});var Xe=s(A);Kg=i(Xe,`You can access each attribute as you would usually do, and if that attribute has not been returned by the model, you
will get `),tl=n(Xe,"CODE",{});var QT=s(tl);Yg=i(QT,"None"),QT.forEach(t),Xg=i(Xe,". Here for instance "),ol=n(Xe,"CODE",{});var ZT=s(ol);Jg=i(ZT,"generation_output.scores"),ZT.forEach(t),Qg=i(Xe,` are all the generated prediction scores of the
language modeling head, and `),nl=n(Xe,"CODE",{});var e4=s(nl);Zg=i(e4,"generation_output.attentions"),e4.forEach(t),eh=i(Xe," is "),sl=n(Xe,"CODE",{});var r4=s(sl);rh=i(r4,"None"),r4.forEach(t),th=i(Xe,"."),Xe.forEach(t),bp=l(e),C=n(e,"P",{});var Je=s(C);oh=i(Je,"When using our "),al=n(Je,"CODE",{});var t4=s(al);nh=i(t4,"generation_output"),t4.forEach(t),sh=i(Je," object as a tuple, it only keeps the attributes that don\u2019t have "),il=n(Je,"CODE",{});var o4=s(il);ah=i(o4,"None"),o4.forEach(t),ih=i(Je,` values.
Here, for instance, it has two elements, `),cl=n(Je,"CODE",{});var n4=s(cl);ch=i(n4,"loss"),n4.forEach(t),lh=i(Je," then "),ll=n(Je,"CODE",{});var s4=s(ll);dh=i(s4,"logits"),s4.forEach(t),ph=i(Je,", so"),Je.forEach(t),vp=l(e),g(xt.$$.fragment,e),$p=l(e),Lr=n(e,"P",{});var Um=s(Lr);mh=i(Um,"will return the tuple "),dl=n(Um,"CODE",{});var a4=s(dl);fh=i(a4,"(generation_output.sequences, generation_output.scores)"),a4.forEach(t),gh=i(Um," for instance."),Um.forEach(t),Tp=l(e),N=n(e,"P",{});var Qe=s(N);hh=i(Qe,"When using our "),pl=n(Qe,"CODE",{});var i4=s(pl);uh=i(i4,"generation_output"),i4.forEach(t),_h=i(Qe," object as a dictionary, it only keeps the attributes that don\u2019t have "),ml=n(Qe,"CODE",{});var c4=s(ml);bh=i(c4,"None"),c4.forEach(t),vh=i(Qe,`
values. Here, for instance, it has two keys that are `),fl=n(Qe,"CODE",{});var l4=s(fl);$h=i(l4,"sequences"),l4.forEach(t),Th=i(Qe," and "),gl=n(Qe,"CODE",{});var d4=s(gl);yh=i(d4,"scores"),d4.forEach(t),kh=i(Qe,"."),Qe.forEach(t),yp=l(e),As=n(e,"P",{});var p4=s(As);xh=i(p4,"We document here all output types."),p4.forEach(t),kp=l(e),rr=n(e,"H3",{class:!0});var Km=s(rr);Er=n(Km,"A",{id:!0,class:!0,href:!0});var m4=s(Er);hl=n(m4,"SPAN",{});var f4=s(hl);g(wt.$$.fragment,f4),f4.forEach(t),m4.forEach(t),wh=l(Km),ul=n(Km,"SPAN",{});var g4=s(ul);Lh=i(g4,"GreedySearchOutput"),g4.forEach(t),Km.forEach(t),xp=l(e),tr=n(e,"DIV",{class:!0});var Ym=s(tr);g(Lt.$$.fragment,Ym),Eh=l(Ym),_l=n(Ym,"P",{});var h4=s(_l);Ph=i(h4,"Base class for outputs of decoder-only generation models using greedy search."),h4.forEach(t),Ym.forEach(t),wp=l(e),or=n(e,"DIV",{class:!0});var Xm=s(or);g(Et.$$.fragment,Xm),Fh=l(Xm),bl=n(Xm,"P",{});var u4=s(bl);Sh=i(u4,`Base class for outputs of encoder-decoder generation models using greedy search. Hidden states and attention
weights of the decoder (respectively the encoder) can be accessed via the encoder_attentions and the
encoder_hidden_states attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),u4.forEach(t),Xm.forEach(t),Lp=l(e),ee=n(e,"DIV",{class:!0});var Ki=s(ee);g(Pt.$$.fragment,Ki),Dh=l(Ki),vl=n(Ki,"P",{});var _4=s(vl);zh=i(_4,"Flax Base class for outputs of decoder-only generation models using greedy search."),_4.forEach(t),qh=l(Ki),Pr=n(Ki,"DIV",{class:!0});var Jm=s(Pr);g(Ft.$$.fragment,Jm),Oh=l(Jm),$l=n(Jm,"P",{});var b4=s($l);Bh=i(b4,"\u201CReturns a new object replacing the specified fields with new values."),b4.forEach(t),Jm.forEach(t),Ki.forEach(t),Ep=l(e),nr=n(e,"H3",{class:!0});var Qm=s(nr);Fr=n(Qm,"A",{id:!0,class:!0,href:!0});var v4=s(Fr);Tl=n(v4,"SPAN",{});var $4=s(Tl);g(St.$$.fragment,$4),$4.forEach(t),v4.forEach(t),Ih=l(Qm),yl=n(Qm,"SPAN",{});var T4=s(yl);Ah=i(T4,"SampleOutput"),T4.forEach(t),Qm.forEach(t),Pp=l(e),sr=n(e,"DIV",{class:!0});var Zm=s(sr);g(Dt.$$.fragment,Zm),Ch=l(Zm),kl=n(Zm,"P",{});var y4=s(kl);Nh=i(y4,"Base class for outputs of decoder-only generation models using sampling."),y4.forEach(t),Zm.forEach(t),Fp=l(e),ar=n(e,"DIV",{class:!0});var ef=s(ar);g(zt.$$.fragment,ef),Wh=l(ef),xl=n(ef,"P",{});var k4=s(xl);Vh=i(k4,`Base class for outputs of encoder-decoder generation models using sampling. Hidden states and attention weights of
the decoder (respectively the encoder) can be accessed via the encoder_attentions and the encoder_hidden_states
attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),k4.forEach(t),ef.forEach(t),Sp=l(e),re=n(e,"DIV",{class:!0});var Yi=s(re);g(qt.$$.fragment,Yi),Mh=l(Yi),wl=n(Yi,"P",{});var x4=s(wl);jh=i(x4,"Flax Base class for outputs of decoder-only generation models using sampling."),x4.forEach(t),Gh=l(Yi),Sr=n(Yi,"DIV",{class:!0});var rf=s(Sr);g(Ot.$$.fragment,rf),Hh=l(rf),Ll=n(rf,"P",{});var w4=s(Ll);Rh=i(w4,"\u201CReturns a new object replacing the specified fields with new values."),w4.forEach(t),rf.forEach(t),Yi.forEach(t),Dp=l(e),ir=n(e,"H3",{class:!0});var tf=s(ir);Dr=n(tf,"A",{id:!0,class:!0,href:!0});var L4=s(Dr);El=n(L4,"SPAN",{});var E4=s(El);g(Bt.$$.fragment,E4),E4.forEach(t),L4.forEach(t),Uh=l(tf),Pl=n(tf,"SPAN",{});var P4=s(Pl);Kh=i(P4,"BeamSearchOutput"),P4.forEach(t),tf.forEach(t),zp=l(e),cr=n(e,"DIV",{class:!0});var of=s(cr);g(It.$$.fragment,of),Yh=l(of),Fl=n(of,"P",{});var F4=s(Fl);Xh=i(F4,"Base class for outputs of decoder-only generation models using beam search."),F4.forEach(t),of.forEach(t),qp=l(e),lr=n(e,"DIV",{class:!0});var nf=s(lr);g(At.$$.fragment,nf),Jh=l(nf),Sl=n(nf,"P",{});var S4=s(Sl);Qh=i(S4,`Base class for outputs of encoder-decoder generation models using beam search. Hidden states and attention weights
of the decoder (respectively the encoder) can be accessed via the encoder_attentions and the encoder_hidden_states
attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),S4.forEach(t),nf.forEach(t),Op=l(e),dr=n(e,"H3",{class:!0});var sf=s(dr);zr=n(sf,"A",{id:!0,class:!0,href:!0});var D4=s(zr);Dl=n(D4,"SPAN",{});var z4=s(Dl);g(Ct.$$.fragment,z4),z4.forEach(t),D4.forEach(t),Zh=l(sf),zl=n(sf,"SPAN",{});var q4=s(zl);eu=i(q4,"BeamSampleOutput"),q4.forEach(t),sf.forEach(t),Bp=l(e),pr=n(e,"DIV",{class:!0});var af=s(pr);g(Nt.$$.fragment,af),ru=l(af),ql=n(af,"P",{});var O4=s(ql);tu=i(O4,"Base class for outputs of decoder-only generation models using beam sample."),O4.forEach(t),af.forEach(t),Ip=l(e),mr=n(e,"DIV",{class:!0});var cf=s(mr);g(Wt.$$.fragment,cf),ou=l(cf),Ol=n(cf,"P",{});var B4=s(Ol);nu=i(B4,`Base class for outputs of encoder-decoder generation models using beam sampling. Hidden states and attention
weights of the decoder (respectively the encoder) can be accessed via the encoder_attentions and the
encoder_hidden_states attributes (respectively the decoder_attentions and the decoder_hidden_states attributes)`),B4.forEach(t),cf.forEach(t),Ap=l(e),fr=n(e,"H2",{class:!0});var lf=s(fr);qr=n(lf,"A",{id:!0,class:!0,href:!0});var I4=s(qr);Bl=n(I4,"SPAN",{});var A4=s(Bl);g(Vt.$$.fragment,A4),A4.forEach(t),I4.forEach(t),su=l(lf),Il=n(lf,"SPAN",{});var C4=s(Il);au=i(C4,"LogitsProcessor"),C4.forEach(t),lf.forEach(t),Cp=l(e),Or=n(e,"P",{});var df=s(Or);iu=i(df,"A "),Cs=n(df,"A",{href:!0});var N4=s(Cs);cu=i(N4,"LogitsProcessor"),N4.forEach(t),lu=i(df,` can be used to modify the prediction scores of a language model head for
generation.`),df.forEach(t),Np=l(e),te=n(e,"DIV",{class:!0});var Xi=s(te);g(Mt.$$.fragment,Xi),du=l(Xi),Al=n(Xi,"P",{});var W4=s(Al);pu=i(W4,"Abstract base class for all logit processors that can be applied during generation."),W4.forEach(t),mu=l(Xi),Br=n(Xi,"DIV",{class:!0});var pf=s(Br);g(jt.$$.fragment,pf),fu=l(pf),Cl=n(pf,"P",{});var V4=s(Cl);gu=i(V4,"Torch method for processing logits."),V4.forEach(t),pf.forEach(t),Xi.forEach(t),Wp=l(e),oe=n(e,"DIV",{class:!0});var Ji=s(oe);g(Gt.$$.fragment,Ji),hu=l(Ji),D=n(Ji,"P",{});var V=s(D);uu=i(V,"This class can be used to create a list of "),Ns=n(V,"A",{href:!0});var M4=s(Ns);_u=i(M4,"LogitsProcessor"),M4.forEach(t),bu=i(V," or "),Ws=n(V,"A",{href:!0});var j4=s(Ws);vu=i(j4,"LogitsWarper"),j4.forEach(t),$u=i(V,` to subsequently process a
`),Nl=n(V,"CODE",{});var G4=s(Nl);Tu=i(G4,"scores"),G4.forEach(t),yu=i(V," input tensor. This class inherits from list and adds a specific "),Wl=n(V,"EM",{});var H4=s(Wl);Vl=n(H4,"STRONG",{});var R4=s(Vl);ku=i(R4,"call"),R4.forEach(t),H4.forEach(t),xu=i(V,` method to apply each
`),Vs=n(V,"A",{href:!0});var U4=s(Vs);wu=i(U4,"LogitsProcessor"),U4.forEach(t),Lu=i(V," or "),Ms=n(V,"A",{href:!0});var K4=s(Ms);Eu=i(K4,"LogitsWarper"),K4.forEach(t),Pu=i(V," to the inputs."),V.forEach(t),Fu=l(Ji),js=n(Ji,"DIV",{class:!0});var Y4=s(js);g(Ht.$$.fragment,Y4),Y4.forEach(t),Ji.forEach(t),Vp=l(e),ne=n(e,"DIV",{class:!0});var Qi=s(ne);g(Rt.$$.fragment,Qi),Su=l(Qi),Ml=n(Qi,"P",{});var X4=s(Ml);Du=i(X4,"Abstract base class for all logit warpers that can be applied during generation with multinomial sampling."),X4.forEach(t),zu=l(Qi),Ir=n(Qi,"DIV",{class:!0});var mf=s(Ir);g(Ut.$$.fragment,mf),qu=l(mf),jl=n(mf,"P",{});var J4=s(jl);Ou=i(J4,"Torch method for warping logits."),J4.forEach(t),mf.forEach(t),Qi.forEach(t),Mp=l(e),se=n(e,"DIV",{class:!0});var Zi=s(se);g(Kt.$$.fragment,Zi),Bu=l(Zi),Gs=n(Zi,"P",{});var Y$=s(Gs);Hs=n(Y$,"A",{href:!0});var Q4=s(Hs);Iu=i(Q4,"LogitsProcessor"),Q4.forEach(t),Au=i(Y$," enforcing a min-length by setting EOS probability to 0."),Y$.forEach(t),Cu=l(Zi),Rs=n(Zi,"DIV",{class:!0});var Z4=s(Rs);g(Yt.$$.fragment,Z4),Z4.forEach(t),Zi.forEach(t),jp=l(e),ae=n(e,"DIV",{class:!0});var ec=s(ae);g(Xt.$$.fragment,ec),Nu=l(ec),Us=n(ec,"P",{});var X$=s(Us);Ks=n(X$,"A",{href:!0});var ey=s(Ks);Wu=i(ey,"LogitsProcessor"),ey.forEach(t),Vu=i(X$," enforcing a min-length of new tokens by setting EOS (End-Of-Sequence) token probability to 0."),X$.forEach(t),Mu=l(ec),Ys=n(ec,"DIV",{class:!0});var ry=s(Ys);g(Jt.$$.fragment,ry),ry.forEach(t),ec.forEach(t),Gp=l(e),ie=n(e,"DIV",{class:!0});var rc=s(ie);g(Qt.$$.fragment,rc),ju=l(rc),Xs=n(rc,"P",{});var J$=s(Xs);Js=n(J$,"A",{href:!0});var ty=s(Js);Gu=i(ty,"LogitsWarper"),ty.forEach(t),Hu=i(J$," for temperature (exponential scaling output probability distribution)."),J$.forEach(t),Ru=l(rc),Qs=n(rc,"DIV",{class:!0});var oy=s(Qs);g(Zt.$$.fragment,oy),oy.forEach(t),rc.forEach(t),Hp=l(e),ce=n(e,"DIV",{class:!0});var tc=s(ce);g(eo.$$.fragment,tc),Uu=l(tc),Zs=n(tc,"P",{});var Q$=s(Zs);ea=n(Q$,"A",{href:!0});var ny=s(ea);Ku=i(ny,"LogitsProcessor"),ny.forEach(t),Yu=i(Q$," enforcing an exponential penalty on repeated sequences."),Q$.forEach(t),Xu=l(tc),ra=n(tc,"DIV",{class:!0});var sy=s(ra);g(ro.$$.fragment,sy),sy.forEach(t),tc.forEach(t),Rp=l(e),le=n(e,"DIV",{class:!0});var oc=s(le);g(to.$$.fragment,oc),Ju=l(oc),ta=n(oc,"P",{});var Z$=s(ta);oa=n(Z$,"A",{href:!0});var ay=s(oa);Qu=i(ay,"LogitsWarper"),ay.forEach(t),Zu=i(Z$," that performs top-p, i.e. restricting to top tokens summing to prob_cut_off <= prob_cut_off."),Z$.forEach(t),e_=l(oc),na=n(oc,"DIV",{class:!0});var iy=s(na);g(oo.$$.fragment,iy),iy.forEach(t),oc.forEach(t),Up=l(e),de=n(e,"DIV",{class:!0});var nc=s(de);g(no.$$.fragment,nc),r_=l(nc),sa=n(nc,"P",{});var eT=s(sa);aa=n(eT,"A",{href:!0});var cy=s(aa);t_=i(cy,"LogitsWarper"),cy.forEach(t),o_=i(eT," that performs top-k, i.e. restricting to the k highest probability elements."),eT.forEach(t),n_=l(nc),ia=n(nc,"DIV",{class:!0});var ly=s(ia);g(so.$$.fragment,ly),ly.forEach(t),nc.forEach(t),Kp=l(e),pe=n(e,"DIV",{class:!0});var sc=s(pe);g(ao.$$.fragment,sc),s_=l(sc),Ar=n(sc,"P",{});var ep=s(Ar);ca=n(ep,"A",{href:!0});var dy=s(ca);a_=i(dy,"LogitsWarper"),dy.forEach(t),i_=i(ep," that performs typical decoding. See "),io=n(ep,"A",{href:!0,rel:!0});var py=s(io);c_=i(py,`Typical Decoding for Natural Language
Generation`),py.forEach(t),l_=i(ep," for more information."),ep.forEach(t),d_=l(sc),la=n(sc,"DIV",{class:!0});var my=s(la);g(co.$$.fragment,my),my.forEach(t),sc.forEach(t),Yp=l(e),me=n(e,"DIV",{class:!0});var ac=s(me);g(lo.$$.fragment,ac),p_=l(ac),Cr=n(ac,"P",{});var rp=s(Cr);da=n(rp,"A",{href:!0});var fy=s(da);m_=i(fy,"LogitsProcessor"),fy.forEach(t),f_=i(rp,` that enforces no repetition of n-grams. See
`),po=n(rp,"A",{href:!0,rel:!0});var gy=s(po);g_=i(gy,"Fairseq"),gy.forEach(t),h_=i(rp,"."),rp.forEach(t),u_=l(ac),pa=n(ac,"DIV",{class:!0});var hy=s(pa);g(mo.$$.fragment,hy),hy.forEach(t),ac.forEach(t),Xp=l(e),fe=n(e,"DIV",{class:!0});var ic=s(fe);g(fo.$$.fragment,ic),__=l(ic),ma=n(ic,"P",{});var rT=s(ma);fa=n(rT,"A",{href:!0});var uy=s(fa);b_=i(uy,"LogitsProcessor"),uy.forEach(t),v_=i(rT," that enforces that specified sequences will never be sampled."),rT.forEach(t),$_=l(ic),ga=n(ic,"DIV",{class:!0});var _y=s(ga);g(go.$$.fragment,_y),_y.forEach(t),ic.forEach(t),Jp=l(e),ge=n(e,"DIV",{class:!0});var cc=s(ge);g(ho.$$.fragment,cc),T_=l(cc),Nr=n(cc,"P",{});var tp=s(Nr);ha=n(tp,"A",{href:!0});var by=s(ha);y_=i(by,"LogitsProcessor"),by.forEach(t),k_=i(tp,` that enforces constrained generation and is useful for prefix-conditioned constrained
generation. See `),uo=n(tp,"A",{href:!0,rel:!0});var vy=s(uo);x_=i(vy,"Autoregressive Entity Retrieval"),vy.forEach(t),w_=i(tp," for more information."),tp.forEach(t),L_=l(cc),ua=n(cc,"DIV",{class:!0});var $y=s(ua);g(_o.$$.fragment,$y),$y.forEach(t),cc.forEach(t),Qp=l(e),he=n(e,"DIV",{class:!0});var lc=s(he);g(bo.$$.fragment,lc),E_=l(lc),Ue=n(lc,"P",{});var _s=s(Ue);_a=n(_s,"A",{href:!0});var Ty=s(_a);P_=i(Ty,"LogitsProcessor"),Ty.forEach(t),F_=i(_s,` that enforces diverse beam search. Note that this logits processor is only effective for
`),ba=n(_s,"A",{href:!0});var yy=s(ba);S_=i(yy,"PreTrainedModel.group_beam_search()"),yy.forEach(t),D_=i(_s,". See "),vo=n(_s,"A",{href:!0,rel:!0});var ky=s(vo);z_=i(ky,`Diverse Beam Search: Decoding Diverse Solutions from Neural Sequence
Models`),ky.forEach(t),q_=i(_s," for more details."),_s.forEach(t),O_=l(lc),va=n(lc,"DIV",{class:!0});var xy=s(va);g($o.$$.fragment,xy),xy.forEach(t),lc.forEach(t),Zp=l(e),ue=n(e,"DIV",{class:!0});var dc=s(ue);g(To.$$.fragment,dc),B_=l(dc),$a=n(dc,"P",{});var tT=s($a);Ta=n(tT,"A",{href:!0});var wy=s(Ta);I_=i(wy,"LogitsProcessor"),wy.forEach(t),A_=i(tT," that enforces the specified token as the first generated token."),tT.forEach(t),C_=l(dc),ya=n(dc,"DIV",{class:!0});var Ly=s(ya);g(yo.$$.fragment,Ly),Ly.forEach(t),dc.forEach(t),em=l(e),_e=n(e,"DIV",{class:!0});var pc=s(_e);g(ko.$$.fragment,pc),N_=l(pc),Wr=n(pc,"P",{});var op=s(Wr);ka=n(op,"A",{href:!0});var Ey=s(ka);W_=i(Ey,"LogitsProcessor"),Ey.forEach(t),V_=i(op," that enforces the specified token as the last generated token when "),Gl=n(op,"CODE",{});var Py=s(Gl);M_=i(Py,"max_length"),Py.forEach(t),j_=i(op," is reached."),op.forEach(t),G_=l(pc),xa=n(pc,"DIV",{class:!0});var Fy=s(xa);g(xo.$$.fragment,Fy),Fy.forEach(t),pc.forEach(t),rm=l(e),be=n(e,"DIV",{class:!0});var mc=s(be);g(wo.$$.fragment,mc),H_=l(mc),Ke=n(mc,"P",{});var bs=s(Ke);wa=n(bs,"A",{href:!0});var Sy=s(wa);R_=i(Sy,"LogitsProcessor"),Sy.forEach(t),U_=i(bs," that removes all "),Hl=n(bs,"CODE",{});var Dy=s(Hl);K_=i(Dy,"nan"),Dy.forEach(t),Y_=i(bs," and "),Rl=n(bs,"CODE",{});var zy=s(Rl);X_=i(zy,"inf"),zy.forEach(t),J_=i(bs,` values to avoid the generation method to fail. Note that using
the logits processor should only be used if necessary since it can slow down the generation method.`),bs.forEach(t),Q_=l(mc),La=n(mc,"DIV",{class:!0});var qy=s(La);g(Lo.$$.fragment,qy),qy.forEach(t),mc.forEach(t),tm=l(e),ve=n(e,"DIV",{class:!0});var fc=s(ve);g(Eo.$$.fragment,fc),Z_=l(fc),Ul=n(fc,"P",{});var Oy=s(Ul);eb=i(Oy,"Abstract base class for all logit processors that can be applied during generation."),Oy.forEach(t),rb=l(fc),Vr=n(fc,"DIV",{class:!0});var ff=s(Vr);g(Po.$$.fragment,ff),tb=l(ff),Kl=n(ff,"P",{});var By=s(Kl);ob=i(By,"TF method for processing logits."),By.forEach(t),ff.forEach(t),fc.forEach(t),om=l(e),$e=n(e,"DIV",{class:!0});var gc=s($e);g(Fo.$$.fragment,gc),nb=l(gc),j=n(gc,"P",{});var Ze=s(j);sb=i(Ze,"This class can be used to create a list of "),Ea=n(Ze,"A",{href:!0});var Iy=s(Ea);ab=i(Iy,"TFLogitsProcessor"),Iy.forEach(t),ib=i(Ze," to subsequently process a "),Yl=n(Ze,"CODE",{});var Ay=s(Yl);cb=i(Ay,"scores"),Ay.forEach(t),lb=i(Ze,` input tensor.
This class inherits from list and adds a specific `),Xl=n(Ze,"EM",{});var Cy=s(Xl);Jl=n(Cy,"STRONG",{});var Ny=s(Jl);db=i(Ny,"call"),Ny.forEach(t),Cy.forEach(t),pb=i(Ze," method to apply each "),Pa=n(Ze,"A",{href:!0});var Wy=s(Pa);mb=i(Wy,"TFLogitsProcessor"),Wy.forEach(t),fb=i(Ze,` to the
inputs.`),Ze.forEach(t),gb=l(gc),Fa=n(gc,"DIV",{class:!0});var Vy=s(Fa);g(So.$$.fragment,Vy),Vy.forEach(t),gc.forEach(t),nm=l(e),Te=n(e,"DIV",{class:!0});var hc=s(Te);g(Do.$$.fragment,hc),hb=l(hc),Ql=n(hc,"P",{});var My=s(Ql);ub=i(My,"Abstract base class for all logit warpers that can be applied during generation with multinomial sampling."),My.forEach(t),_b=l(hc),Mr=n(hc,"DIV",{class:!0});var gf=s(Mr);g(zo.$$.fragment,gf),bb=l(gf),Zl=n(gf,"P",{});var jy=s(Zl);vb=i(jy,"TF method for warping logits."),jy.forEach(t),gf.forEach(t),hc.forEach(t),sm=l(e),ye=n(e,"DIV",{class:!0});var uc=s(ye);g(qo.$$.fragment,uc),$b=l(uc),Sa=n(uc,"P",{});var oT=s(Sa);Da=n(oT,"A",{href:!0});var Gy=s(Da);Tb=i(Gy,"TFLogitsWarper"),Gy.forEach(t),yb=i(oT," for temperature (exponential scaling output probability distribution)."),oT.forEach(t),kb=l(uc),za=n(uc,"DIV",{class:!0});var Hy=s(za);g(Oo.$$.fragment,Hy),Hy.forEach(t),uc.forEach(t),am=l(e),ke=n(e,"DIV",{class:!0});var _c=s(ke);g(Bo.$$.fragment,_c),xb=l(_c),qa=n(_c,"P",{});var nT=s(qa);Oa=n(nT,"A",{href:!0});var Ry=s(Oa);wb=i(Ry,"TFLogitsWarper"),Ry.forEach(t),Lb=i(nT," that performs top-p, i.e. restricting to top tokens summing to <= prob_cut_off."),nT.forEach(t),Eb=l(_c),Ba=n(_c,"DIV",{class:!0});var Uy=s(Ba);g(Io.$$.fragment,Uy),Uy.forEach(t),_c.forEach(t),im=l(e),xe=n(e,"DIV",{class:!0});var bc=s(xe);g(Ao.$$.fragment,bc),Pb=l(bc),Ia=n(bc,"P",{});var sT=s(Ia);Aa=n(sT,"A",{href:!0});var Ky=s(Aa);Fb=i(Ky,"TFLogitsWarper"),Ky.forEach(t),Sb=i(sT," that performs top-k, i.e. restricting to the k highest probability elements."),sT.forEach(t),Db=l(bc),Ca=n(bc,"DIV",{class:!0});var Yy=s(Ca);g(Co.$$.fragment,Yy),Yy.forEach(t),bc.forEach(t),cm=l(e),we=n(e,"DIV",{class:!0});var vc=s(we);g(No.$$.fragment,vc),zb=l(vc),Na=n(vc,"P",{});var aT=s(Na);Wa=n(aT,"A",{href:!0});var Xy=s(Wa);qb=i(Xy,"TFLogitsProcessor"),Xy.forEach(t),Ob=i(aT," enforcing a min-length by setting EOS probability to 0."),aT.forEach(t),Bb=l(vc),Va=n(vc,"DIV",{class:!0});var Jy=s(Va);g(Wo.$$.fragment,Jy),Jy.forEach(t),vc.forEach(t),lm=l(e),Le=n(e,"DIV",{class:!0});var $c=s(Le);g(Vo.$$.fragment,$c),Ib=l($c),Ma=n($c,"P",{});var iT=s(Ma);ja=n(iT,"A",{href:!0});var Qy=s(ja);Ab=i(Qy,"TFLogitsProcessor"),Qy.forEach(t),Cb=i(iT," that enforces that specified sequences will never be sampled."),iT.forEach(t),Nb=l($c),Ga=n($c,"DIV",{class:!0});var Zy=s(Ga);g(Mo.$$.fragment,Zy),Zy.forEach(t),$c.forEach(t),dm=l(e),Ee=n(e,"DIV",{class:!0});var Tc=s(Ee);g(jo.$$.fragment,Tc),Wb=l(Tc),jr=n(Tc,"P",{});var np=s(jr);Ha=n(np,"A",{href:!0});var ek=s(Ha);Vb=i(ek,"TFLogitsProcessor"),ek.forEach(t),Mb=i(np,` that enforces no repetition of n-grams. See
`),Go=n(np,"A",{href:!0,rel:!0});var rk=s(Go);jb=i(rk,"Fairseq"),rk.forEach(t),Gb=i(np,"."),np.forEach(t),Hb=l(Tc),Ra=n(Tc,"DIV",{class:!0});var tk=s(Ra);g(Ho.$$.fragment,tk),tk.forEach(t),Tc.forEach(t),pm=l(e),Pe=n(e,"DIV",{class:!0});var yc=s(Pe);g(Ro.$$.fragment,yc),Rb=l(yc),Ua=n(yc,"P",{});var cT=s(Ua);Ka=n(cT,"A",{href:!0});var ok=s(Ka);Ub=i(ok,"TFLogitsProcessor"),ok.forEach(t),Kb=i(cT," enforcing an exponential penalty on repeated sequences."),cT.forEach(t),Yb=l(yc),Ya=n(yc,"DIV",{class:!0});var nk=s(Ya);g(Uo.$$.fragment,nk),nk.forEach(t),yc.forEach(t),mm=l(e),Fe=n(e,"DIV",{class:!0});var kc=s(Fe);g(Ko.$$.fragment,kc),Xb=l(kc),Xa=n(kc,"P",{});var lT=s(Xa);Ja=n(lT,"A",{href:!0});var sk=s(Ja);Jb=i(sk,"TFLogitsProcessor"),sk.forEach(t),Qb=i(lT," that enforces the specified token as the first generated token."),lT.forEach(t),Zb=l(kc),Qa=n(kc,"DIV",{class:!0});var ak=s(Qa);g(Yo.$$.fragment,ak),ak.forEach(t),kc.forEach(t),fm=l(e),Se=n(e,"DIV",{class:!0});var xc=s(Se);g(Xo.$$.fragment,xc),ev=l(xc),Gr=n(xc,"P",{});var sp=s(Gr);Za=n(sp,"A",{href:!0});var ik=s(Za);rv=i(ik,"TFLogitsProcessor"),ik.forEach(t),tv=i(sp," that enforces the specified token as the last generated token when "),ed=n(sp,"CODE",{});var ck=s(ed);ov=i(ck,"max_length"),ck.forEach(t),nv=i(sp," is reached."),sp.forEach(t),sv=l(xc),ei=n(xc,"DIV",{class:!0});var lk=s(ei);g(Jo.$$.fragment,lk),lk.forEach(t),xc.forEach(t),gm=l(e),De=n(e,"DIV",{class:!0});var wc=s(De);g(Qo.$$.fragment,wc),av=l(wc),rd=n(wc,"P",{});var dk=s(rd);iv=i(dk,"Abstract base class for all logit processors that can be applied during generation."),dk.forEach(t),cv=l(wc),Hr=n(wc,"DIV",{class:!0});var hf=s(Hr);g(Zo.$$.fragment,hf),lv=l(hf),td=n(hf,"P",{});var pk=s(td);dv=i(pk,"Flax method for processing logits."),pk.forEach(t),hf.forEach(t),wc.forEach(t),hm=l(e),ze=n(e,"DIV",{class:!0});var Lc=s(ze);g(en.$$.fragment,Lc),pv=l(Lc),z=n(Lc,"P",{});var M=s(z);mv=i(M,"This class can be used to create a list of "),ri=n(M,"A",{href:!0});var mk=s(ri);fv=i(mk,"FlaxLogitsProcessor"),mk.forEach(t),gv=i(M," or "),ti=n(M,"A",{href:!0});var fk=s(ti);hv=i(fk,"FlaxLogitsWarper"),fk.forEach(t),uv=i(M,` to subsequently process
a `),od=n(M,"CODE",{});var gk=s(od);_v=i(gk,"scores"),gk.forEach(t),bv=i(M," input tensor. This class inherits from list and adds a specific "),nd=n(M,"EM",{});var hk=s(nd);sd=n(hk,"STRONG",{});var uk=s(sd);vv=i(uk,"call"),uk.forEach(t),hk.forEach(t),$v=i(M,` method to apply each
`),oi=n(M,"A",{href:!0});var _k=s(oi);Tv=i(_k,"FlaxLogitsProcessor"),_k.forEach(t),yv=i(M," or "),ni=n(M,"A",{href:!0});var bk=s(ni);kv=i(bk,"FlaxLogitsWarper"),bk.forEach(t),xv=i(M," to the inputs."),M.forEach(t),wv=l(Lc),si=n(Lc,"DIV",{class:!0});var vk=s(si);g(rn.$$.fragment,vk),vk.forEach(t),Lc.forEach(t),um=l(e),qe=n(e,"DIV",{class:!0});var Ec=s(qe);g(tn.$$.fragment,Ec),Lv=l(Ec),ad=n(Ec,"P",{});var $k=s(ad);Ev=i($k,"Abstract base class for all logit warpers that can be applied during generation with multinomial sampling."),$k.forEach(t),Pv=l(Ec),Rr=n(Ec,"DIV",{class:!0});var uf=s(Rr);g(on.$$.fragment,uf),Fv=l(uf),id=n(uf,"P",{});var Tk=s(id);Sv=i(Tk,"Flax method for warping logits."),Tk.forEach(t),uf.forEach(t),Ec.forEach(t),_m=l(e),Oe=n(e,"DIV",{class:!0});var Pc=s(Oe);g(nn.$$.fragment,Pc),Dv=l(Pc),ai=n(Pc,"P",{});var dT=s(ai);ii=n(dT,"A",{href:!0});var yk=s(ii);zv=i(yk,"FlaxLogitsWarper"),yk.forEach(t),qv=i(dT," for temperature (exponential scaling output probability distribution)."),dT.forEach(t),Ov=l(Pc),ci=n(Pc,"DIV",{class:!0});var kk=s(ci);g(sn.$$.fragment,kk),kk.forEach(t),Pc.forEach(t),bm=l(e),Be=n(e,"DIV",{class:!0});var Fc=s(Be);g(an.$$.fragment,Fc),Bv=l(Fc),li=n(Fc,"P",{});var pT=s(li);di=n(pT,"A",{href:!0});var xk=s(di);Iv=i(xk,"FlaxLogitsWarper"),xk.forEach(t),Av=i(pT," that performs top-p, i.e. restricting to top tokens summing to prob_cut_off <= prob_cut_off."),pT.forEach(t),Cv=l(Fc),pi=n(Fc,"DIV",{class:!0});var wk=s(pi);g(cn.$$.fragment,wk),wk.forEach(t),Fc.forEach(t),vm=l(e),Ie=n(e,"DIV",{class:!0});var Sc=s(Ie);g(ln.$$.fragment,Sc),Nv=l(Sc),mi=n(Sc,"P",{});var mT=s(mi);fi=n(mT,"A",{href:!0});var Lk=s(fi);Wv=i(Lk,"FlaxLogitsWarper"),Lk.forEach(t),Vv=i(mT," that performs top-k, i.e. restricting to the k highest probability elements."),mT.forEach(t),Mv=l(Sc),gi=n(Sc,"DIV",{class:!0});var Ek=s(gi);g(dn.$$.fragment,Ek),Ek.forEach(t),Sc.forEach(t),$m=l(e),Ae=n(e,"DIV",{class:!0});var Dc=s(Ae);g(pn.$$.fragment,Dc),jv=l(Dc),hi=n(Dc,"P",{});var fT=s(hi);ui=n(fT,"A",{href:!0});var Pk=s(ui);Gv=i(Pk,"FlaxLogitsProcessor"),Pk.forEach(t),Hv=i(fT," that enforces the specified token as the first generated token."),fT.forEach(t),Rv=l(Dc),_i=n(Dc,"DIV",{class:!0});var Fk=s(_i);g(mn.$$.fragment,Fk),Fk.forEach(t),Dc.forEach(t),Tm=l(e),Ce=n(e,"DIV",{class:!0});var zc=s(Ce);g(fn.$$.fragment,zc),Uv=l(zc),Ur=n(zc,"P",{});var ap=s(Ur);bi=n(ap,"A",{href:!0});var Sk=s(bi);Kv=i(Sk,"FlaxLogitsProcessor"),Sk.forEach(t),Yv=i(ap," that enforces the specified token as the last generated token when "),cd=n(ap,"CODE",{});var Dk=s(cd);Xv=i(Dk,"max_length"),Dk.forEach(t),Jv=i(ap," is reached."),ap.forEach(t),Qv=l(zc),vi=n(zc,"DIV",{class:!0});var zk=s(vi);g(gn.$$.fragment,zk),zk.forEach(t),zc.forEach(t),ym=l(e),Ne=n(e,"DIV",{class:!0});var qc=s(Ne);g(hn.$$.fragment,qc),Zv=l(qc),$i=n(qc,"P",{});var gT=s($i);Ti=n(gT,"A",{href:!0});var qk=s(Ti);e1=i(qk,"FlaxLogitsProcessor"),qk.forEach(t),r1=i(gT," enforcing a min-length by setting EOS probability to 0."),gT.forEach(t),t1=l(qc),yi=n(qc,"DIV",{class:!0});var Ok=s(yi);g(un.$$.fragment,Ok),Ok.forEach(t),qc.forEach(t),km=l(e),gr=n(e,"H2",{class:!0});var _f=s(gr);Kr=n(_f,"A",{id:!0,class:!0,href:!0});var Bk=s(Kr);ld=n(Bk,"SPAN",{});var Ik=s(ld);g(_n.$$.fragment,Ik),Ik.forEach(t),Bk.forEach(t),o1=l(_f),dd=n(_f,"SPAN",{});var Ak=s(dd);n1=i(Ak,"StoppingCriteria"),Ak.forEach(t),_f.forEach(t),xm=l(e),Yr=n(e,"P",{});var bf=s(Yr);s1=i(bf,"A "),ki=n(bf,"A",{href:!0});var Ck=s(ki);a1=i(Ck,"StoppingCriteria"),Ck.forEach(t),i1=i(bf," can be used to change when to stop generation (other than EOS token)."),bf.forEach(t),wm=l(e),We=n(e,"DIV",{class:!0});var Oc=s(We);g(bn.$$.fragment,Oc),c1=l(Oc),pd=n(Oc,"P",{});var Nk=s(pd);l1=i(Nk,"Abstract base class for all stopping criteria that can be applied during generation."),Nk.forEach(t),d1=l(Oc),xi=n(Oc,"DIV",{class:!0});var Wk=s(xi);g(vn.$$.fragment,Wk),Wk.forEach(t),Oc.forEach(t),Lm=l(e),hr=n(e,"DIV",{class:!0});var vf=s(hr);g($n.$$.fragment,vf),p1=l(vf),wi=n(vf,"DIV",{class:!0});var Vk=s(wi);g(Tn.$$.fragment,Vk),Vk.forEach(t),vf.forEach(t),Em=l(e),Ve=n(e,"DIV",{class:!0});var Bc=s(Ve);g(yn.$$.fragment,Bc),m1=l(Bc),kn=n(Bc,"P",{});var $f=s(kn);f1=i($f,"This class can be used to stop generation whenever the full generated number of tokens exceeds "),md=n($f,"CODE",{});var Mk=s(md);g1=i(Mk,"max_length"),Mk.forEach(t),h1=i($f,`. Keep
in mind for decoder-only type of transformers, this will include the initial prompted tokens.`),$f.forEach(t),u1=l(Bc),Li=n(Bc,"DIV",{class:!0});var jk=s(Li);g(xn.$$.fragment,jk),jk.forEach(t),Bc.forEach(t),Pm=l(e),Me=n(e,"DIV",{class:!0});var Ic=s(Me);g(wn.$$.fragment,Ic),_1=l(Ic),Ln=n(Ic,"P",{});var Tf=s(Ln);b1=i(Tf,`This class can be used to stop generation whenever the full generation exceeds some amount of time. By default, the
time will start being counted when you initialize this function. You can override this by passing an
`),fd=n(Tf,"CODE",{});var Gk=s(fd);v1=i(Gk,"initial_time"),Gk.forEach(t),$1=i(Tf,"."),Tf.forEach(t),T1=l(Ic),Ei=n(Ic,"DIV",{class:!0});var Hk=s(Ei);g(En.$$.fragment,Hk),Hk.forEach(t),Ic.forEach(t),Fm=l(e),ur=n(e,"H2",{class:!0});var yf=s(ur);Xr=n(yf,"A",{id:!0,class:!0,href:!0});var Rk=s(Xr);gd=n(Rk,"SPAN",{});var Uk=s(gd);g(Pn.$$.fragment,Uk),Uk.forEach(t),Rk.forEach(t),y1=l(yf),hd=n(yf,"SPAN",{});var Kk=s(hd);k1=i(Kk,"Constraints"),Kk.forEach(t),yf.forEach(t),Sm=l(e),Jr=n(e,"P",{});var kf=s(Jr);x1=i(kf,"A "),Pi=n(kf,"A",{href:!0});var Yk=s(Pi);w1=i(Yk,"Constraint"),Yk.forEach(t),L1=i(kf," can be used to force the generation to include specific tokens or sequences in the output."),kf.forEach(t),Dm=l(e),k=n(e,"DIV",{class:!0});var w=s(k);g(Fn.$$.fragment,w),E1=l(w),ud=n(w,"P",{});var Xk=s(ud);P1=i(Xk,`Abstract base class for all constraints that can be applied during generation.
It must define how the constraint can be satisfied.`),Xk.forEach(t),F1=l(w),_d=n(w,"P",{});var Jk=s(_d);S1=i(Jk,"All classes that inherit Constraint must follow the requirement that"),Jk.forEach(t),D1=l(w),g(Qr.$$.fragment,w),z1=l(w),bd=n(w,"P",{});var Qk=s(bd);q1=i(Qk,"will always terminate (halt)."),Qk.forEach(t),O1=l(w),Zr=n(w,"DIV",{class:!0});var xf=s(Zr);g(Sn.$$.fragment,xf),B1=l(xf),vd=n(xf,"P",{});var Zk=s(vd);I1=i(Zk,"When called, returns the token that would take this constraint one step closer to being fulfilled."),Zk.forEach(t),xf.forEach(t),A1=l(w),et=n(w,"DIV",{class:!0});var wf=s(et);g(Dn.$$.fragment,wf),C1=l(wf),$d=n(wf,"P",{});var e0=s($d);N1=i(e0,"Creates a new instance of this constraint."),e0.forEach(t),wf.forEach(t),W1=l(w),rt=n(w,"DIV",{class:!0});var Lf=s(rt);g(zn.$$.fragment,Lf),V1=l(Lf),Td=n(Lf,"P",{});var r0=s(Td);M1=i(r0,"Reads in a token and returns whether it creates progress."),r0.forEach(t),Lf.forEach(t),j1=l(w),tt=n(w,"DIV",{class:!0});var Ef=s(tt);g(qn.$$.fragment,Ef),G1=l(Ef),On=n(Ef,"P",{});var Pf=s(On);H1=i(Pf,"Returns the number of remaining steps of "),yd=n(Pf,"CODE",{});var t0=s(yd);R1=i(t0,"advance()"),t0.forEach(t),U1=i(Pf," in order to complete this constraint."),Pf.forEach(t),Ef.forEach(t),K1=l(w),ot=n(w,"DIV",{class:!0});var Ff=s(ot);g(Bn.$$.fragment,Ff),Y1=l(Ff),kd=n(Ff,"P",{});var o0=s(kd);X1=i(o0,`Resets the state of this constraint to its initialization. We would call this in cases where the fulfillment of
a constraint is abrupted by an unwanted token.`),o0.forEach(t),Ff.forEach(t),J1=l(w),nt=n(w,"DIV",{class:!0});var Sf=s(nt);g(In.$$.fragment,Sf),Q1=l(Sf),xd=n(Sf,"P",{});var n0=s(xd);Z1=i(n0,"Tests whether this constraint has been properly defined."),n0.forEach(t),Sf.forEach(t),e2=l(w),Ye=n(w,"DIV",{class:!0});var Ac=s(Ye);g(An.$$.fragment,Ac),r2=l(Ac),Cn=n(Ac,"P",{});var Df=s(Cn);t2=i(Df,`Reads in a token and returns booleans that indicate the progress made by it. This function will update the
state of this object unlikes `),wd=n(Df,"CODE",{});var s0=s(wd);o2=i(s0,"does_advance(self, token_id: int)"),s0.forEach(t),n2=i(Df,"."),Df.forEach(t),s2=l(Ac),Ld=n(Ac,"P",{});var a0=s(Ld);a2=i(a0,`This isn\u2019t to test whether a certain token will advance the progress; it\u2019s to update its state as if it has
been generated. This becomes important if token_id != desired token (refer to else statement in
PhrasalConstraint)`),a0.forEach(t),Ac.forEach(t),w.forEach(t),zm=l(e),_r=n(e,"DIV",{class:!0});var zf=s(_r);g(Nn.$$.fragment,zf),i2=l(zf),Fi=n(zf,"P",{});var hT=s(Fi);Si=n(hT,"A",{href:!0});var i0=s(Si);c2=i(i0,"Constraint"),i0.forEach(t),l2=i(hT," enforcing that an ordered sequence of tokens is included in the output."),hT.forEach(t),zf.forEach(t),qm=l(e),br=n(e,"DIV",{class:!0});var qf=s(br);g(Wn.$$.fragment,qf),d2=l(qf),Vn=n(qf,"P",{});var Of=s(Vn);p2=i(Of,"A special "),Di=n(Of,"A",{href:!0});var c0=s(Di);m2=i(c0,"Constraint"),c0.forEach(t),f2=i(Of," that is fulfilled by fulfilling just one of several constraints."),Of.forEach(t),qf.forEach(t),Om=l(e),G=n(e,"DIV",{class:!0});var _t=s(G);g(Mn.$$.fragment,_t),g2=l(_t),Ed=n(_t,"P",{});var l0=s(Ed);h2=i(l0,"A class for beam scorers to track its progress through a list of constraints."),l0.forEach(t),u2=l(_t),B=n(_t,"DIV",{class:!0});var X=s(B);g(jn.$$.fragment,X),_2=l(X),Pd=n(X,"P",{});var d0=s(Pd);b2=i(d0,`The list of tokens to generate such that we can make progress.
By \u201Clist\u201D we don\u2019t mean the list of token that will fully fulfill a constraint.`),d0.forEach(t),v2=l(X),vr=n(X,"P",{});var Cc=s(vr);$2=i(Cc,"Given constraints "),Fd=n(Cc,"CODE",{});var p0=s(Fd);T2=i(p0,"c_i = {t_ij | j == # of tokens}"),p0.forEach(t),y2=i(Cc,`, If we\u2019re not in the middle of progressing through a
specific constraint `),Sd=n(Cc,"CODE",{});var m0=s(Sd);k2=i(m0,"c_i"),m0.forEach(t),x2=i(Cc,", we return:"),Cc.forEach(t),w2=l(X),Dd=n(X,"P",{});var f0=s(Dd);zd=n(f0,"CODE",{});var g0=s(zd);L2=i(g0,"[t_k1 for k in indices of unfulfilled constraints]"),g0.forEach(t),f0.forEach(t),E2=l(X),je=n(X,"P",{});var bt=s(je);P2=i(bt,`If we are in the middle of a constraint, then we return:
`),qd=n(bt,"CODE",{});var h0=s(qd);F2=i(h0,"[t_ij]"),h0.forEach(t),S2=i(bt,", where "),Od=n(bt,"CODE",{});var u0=s(Od);D2=i(u0,"i"),u0.forEach(t),z2=i(bt," is the index of the inprogress constraint, "),Bd=n(bt,"CODE",{});var _0=s(Bd);q2=i(_0,"j"),_0.forEach(t),O2=i(bt," is the next step for the constraint."),bt.forEach(t),B2=l(X),Id=n(X,"P",{});var b0=s(Id);I2=i(b0,`Though we don\u2019t care which constraint is fulfilled first, if we are in the progress of fulfilling a constraint,
that\u2019s the only one we\u2019ll return.`),b0.forEach(t),X.forEach(t),A2=l(_t),st=n(_t,"DIV",{class:!0});var Bf=s(st);g(Gn.$$.fragment,Bf),C2=l(Bf),Ad=n(Bf,"P",{});var v0=s(Ad);N2=i(v0,"token_ids: the tokens generated thus far to reset the state of the progress through constraints."),v0.forEach(t),Bf.forEach(t),_t.forEach(t),Bm=l(e),$r=n(e,"H2",{class:!0});var If=s($r);at=n(If,"A",{id:!0,class:!0,href:!0});var $0=s(at);Cd=n($0,"SPAN",{});var T0=s(Cd);g(Hn.$$.fragment,T0),T0.forEach(t),$0.forEach(t),W2=l(If),Nd=n(If,"SPAN",{});var y0=s(Nd);V2=i(y0,"BeamSearch"),y0.forEach(t),If.forEach(t),Im=l(e),H=n(e,"DIV",{class:!0});var vt=s(H);g(Rn.$$.fragment,vt),M2=l(vt),Tr=n(vt,"P",{});var Nc=s(Tr);j2=i(Nc,"Abstract base class for all beam scorers that are used for "),zi=n(Nc,"A",{href:!0});var k0=s(zi);G2=i(k0,"beam_search()"),k0.forEach(t),H2=i(Nc,` and
`),qi=n(Nc,"A",{href:!0});var x0=s(qi);R2=i(x0,"beam_sample()"),x0.forEach(t),U2=i(Nc,"."),Nc.forEach(t),K2=l(vt),Oi=n(vt,"DIV",{class:!0});var w0=s(Oi);g(Un.$$.fragment,w0),w0.forEach(t),Y2=l(vt),Bi=n(vt,"DIV",{class:!0});var L0=s(Bi);g(Kn.$$.fragment,L0),L0.forEach(t),vt.forEach(t),Am=l(e),q=n(e,"DIV",{class:!0});var J=s(q);g(Yn.$$.fragment,J),X2=l(J),Ii=n(J,"P",{});var uT=s(Ii);Ai=n(uT,"A",{href:!0});var E0=s(Ai);J2=i(E0,"BeamScorer"),E0.forEach(t),Q2=i(uT," implementing standard beam search decoding."),uT.forEach(t),Z2=l(J),Xn=n(J,"P",{});var Af=s(Xn);e$=i(Af,"Adapted in part from "),Jn=n(Af,"A",{href:!0,rel:!0});var P0=s(Jn);r$=i(P0,`Facebook\u2019s XLM beam search
code`),P0.forEach(t),t$=i(Af,"."),Af.forEach(t),o$=l(J),Ci=n(J,"P",{});var _T=s(Ci);n$=i(_T,"Reference for the diverse beam search algorithm and implementation "),Qn=n(_T,"A",{href:!0,rel:!0});var F0=s(Qn);s$=i(F0,`Ashwin Kalyan\u2019s DBS
implementation`),F0.forEach(t),_T.forEach(t),a$=l(J),Ni=n(J,"DIV",{class:!0});var S0=s(Ni);g(Zn.$$.fragment,S0),S0.forEach(t),i$=l(J),Wi=n(J,"DIV",{class:!0});var D0=s(Wi);g(es.$$.fragment,D0),D0.forEach(t),J.forEach(t),Cm=l(e),R=n(e,"DIV",{class:!0});var $t=s(R);g(rs.$$.fragment,$t),c$=l($t),Vi=n($t,"P",{});var bT=s(Vi);Mi=n(bT,"A",{href:!0});var z0=s(Mi);l$=i(z0,"BeamScorer"),z0.forEach(t),d$=i(bT," implementing constrained beam search decoding."),bT.forEach(t),p$=l($t),ji=n($t,"DIV",{class:!0});var q0=s(ji);g(ts.$$.fragment,q0),q0.forEach(t),m$=l($t),Gi=n($t,"DIV",{class:!0});var O0=s(Gi);g(os.$$.fragment,O0),O0.forEach(t),$t.forEach(t),Nm=l(e),yr=n(e,"H2",{class:!0});var Cf=s(yr);it=n(Cf,"A",{id:!0,class:!0,href:!0});var B0=s(it);Wd=n(B0,"SPAN",{});var I0=s(Wd);g(ns.$$.fragment,I0),I0.forEach(t),B0.forEach(t),f$=l(Cf),Vd=n(Cf,"SPAN",{});var A0=s(Vd);g$=i(A0,"Utilities"),A0.forEach(t),Cf.forEach(t),Wm=l(e),Ge=n(e,"DIV",{class:!0});var Wc=s(Ge);g(ss.$$.fragment,Wc),h$=l(Wc),Md=n(Wc,"P",{});var C0=s(Md);u$=i(C0,"Filter a distribution of logits using top-k and/or nucleus (top-p) filtering"),C0.forEach(t),_$=l(Wc),Hi=n(Wc,"P",{});var vT=s(Hi);b$=i(vT,"From: "),as=n(vT,"A",{href:!0,rel:!0});var N0=s(as);v$=i(N0,"https://gist.github.com/thomwolf/1a5a29f6962089e871b94cbd09daf317"),N0.forEach(t),vT.forEach(t),Wc.forEach(t),Vm=l(e),He=n(e,"DIV",{class:!0});var Vc=s(He);g(is.$$.fragment,Vc),$$=l(Vc),jd=n(Vc,"P",{});var W0=s(jd);T$=i(W0,"Filter a distribution of logits using top-k and/or nucleus (top-p) filtering"),W0.forEach(t),y$=l(Vc),Ri=n(Vc,"P",{});var $T=s(Ri);k$=i($T,"From: "),cs=n($T,"A",{href:!0,rel:!0});var V0=s(cs);x$=i(V0,"https://gist.github.com/thomwolf/1a5a29f6962089e871b94cbd09daf317"),V0.forEach(t),$T.forEach(t),Vc.forEach(t),Mm=l(e),kr=n(e,"H2",{class:!0});var Nf=s(kr);ct=n(Nf,"A",{id:!0,class:!0,href:!0});var M0=s(ct);Gd=n(M0,"SPAN",{});var j0=s(Gd);g(ls.$$.fragment,j0),j0.forEach(t),M0.forEach(t),w$=l(Nf),Hd=n(Nf,"SPAN",{});var G0=s(Hd);L$=i(G0,"Streamers"),G0.forEach(t),Nf.forEach(t),jm=l(e),O=n(e,"DIV",{class:!0});var Q=s(O);g(ds.$$.fragment,Q),E$=l(Q),Rd=n(Q,"P",{});var H0=s(Rd);P$=i(H0,"Simple text streamer that prints the token(s) to stdout as soon as entire words are formed."),H0.forEach(t),F$=l(Q),g(lt.$$.fragment,Q),S$=l(Q),dt=n(Q,"DIV",{class:!0});var Wf=s(dt);g(ps.$$.fragment,Wf),D$=l(Wf),Ud=n(Wf,"P",{});var R0=s(Ud);z$=i(R0,"Flushes any remaining cache and prints a newline to stdout."),R0.forEach(t),Wf.forEach(t),q$=l(Q),pt=n(Q,"DIV",{class:!0});var Vf=s(pt);g(ms.$$.fragment,Vf),O$=l(Vf),Kd=n(Vf,"P",{});var U0=s(Kd);B$=i(U0,"Prints the new text to stdout. If the stream is ending, also prints a newline."),U0.forEach(t),Vf.forEach(t),I$=l(Q),mt=n(Q,"DIV",{class:!0});var Mf=s(mt);g(fs.$$.fragment,Mf),A$=l(Mf),Yd=n(Mf,"P",{});var K0=s(Yd);C$=i(K0,"Recives tokens, decodes them, and prints them to stdout as soon as they form entire words."),K0.forEach(t),Mf.forEach(t),Q.forEach(t),Gm=l(e),U=n(e,"DIV",{class:!0});var Tt=s(U);g(gs.$$.fragment,Tt),N$=l(Tt),Xd=n(Tt,"P",{});var Y0=s(Xd);W$=i(Y0,`Streamer that stores print-ready text in a queue, to be used by a downstream application as an iterator. This is
useful for applications that benefit from acessing the generated text in a non-blocking way (e.g. in an interactive
Gradio demo).`),Y0.forEach(t),V$=l(Tt),g(ft.$$.fragment,Tt),M$=l(Tt),gt=n(Tt,"DIV",{class:!0});var jf=s(gt);g(hs.$$.fragment,jf),j$=l(jf),Jd=n(jf,"P",{});var X0=s(Jd);G$=i(X0,"Put the new text in the queue. If the stream is ending, also put a stop signal in the queue."),X0.forEach(t),jf.forEach(t),Tt.forEach(t),this.h()},h(){d(T,"name","hf:doc:metadata"),d(T,"content",JSON.stringify(ax)),d(x,"id","utilities-for-generation"),d(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(x,"href","#utilities-for-generation"),d(y,"class","relative group"),d(vs,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.generate"),d($s,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.greedy_search"),d(Ts,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.contrastive_search"),d(ys,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.sample"),d(ks,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.beam_search"),d(xs,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.beam_sample"),d(ws,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.group_beam_search"),d(Ls,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.constrained_beam_search"),d(wr,"id","generate-outputs"),d(wr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(wr,"href","#generate-outputs"),d(er,"class","relative group"),d(Ps,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.generate"),d(Fs,"href","/docs/transformers/pr_21894/en/main_classes/output#transformers.utils.ModelOutput"),d(Ss,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.generate"),d(zs,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.generation.GreedySearchDecoderOnlyOutput"),d(Er,"id","transformers.generation.GreedySearchDecoderOnlyOutput"),d(Er,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Er,"href","#transformers.generation.GreedySearchDecoderOnlyOutput"),d(rr,"class","relative group"),d(tr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(or,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Pr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Fr,"id","transformers.generation.SampleDecoderOnlyOutput"),d(Fr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Fr,"href","#transformers.generation.SampleDecoderOnlyOutput"),d(nr,"class","relative group"),d(sr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ar,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Sr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Dr,"id","transformers.generation.BeamSearchDecoderOnlyOutput"),d(Dr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Dr,"href","#transformers.generation.BeamSearchDecoderOnlyOutput"),d(ir,"class","relative group"),d(cr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(lr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(zr,"id","transformers.generation.BeamSampleDecoderOnlyOutput"),d(zr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(zr,"href","#transformers.generation.BeamSampleDecoderOnlyOutput"),d(dr,"class","relative group"),d(pr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(mr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(qr,"id","transformers.LogitsProcessor"),d(qr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(qr,"href","#transformers.LogitsProcessor"),d(fr,"class","relative group"),d(Cs,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(Br,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ns,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(Ws,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsWarper"),d(Vs,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(Ms,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsWarper"),d(js,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ir,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Hs,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(Rs,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ks,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(Ys,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Js,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsWarper"),d(Qs,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ea,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(ra,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(oa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsWarper"),d(na,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(aa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsWarper"),d(ia,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ca,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsWarper"),d(io,"href","https://arxiv.org/abs/2202.00666"),d(io,"rel","nofollow"),d(la,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(da,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(po,"href","https://github.com/pytorch/fairseq/blob/a07cb6f40480928c9e0548b737aadd36ee66ac76/fairseq/sequence_generator.py#L345"),d(po,"rel","nofollow"),d(pa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(fa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(ga,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ha,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(uo,"href","https://arxiv.org/abs/2010.00904"),d(uo,"rel","nofollow"),d(ua,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(_a,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(ba,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.group_beam_search"),d(vo,"href","https://arxiv.org/pdf/1610.02424.pdf"),d(vo,"rel","nofollow"),d(va,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ta,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(ya,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ka,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(xa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(wa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.LogitsProcessor"),d(La,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Vr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ea,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Pa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Fa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Mr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Da,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsWarper"),d(za,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Oa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsWarper"),d(Ba,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Aa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsWarper"),d(Ca,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Wa,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Va,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ja,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Ga,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ha,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Go,"href","https://github.com/pytorch/fairseq/blob/a07cb6f40480928c9e0548b737aadd36ee66ac76/fairseq/sequence_generator.py#L345"),d(Go,"rel","nofollow"),d(Ra,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ka,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Ya,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ja,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(Qa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Za,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.TFLogitsProcessor"),d(ei,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Hr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ri,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsProcessor"),d(ti,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsWarper"),d(oi,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsProcessor"),d(ni,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsWarper"),d(si,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Rr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ii,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsWarper"),d(ci,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(di,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsWarper"),d(pi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(fi,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsWarper"),d(gi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ui,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsProcessor"),d(_i,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(bi,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsProcessor"),d(vi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ti,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.FlaxLogitsProcessor"),d(yi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Kr,"id","transformers.StoppingCriteria"),d(Kr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Kr,"href","#transformers.StoppingCriteria"),d(gr,"class","relative group"),d(ki,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.StoppingCriteria"),d(xi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(We,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(wi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(hr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Li,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ei,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Xr,"id","transformers.Constraint"),d(Xr,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Xr,"href","#transformers.Constraint"),d(ur,"class","relative group"),d(Pi,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.Constraint"),d(Zr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(nt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Si,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.Constraint"),d(_r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Di,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.Constraint"),d(br,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(st,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(at,"id","transformers.BeamScorer"),d(at,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(at,"href","#transformers.BeamScorer"),d($r,"class","relative group"),d(zi,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.beam_search"),d(qi,"href","/docs/transformers/pr_21894/en/main_classes/text_generation#transformers.GenerationMixin.beam_sample"),d(Oi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Bi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ai,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.BeamScorer"),d(Jn,"href","https://github.com/facebookresearch/XLM/blob/9e6f6814d17be4fe5b15f2e6c43eb2b2d76daeb4/src/model/transformer.py#L529"),d(Jn,"rel","nofollow"),d(Qn,"href","https://github.com/ashwinkalyan/dbs/blob/master/dbs/beam_utils.lua"),d(Qn,"rel","nofollow"),d(Ni,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Wi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Mi,"href","/docs/transformers/pr_21894/en/internal/generation_utils#transformers.BeamScorer"),d(ji,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Gi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(it,"id","transformers.top_k_top_p_filtering"),d(it,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(it,"href","#transformers.top_k_top_p_filtering"),d(yr,"class","relative group"),d(as,"href","https://gist.github.com/thomwolf/1a5a29f6962089e871b94cbd09daf317"),d(as,"rel","nofollow"),d(Ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(cs,"href","https://gist.github.com/thomwolf/1a5a29f6962089e871b94cbd09daf317"),d(cs,"rel","nofollow"),d(He,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ct,"id","transformers.TextStreamer"),d(ct,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ct,"href","#transformers.TextStreamer"),d(kr,"class","relative group"),d(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(gt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,p){r(document.head,T),m(e,F,p),m(e,y,p),r(y,x),r(x,I),h($,I,null),r(y,S),r(y,Mc),r(Mc,Gf),m(e,cp,p),m(e,L,p),r(L,Hf),r(L,vs),r(vs,Rf),r(L,Uf),r(L,$s),r($s,Kf),r(L,Yf),r(L,Ts),r(Ts,Xf),r(L,Jf),r(L,ys),r(ys,Qf),r(L,Zf),r(L,ks),r(ks,eg),r(L,rg),r(L,xs),r(xs,tg),r(L,og),r(L,ws),r(ws,ng),r(L,sg),r(L,Ls),r(Ls,ag),r(L,ig),m(e,lp,p),m(e,Es,p),r(Es,cg),m(e,dp,p),m(e,er,p),r(er,wr),r(wr,jc),h(yt,jc,null),r(er,lg),r(er,Gc),r(Gc,dg),m(e,pp,p),m(e,K,p),r(K,pg),r(K,Ps),r(Ps,mg),r(K,fg),r(K,Fs),r(Fs,gg),r(K,hg),r(K,Ss),r(Ss,ug),r(K,_g),m(e,mp,p),m(e,Ds,p),r(Ds,bg),m(e,fp,p),h(kt,e,p),m(e,gp,p),m(e,Re,p),r(Re,vg),r(Re,Hc),r(Hc,$g),r(Re,Tg),r(Re,zs),r(zs,yg),r(Re,kg),m(e,hp,p),m(e,Y,p),r(Y,qs),r(qs,Rc),r(Rc,xg),r(qs,wg),r(Y,Lg),r(Y,Os),r(Os,Uc),r(Uc,Eg),r(Os,Pg),r(Y,Fg),r(Y,Bs),r(Bs,Kc),r(Kc,Sg),r(Bs,Dg),r(Y,zg),r(Y,Is),r(Is,Yc),r(Yc,qg),r(Is,Og),m(e,up,p),m(e,E,p),r(E,Bg),r(E,Xc),r(Xc,Ig),r(E,Ag),r(E,Jc),r(Jc,Cg),r(E,Ng),r(E,Qc),r(Qc,Wg),r(E,Vg),r(E,Zc),r(Zc,Mg),r(E,jg),r(E,el),r(el,Gg),r(E,Hg),r(E,rl),r(rl,Rg),r(E,Ug),m(e,_p,p),m(e,A,p),r(A,Kg),r(A,tl),r(tl,Yg),r(A,Xg),r(A,ol),r(ol,Jg),r(A,Qg),r(A,nl),r(nl,Zg),r(A,eh),r(A,sl),r(sl,rh),r(A,th),m(e,bp,p),m(e,C,p),r(C,oh),r(C,al),r(al,nh),r(C,sh),r(C,il),r(il,ah),r(C,ih),r(C,cl),r(cl,ch),r(C,lh),r(C,ll),r(ll,dh),r(C,ph),m(e,vp,p),h(xt,e,p),m(e,$p,p),m(e,Lr,p),r(Lr,mh),r(Lr,dl),r(dl,fh),r(Lr,gh),m(e,Tp,p),m(e,N,p),r(N,hh),r(N,pl),r(pl,uh),r(N,_h),r(N,ml),r(ml,bh),r(N,vh),r(N,fl),r(fl,$h),r(N,Th),r(N,gl),r(gl,yh),r(N,kh),m(e,yp,p),m(e,As,p),r(As,xh),m(e,kp,p),m(e,rr,p),r(rr,Er),r(Er,hl),h(wt,hl,null),r(rr,wh),r(rr,ul),r(ul,Lh),m(e,xp,p),m(e,tr,p),h(Lt,tr,null),r(tr,Eh),r(tr,_l),r(_l,Ph),m(e,wp,p),m(e,or,p),h(Et,or,null),r(or,Fh),r(or,bl),r(bl,Sh),m(e,Lp,p),m(e,ee,p),h(Pt,ee,null),r(ee,Dh),r(ee,vl),r(vl,zh),r(ee,qh),r(ee,Pr),h(Ft,Pr,null),r(Pr,Oh),r(Pr,$l),r($l,Bh),m(e,Ep,p),m(e,nr,p),r(nr,Fr),r(Fr,Tl),h(St,Tl,null),r(nr,Ih),r(nr,yl),r(yl,Ah),m(e,Pp,p),m(e,sr,p),h(Dt,sr,null),r(sr,Ch),r(sr,kl),r(kl,Nh),m(e,Fp,p),m(e,ar,p),h(zt,ar,null),r(ar,Wh),r(ar,xl),r(xl,Vh),m(e,Sp,p),m(e,re,p),h(qt,re,null),r(re,Mh),r(re,wl),r(wl,jh),r(re,Gh),r(re,Sr),h(Ot,Sr,null),r(Sr,Hh),r(Sr,Ll),r(Ll,Rh),m(e,Dp,p),m(e,ir,p),r(ir,Dr),r(Dr,El),h(Bt,El,null),r(ir,Uh),r(ir,Pl),r(Pl,Kh),m(e,zp,p),m(e,cr,p),h(It,cr,null),r(cr,Yh),r(cr,Fl),r(Fl,Xh),m(e,qp,p),m(e,lr,p),h(At,lr,null),r(lr,Jh),r(lr,Sl),r(Sl,Qh),m(e,Op,p),m(e,dr,p),r(dr,zr),r(zr,Dl),h(Ct,Dl,null),r(dr,Zh),r(dr,zl),r(zl,eu),m(e,Bp,p),m(e,pr,p),h(Nt,pr,null),r(pr,ru),r(pr,ql),r(ql,tu),m(e,Ip,p),m(e,mr,p),h(Wt,mr,null),r(mr,ou),r(mr,Ol),r(Ol,nu),m(e,Ap,p),m(e,fr,p),r(fr,qr),r(qr,Bl),h(Vt,Bl,null),r(fr,su),r(fr,Il),r(Il,au),m(e,Cp,p),m(e,Or,p),r(Or,iu),r(Or,Cs),r(Cs,cu),r(Or,lu),m(e,Np,p),m(e,te,p),h(Mt,te,null),r(te,du),r(te,Al),r(Al,pu),r(te,mu),r(te,Br),h(jt,Br,null),r(Br,fu),r(Br,Cl),r(Cl,gu),m(e,Wp,p),m(e,oe,p),h(Gt,oe,null),r(oe,hu),r(oe,D),r(D,uu),r(D,Ns),r(Ns,_u),r(D,bu),r(D,Ws),r(Ws,vu),r(D,$u),r(D,Nl),r(Nl,Tu),r(D,yu),r(D,Wl),r(Wl,Vl),r(Vl,ku),r(D,xu),r(D,Vs),r(Vs,wu),r(D,Lu),r(D,Ms),r(Ms,Eu),r(D,Pu),r(oe,Fu),r(oe,js),h(Ht,js,null),m(e,Vp,p),m(e,ne,p),h(Rt,ne,null),r(ne,Su),r(ne,Ml),r(Ml,Du),r(ne,zu),r(ne,Ir),h(Ut,Ir,null),r(Ir,qu),r(Ir,jl),r(jl,Ou),m(e,Mp,p),m(e,se,p),h(Kt,se,null),r(se,Bu),r(se,Gs),r(Gs,Hs),r(Hs,Iu),r(Gs,Au),r(se,Cu),r(se,Rs),h(Yt,Rs,null),m(e,jp,p),m(e,ae,p),h(Xt,ae,null),r(ae,Nu),r(ae,Us),r(Us,Ks),r(Ks,Wu),r(Us,Vu),r(ae,Mu),r(ae,Ys),h(Jt,Ys,null),m(e,Gp,p),m(e,ie,p),h(Qt,ie,null),r(ie,ju),r(ie,Xs),r(Xs,Js),r(Js,Gu),r(Xs,Hu),r(ie,Ru),r(ie,Qs),h(Zt,Qs,null),m(e,Hp,p),m(e,ce,p),h(eo,ce,null),r(ce,Uu),r(ce,Zs),r(Zs,ea),r(ea,Ku),r(Zs,Yu),r(ce,Xu),r(ce,ra),h(ro,ra,null),m(e,Rp,p),m(e,le,p),h(to,le,null),r(le,Ju),r(le,ta),r(ta,oa),r(oa,Qu),r(ta,Zu),r(le,e_),r(le,na),h(oo,na,null),m(e,Up,p),m(e,de,p),h(no,de,null),r(de,r_),r(de,sa),r(sa,aa),r(aa,t_),r(sa,o_),r(de,n_),r(de,ia),h(so,ia,null),m(e,Kp,p),m(e,pe,p),h(ao,pe,null),r(pe,s_),r(pe,Ar),r(Ar,ca),r(ca,a_),r(Ar,i_),r(Ar,io),r(io,c_),r(Ar,l_),r(pe,d_),r(pe,la),h(co,la,null),m(e,Yp,p),m(e,me,p),h(lo,me,null),r(me,p_),r(me,Cr),r(Cr,da),r(da,m_),r(Cr,f_),r(Cr,po),r(po,g_),r(Cr,h_),r(me,u_),r(me,pa),h(mo,pa,null),m(e,Xp,p),m(e,fe,p),h(fo,fe,null),r(fe,__),r(fe,ma),r(ma,fa),r(fa,b_),r(ma,v_),r(fe,$_),r(fe,ga),h(go,ga,null),m(e,Jp,p),m(e,ge,p),h(ho,ge,null),r(ge,T_),r(ge,Nr),r(Nr,ha),r(ha,y_),r(Nr,k_),r(Nr,uo),r(uo,x_),r(Nr,w_),r(ge,L_),r(ge,ua),h(_o,ua,null),m(e,Qp,p),m(e,he,p),h(bo,he,null),r(he,E_),r(he,Ue),r(Ue,_a),r(_a,P_),r(Ue,F_),r(Ue,ba),r(ba,S_),r(Ue,D_),r(Ue,vo),r(vo,z_),r(Ue,q_),r(he,O_),r(he,va),h($o,va,null),m(e,Zp,p),m(e,ue,p),h(To,ue,null),r(ue,B_),r(ue,$a),r($a,Ta),r(Ta,I_),r($a,A_),r(ue,C_),r(ue,ya),h(yo,ya,null),m(e,em,p),m(e,_e,p),h(ko,_e,null),r(_e,N_),r(_e,Wr),r(Wr,ka),r(ka,W_),r(Wr,V_),r(Wr,Gl),r(Gl,M_),r(Wr,j_),r(_e,G_),r(_e,xa),h(xo,xa,null),m(e,rm,p),m(e,be,p),h(wo,be,null),r(be,H_),r(be,Ke),r(Ke,wa),r(wa,R_),r(Ke,U_),r(Ke,Hl),r(Hl,K_),r(Ke,Y_),r(Ke,Rl),r(Rl,X_),r(Ke,J_),r(be,Q_),r(be,La),h(Lo,La,null),m(e,tm,p),m(e,ve,p),h(Eo,ve,null),r(ve,Z_),r(ve,Ul),r(Ul,eb),r(ve,rb),r(ve,Vr),h(Po,Vr,null),r(Vr,tb),r(Vr,Kl),r(Kl,ob),m(e,om,p),m(e,$e,p),h(Fo,$e,null),r($e,nb),r($e,j),r(j,sb),r(j,Ea),r(Ea,ab),r(j,ib),r(j,Yl),r(Yl,cb),r(j,lb),r(j,Xl),r(Xl,Jl),r(Jl,db),r(j,pb),r(j,Pa),r(Pa,mb),r(j,fb),r($e,gb),r($e,Fa),h(So,Fa,null),m(e,nm,p),m(e,Te,p),h(Do,Te,null),r(Te,hb),r(Te,Ql),r(Ql,ub),r(Te,_b),r(Te,Mr),h(zo,Mr,null),r(Mr,bb),r(Mr,Zl),r(Zl,vb),m(e,sm,p),m(e,ye,p),h(qo,ye,null),r(ye,$b),r(ye,Sa),r(Sa,Da),r(Da,Tb),r(Sa,yb),r(ye,kb),r(ye,za),h(Oo,za,null),m(e,am,p),m(e,ke,p),h(Bo,ke,null),r(ke,xb),r(ke,qa),r(qa,Oa),r(Oa,wb),r(qa,Lb),r(ke,Eb),r(ke,Ba),h(Io,Ba,null),m(e,im,p),m(e,xe,p),h(Ao,xe,null),r(xe,Pb),r(xe,Ia),r(Ia,Aa),r(Aa,Fb),r(Ia,Sb),r(xe,Db),r(xe,Ca),h(Co,Ca,null),m(e,cm,p),m(e,we,p),h(No,we,null),r(we,zb),r(we,Na),r(Na,Wa),r(Wa,qb),r(Na,Ob),r(we,Bb),r(we,Va),h(Wo,Va,null),m(e,lm,p),m(e,Le,p),h(Vo,Le,null),r(Le,Ib),r(Le,Ma),r(Ma,ja),r(ja,Ab),r(Ma,Cb),r(Le,Nb),r(Le,Ga),h(Mo,Ga,null),m(e,dm,p),m(e,Ee,p),h(jo,Ee,null),r(Ee,Wb),r(Ee,jr),r(jr,Ha),r(Ha,Vb),r(jr,Mb),r(jr,Go),r(Go,jb),r(jr,Gb),r(Ee,Hb),r(Ee,Ra),h(Ho,Ra,null),m(e,pm,p),m(e,Pe,p),h(Ro,Pe,null),r(Pe,Rb),r(Pe,Ua),r(Ua,Ka),r(Ka,Ub),r(Ua,Kb),r(Pe,Yb),r(Pe,Ya),h(Uo,Ya,null),m(e,mm,p),m(e,Fe,p),h(Ko,Fe,null),r(Fe,Xb),r(Fe,Xa),r(Xa,Ja),r(Ja,Jb),r(Xa,Qb),r(Fe,Zb),r(Fe,Qa),h(Yo,Qa,null),m(e,fm,p),m(e,Se,p),h(Xo,Se,null),r(Se,ev),r(Se,Gr),r(Gr,Za),r(Za,rv),r(Gr,tv),r(Gr,ed),r(ed,ov),r(Gr,nv),r(Se,sv),r(Se,ei),h(Jo,ei,null),m(e,gm,p),m(e,De,p),h(Qo,De,null),r(De,av),r(De,rd),r(rd,iv),r(De,cv),r(De,Hr),h(Zo,Hr,null),r(Hr,lv),r(Hr,td),r(td,dv),m(e,hm,p),m(e,ze,p),h(en,ze,null),r(ze,pv),r(ze,z),r(z,mv),r(z,ri),r(ri,fv),r(z,gv),r(z,ti),r(ti,hv),r(z,uv),r(z,od),r(od,_v),r(z,bv),r(z,nd),r(nd,sd),r(sd,vv),r(z,$v),r(z,oi),r(oi,Tv),r(z,yv),r(z,ni),r(ni,kv),r(z,xv),r(ze,wv),r(ze,si),h(rn,si,null),m(e,um,p),m(e,qe,p),h(tn,qe,null),r(qe,Lv),r(qe,ad),r(ad,Ev),r(qe,Pv),r(qe,Rr),h(on,Rr,null),r(Rr,Fv),r(Rr,id),r(id,Sv),m(e,_m,p),m(e,Oe,p),h(nn,Oe,null),r(Oe,Dv),r(Oe,ai),r(ai,ii),r(ii,zv),r(ai,qv),r(Oe,Ov),r(Oe,ci),h(sn,ci,null),m(e,bm,p),m(e,Be,p),h(an,Be,null),r(Be,Bv),r(Be,li),r(li,di),r(di,Iv),r(li,Av),r(Be,Cv),r(Be,pi),h(cn,pi,null),m(e,vm,p),m(e,Ie,p),h(ln,Ie,null),r(Ie,Nv),r(Ie,mi),r(mi,fi),r(fi,Wv),r(mi,Vv),r(Ie,Mv),r(Ie,gi),h(dn,gi,null),m(e,$m,p),m(e,Ae,p),h(pn,Ae,null),r(Ae,jv),r(Ae,hi),r(hi,ui),r(ui,Gv),r(hi,Hv),r(Ae,Rv),r(Ae,_i),h(mn,_i,null),m(e,Tm,p),m(e,Ce,p),h(fn,Ce,null),r(Ce,Uv),r(Ce,Ur),r(Ur,bi),r(bi,Kv),r(Ur,Yv),r(Ur,cd),r(cd,Xv),r(Ur,Jv),r(Ce,Qv),r(Ce,vi),h(gn,vi,null),m(e,ym,p),m(e,Ne,p),h(hn,Ne,null),r(Ne,Zv),r(Ne,$i),r($i,Ti),r(Ti,e1),r($i,r1),r(Ne,t1),r(Ne,yi),h(un,yi,null),m(e,km,p),m(e,gr,p),r(gr,Kr),r(Kr,ld),h(_n,ld,null),r(gr,o1),r(gr,dd),r(dd,n1),m(e,xm,p),m(e,Yr,p),r(Yr,s1),r(Yr,ki),r(ki,a1),r(Yr,i1),m(e,wm,p),m(e,We,p),h(bn,We,null),r(We,c1),r(We,pd),r(pd,l1),r(We,d1),r(We,xi),h(vn,xi,null),m(e,Lm,p),m(e,hr,p),h($n,hr,null),r(hr,p1),r(hr,wi),h(Tn,wi,null),m(e,Em,p),m(e,Ve,p),h(yn,Ve,null),r(Ve,m1),r(Ve,kn),r(kn,f1),r(kn,md),r(md,g1),r(kn,h1),r(Ve,u1),r(Ve,Li),h(xn,Li,null),m(e,Pm,p),m(e,Me,p),h(wn,Me,null),r(Me,_1),r(Me,Ln),r(Ln,b1),r(Ln,fd),r(fd,v1),r(Ln,$1),r(Me,T1),r(Me,Ei),h(En,Ei,null),m(e,Fm,p),m(e,ur,p),r(ur,Xr),r(Xr,gd),h(Pn,gd,null),r(ur,y1),r(ur,hd),r(hd,k1),m(e,Sm,p),m(e,Jr,p),r(Jr,x1),r(Jr,Pi),r(Pi,w1),r(Jr,L1),m(e,Dm,p),m(e,k,p),h(Fn,k,null),r(k,E1),r(k,ud),r(ud,P1),r(k,F1),r(k,_d),r(_d,S1),r(k,D1),h(Qr,k,null),r(k,z1),r(k,bd),r(bd,q1),r(k,O1),r(k,Zr),h(Sn,Zr,null),r(Zr,B1),r(Zr,vd),r(vd,I1),r(k,A1),r(k,et),h(Dn,et,null),r(et,C1),r(et,$d),r($d,N1),r(k,W1),r(k,rt),h(zn,rt,null),r(rt,V1),r(rt,Td),r(Td,M1),r(k,j1),r(k,tt),h(qn,tt,null),r(tt,G1),r(tt,On),r(On,H1),r(On,yd),r(yd,R1),r(On,U1),r(k,K1),r(k,ot),h(Bn,ot,null),r(ot,Y1),r(ot,kd),r(kd,X1),r(k,J1),r(k,nt),h(In,nt,null),r(nt,Q1),r(nt,xd),r(xd,Z1),r(k,e2),r(k,Ye),h(An,Ye,null),r(Ye,r2),r(Ye,Cn),r(Cn,t2),r(Cn,wd),r(wd,o2),r(Cn,n2),r(Ye,s2),r(Ye,Ld),r(Ld,a2),m(e,zm,p),m(e,_r,p),h(Nn,_r,null),r(_r,i2),r(_r,Fi),r(Fi,Si),r(Si,c2),r(Fi,l2),m(e,qm,p),m(e,br,p),h(Wn,br,null),r(br,d2),r(br,Vn),r(Vn,p2),r(Vn,Di),r(Di,m2),r(Vn,f2),m(e,Om,p),m(e,G,p),h(Mn,G,null),r(G,g2),r(G,Ed),r(Ed,h2),r(G,u2),r(G,B),h(jn,B,null),r(B,_2),r(B,Pd),r(Pd,b2),r(B,v2),r(B,vr),r(vr,$2),r(vr,Fd),r(Fd,T2),r(vr,y2),r(vr,Sd),r(Sd,k2),r(vr,x2),r(B,w2),r(B,Dd),r(Dd,zd),r(zd,L2),r(B,E2),r(B,je),r(je,P2),r(je,qd),r(qd,F2),r(je,S2),r(je,Od),r(Od,D2),r(je,z2),r(je,Bd),r(Bd,q2),r(je,O2),r(B,B2),r(B,Id),r(Id,I2),r(G,A2),r(G,st),h(Gn,st,null),r(st,C2),r(st,Ad),r(Ad,N2),m(e,Bm,p),m(e,$r,p),r($r,at),r(at,Cd),h(Hn,Cd,null),r($r,W2),r($r,Nd),r(Nd,V2),m(e,Im,p),m(e,H,p),h(Rn,H,null),r(H,M2),r(H,Tr),r(Tr,j2),r(Tr,zi),r(zi,G2),r(Tr,H2),r(Tr,qi),r(qi,R2),r(Tr,U2),r(H,K2),r(H,Oi),h(Un,Oi,null),r(H,Y2),r(H,Bi),h(Kn,Bi,null),m(e,Am,p),m(e,q,p),h(Yn,q,null),r(q,X2),r(q,Ii),r(Ii,Ai),r(Ai,J2),r(Ii,Q2),r(q,Z2),r(q,Xn),r(Xn,e$),r(Xn,Jn),r(Jn,r$),r(Xn,t$),r(q,o$),r(q,Ci),r(Ci,n$),r(Ci,Qn),r(Qn,s$),r(q,a$),r(q,Ni),h(Zn,Ni,null),r(q,i$),r(q,Wi),h(es,Wi,null),m(e,Cm,p),m(e,R,p),h(rs,R,null),r(R,c$),r(R,Vi),r(Vi,Mi),r(Mi,l$),r(Vi,d$),r(R,p$),r(R,ji),h(ts,ji,null),r(R,m$),r(R,Gi),h(os,Gi,null),m(e,Nm,p),m(e,yr,p),r(yr,it),r(it,Wd),h(ns,Wd,null),r(yr,f$),r(yr,Vd),r(Vd,g$),m(e,Wm,p),m(e,Ge,p),h(ss,Ge,null),r(Ge,h$),r(Ge,Md),r(Md,u$),r(Ge,_$),r(Ge,Hi),r(Hi,b$),r(Hi,as),r(as,v$),m(e,Vm,p),m(e,He,p),h(is,He,null),r(He,$$),r(He,jd),r(jd,T$),r(He,y$),r(He,Ri),r(Ri,k$),r(Ri,cs),r(cs,x$),m(e,Mm,p),m(e,kr,p),r(kr,ct),r(ct,Gd),h(ls,Gd,null),r(kr,w$),r(kr,Hd),r(Hd,L$),m(e,jm,p),m(e,O,p),h(ds,O,null),r(O,E$),r(O,Rd),r(Rd,P$),r(O,F$),h(lt,O,null),r(O,S$),r(O,dt),h(ps,dt,null),r(dt,D$),r(dt,Ud),r(Ud,z$),r(O,q$),r(O,pt),h(ms,pt,null),r(pt,O$),r(pt,Kd),r(Kd,B$),r(O,I$),r(O,mt),h(fs,mt,null),r(mt,A$),r(mt,Yd),r(Yd,C$),m(e,Gm,p),m(e,U,p),h(gs,U,null),r(U,N$),r(U,Xd),r(Xd,W$),r(U,V$),h(ft,U,null),r(U,M$),r(U,gt),h(hs,gt,null),r(gt,j$),r(gt,Jd),r(Jd,G$),Hm=!0},p(e,[p]){const us={};p&2&&(us.$$scope={dirty:p,ctx:e}),Qr.$set(us);const Qd={};p&2&&(Qd.$$scope={dirty:p,ctx:e}),lt.$set(Qd);const Zd={};p&2&&(Zd.$$scope={dirty:p,ctx:e}),ft.$set(Zd)},i(e){Hm||(u($.$$.fragment,e),u(yt.$$.fragment,e),u(kt.$$.fragment,e),u(xt.$$.fragment,e),u(wt.$$.fragment,e),u(Lt.$$.fragment,e),u(Et.$$.fragment,e),u(Pt.$$.fragment,e),u(Ft.$$.fragment,e),u(St.$$.fragment,e),u(Dt.$$.fragment,e),u(zt.$$.fragment,e),u(qt.$$.fragment,e),u(Ot.$$.fragment,e),u(Bt.$$.fragment,e),u(It.$$.fragment,e),u(At.$$.fragment,e),u(Ct.$$.fragment,e),u(Nt.$$.fragment,e),u(Wt.$$.fragment,e),u(Vt.$$.fragment,e),u(Mt.$$.fragment,e),u(jt.$$.fragment,e),u(Gt.$$.fragment,e),u(Ht.$$.fragment,e),u(Rt.$$.fragment,e),u(Ut.$$.fragment,e),u(Kt.$$.fragment,e),u(Yt.$$.fragment,e),u(Xt.$$.fragment,e),u(Jt.$$.fragment,e),u(Qt.$$.fragment,e),u(Zt.$$.fragment,e),u(eo.$$.fragment,e),u(ro.$$.fragment,e),u(to.$$.fragment,e),u(oo.$$.fragment,e),u(no.$$.fragment,e),u(so.$$.fragment,e),u(ao.$$.fragment,e),u(co.$$.fragment,e),u(lo.$$.fragment,e),u(mo.$$.fragment,e),u(fo.$$.fragment,e),u(go.$$.fragment,e),u(ho.$$.fragment,e),u(_o.$$.fragment,e),u(bo.$$.fragment,e),u($o.$$.fragment,e),u(To.$$.fragment,e),u(yo.$$.fragment,e),u(ko.$$.fragment,e),u(xo.$$.fragment,e),u(wo.$$.fragment,e),u(Lo.$$.fragment,e),u(Eo.$$.fragment,e),u(Po.$$.fragment,e),u(Fo.$$.fragment,e),u(So.$$.fragment,e),u(Do.$$.fragment,e),u(zo.$$.fragment,e),u(qo.$$.fragment,e),u(Oo.$$.fragment,e),u(Bo.$$.fragment,e),u(Io.$$.fragment,e),u(Ao.$$.fragment,e),u(Co.$$.fragment,e),u(No.$$.fragment,e),u(Wo.$$.fragment,e),u(Vo.$$.fragment,e),u(Mo.$$.fragment,e),u(jo.$$.fragment,e),u(Ho.$$.fragment,e),u(Ro.$$.fragment,e),u(Uo.$$.fragment,e),u(Ko.$$.fragment,e),u(Yo.$$.fragment,e),u(Xo.$$.fragment,e),u(Jo.$$.fragment,e),u(Qo.$$.fragment,e),u(Zo.$$.fragment,e),u(en.$$.fragment,e),u(rn.$$.fragment,e),u(tn.$$.fragment,e),u(on.$$.fragment,e),u(nn.$$.fragment,e),u(sn.$$.fragment,e),u(an.$$.fragment,e),u(cn.$$.fragment,e),u(ln.$$.fragment,e),u(dn.$$.fragment,e),u(pn.$$.fragment,e),u(mn.$$.fragment,e),u(fn.$$.fragment,e),u(gn.$$.fragment,e),u(hn.$$.fragment,e),u(un.$$.fragment,e),u(_n.$$.fragment,e),u(bn.$$.fragment,e),u(vn.$$.fragment,e),u($n.$$.fragment,e),u(Tn.$$.fragment,e),u(yn.$$.fragment,e),u(xn.$$.fragment,e),u(wn.$$.fragment,e),u(En.$$.fragment,e),u(Pn.$$.fragment,e),u(Fn.$$.fragment,e),u(Qr.$$.fragment,e),u(Sn.$$.fragment,e),u(Dn.$$.fragment,e),u(zn.$$.fragment,e),u(qn.$$.fragment,e),u(Bn.$$.fragment,e),u(In.$$.fragment,e),u(An.$$.fragment,e),u(Nn.$$.fragment,e),u(Wn.$$.fragment,e),u(Mn.$$.fragment,e),u(jn.$$.fragment,e),u(Gn.$$.fragment,e),u(Hn.$$.fragment,e),u(Rn.$$.fragment,e),u(Un.$$.fragment,e),u(Kn.$$.fragment,e),u(Yn.$$.fragment,e),u(Zn.$$.fragment,e),u(es.$$.fragment,e),u(rs.$$.fragment,e),u(ts.$$.fragment,e),u(os.$$.fragment,e),u(ns.$$.fragment,e),u(ss.$$.fragment,e),u(is.$$.fragment,e),u(ls.$$.fragment,e),u(ds.$$.fragment,e),u(lt.$$.fragment,e),u(ps.$$.fragment,e),u(ms.$$.fragment,e),u(fs.$$.fragment,e),u(gs.$$.fragment,e),u(ft.$$.fragment,e),u(hs.$$.fragment,e),Hm=!0)},o(e){_($.$$.fragment,e),_(yt.$$.fragment,e),_(kt.$$.fragment,e),_(xt.$$.fragment,e),_(wt.$$.fragment,e),_(Lt.$$.fragment,e),_(Et.$$.fragment,e),_(Pt.$$.fragment,e),_(Ft.$$.fragment,e),_(St.$$.fragment,e),_(Dt.$$.fragment,e),_(zt.$$.fragment,e),_(qt.$$.fragment,e),_(Ot.$$.fragment,e),_(Bt.$$.fragment,e),_(It.$$.fragment,e),_(At.$$.fragment,e),_(Ct.$$.fragment,e),_(Nt.$$.fragment,e),_(Wt.$$.fragment,e),_(Vt.$$.fragment,e),_(Mt.$$.fragment,e),_(jt.$$.fragment,e),_(Gt.$$.fragment,e),_(Ht.$$.fragment,e),_(Rt.$$.fragment,e),_(Ut.$$.fragment,e),_(Kt.$$.fragment,e),_(Yt.$$.fragment,e),_(Xt.$$.fragment,e),_(Jt.$$.fragment,e),_(Qt.$$.fragment,e),_(Zt.$$.fragment,e),_(eo.$$.fragment,e),_(ro.$$.fragment,e),_(to.$$.fragment,e),_(oo.$$.fragment,e),_(no.$$.fragment,e),_(so.$$.fragment,e),_(ao.$$.fragment,e),_(co.$$.fragment,e),_(lo.$$.fragment,e),_(mo.$$.fragment,e),_(fo.$$.fragment,e),_(go.$$.fragment,e),_(ho.$$.fragment,e),_(_o.$$.fragment,e),_(bo.$$.fragment,e),_($o.$$.fragment,e),_(To.$$.fragment,e),_(yo.$$.fragment,e),_(ko.$$.fragment,e),_(xo.$$.fragment,e),_(wo.$$.fragment,e),_(Lo.$$.fragment,e),_(Eo.$$.fragment,e),_(Po.$$.fragment,e),_(Fo.$$.fragment,e),_(So.$$.fragment,e),_(Do.$$.fragment,e),_(zo.$$.fragment,e),_(qo.$$.fragment,e),_(Oo.$$.fragment,e),_(Bo.$$.fragment,e),_(Io.$$.fragment,e),_(Ao.$$.fragment,e),_(Co.$$.fragment,e),_(No.$$.fragment,e),_(Wo.$$.fragment,e),_(Vo.$$.fragment,e),_(Mo.$$.fragment,e),_(jo.$$.fragment,e),_(Ho.$$.fragment,e),_(Ro.$$.fragment,e),_(Uo.$$.fragment,e),_(Ko.$$.fragment,e),_(Yo.$$.fragment,e),_(Xo.$$.fragment,e),_(Jo.$$.fragment,e),_(Qo.$$.fragment,e),_(Zo.$$.fragment,e),_(en.$$.fragment,e),_(rn.$$.fragment,e),_(tn.$$.fragment,e),_(on.$$.fragment,e),_(nn.$$.fragment,e),_(sn.$$.fragment,e),_(an.$$.fragment,e),_(cn.$$.fragment,e),_(ln.$$.fragment,e),_(dn.$$.fragment,e),_(pn.$$.fragment,e),_(mn.$$.fragment,e),_(fn.$$.fragment,e),_(gn.$$.fragment,e),_(hn.$$.fragment,e),_(un.$$.fragment,e),_(_n.$$.fragment,e),_(bn.$$.fragment,e),_(vn.$$.fragment,e),_($n.$$.fragment,e),_(Tn.$$.fragment,e),_(yn.$$.fragment,e),_(xn.$$.fragment,e),_(wn.$$.fragment,e),_(En.$$.fragment,e),_(Pn.$$.fragment,e),_(Fn.$$.fragment,e),_(Qr.$$.fragment,e),_(Sn.$$.fragment,e),_(Dn.$$.fragment,e),_(zn.$$.fragment,e),_(qn.$$.fragment,e),_(Bn.$$.fragment,e),_(In.$$.fragment,e),_(An.$$.fragment,e),_(Nn.$$.fragment,e),_(Wn.$$.fragment,e),_(Mn.$$.fragment,e),_(jn.$$.fragment,e),_(Gn.$$.fragment,e),_(Hn.$$.fragment,e),_(Rn.$$.fragment,e),_(Un.$$.fragment,e),_(Kn.$$.fragment,e),_(Yn.$$.fragment,e),_(Zn.$$.fragment,e),_(es.$$.fragment,e),_(rs.$$.fragment,e),_(ts.$$.fragment,e),_(os.$$.fragment,e),_(ns.$$.fragment,e),_(ss.$$.fragment,e),_(is.$$.fragment,e),_(ls.$$.fragment,e),_(ds.$$.fragment,e),_(lt.$$.fragment,e),_(ps.$$.fragment,e),_(ms.$$.fragment,e),_(fs.$$.fragment,e),_(gs.$$.fragment,e),_(ft.$$.fragment,e),_(hs.$$.fragment,e),Hm=!1},d(e){t(T),e&&t(F),e&&t(y),b($),e&&t(cp),e&&t(L),e&&t(lp),e&&t(Es),e&&t(dp),e&&t(er),b(yt),e&&t(pp),e&&t(K),e&&t(mp),e&&t(Ds),e&&t(fp),b(kt,e),e&&t(gp),e&&t(Re),e&&t(hp),e&&t(Y),e&&t(up),e&&t(E),e&&t(_p),e&&t(A),e&&t(bp),e&&t(C),e&&t(vp),b(xt,e),e&&t($p),e&&t(Lr),e&&t(Tp),e&&t(N),e&&t(yp),e&&t(As),e&&t(kp),e&&t(rr),b(wt),e&&t(xp),e&&t(tr),b(Lt),e&&t(wp),e&&t(or),b(Et),e&&t(Lp),e&&t(ee),b(Pt),b(Ft),e&&t(Ep),e&&t(nr),b(St),e&&t(Pp),e&&t(sr),b(Dt),e&&t(Fp),e&&t(ar),b(zt),e&&t(Sp),e&&t(re),b(qt),b(Ot),e&&t(Dp),e&&t(ir),b(Bt),e&&t(zp),e&&t(cr),b(It),e&&t(qp),e&&t(lr),b(At),e&&t(Op),e&&t(dr),b(Ct),e&&t(Bp),e&&t(pr),b(Nt),e&&t(Ip),e&&t(mr),b(Wt),e&&t(Ap),e&&t(fr),b(Vt),e&&t(Cp),e&&t(Or),e&&t(Np),e&&t(te),b(Mt),b(jt),e&&t(Wp),e&&t(oe),b(Gt),b(Ht),e&&t(Vp),e&&t(ne),b(Rt),b(Ut),e&&t(Mp),e&&t(se),b(Kt),b(Yt),e&&t(jp),e&&t(ae),b(Xt),b(Jt),e&&t(Gp),e&&t(ie),b(Qt),b(Zt),e&&t(Hp),e&&t(ce),b(eo),b(ro),e&&t(Rp),e&&t(le),b(to),b(oo),e&&t(Up),e&&t(de),b(no),b(so),e&&t(Kp),e&&t(pe),b(ao),b(co),e&&t(Yp),e&&t(me),b(lo),b(mo),e&&t(Xp),e&&t(fe),b(fo),b(go),e&&t(Jp),e&&t(ge),b(ho),b(_o),e&&t(Qp),e&&t(he),b(bo),b($o),e&&t(Zp),e&&t(ue),b(To),b(yo),e&&t(em),e&&t(_e),b(ko),b(xo),e&&t(rm),e&&t(be),b(wo),b(Lo),e&&t(tm),e&&t(ve),b(Eo),b(Po),e&&t(om),e&&t($e),b(Fo),b(So),e&&t(nm),e&&t(Te),b(Do),b(zo),e&&t(sm),e&&t(ye),b(qo),b(Oo),e&&t(am),e&&t(ke),b(Bo),b(Io),e&&t(im),e&&t(xe),b(Ao),b(Co),e&&t(cm),e&&t(we),b(No),b(Wo),e&&t(lm),e&&t(Le),b(Vo),b(Mo),e&&t(dm),e&&t(Ee),b(jo),b(Ho),e&&t(pm),e&&t(Pe),b(Ro),b(Uo),e&&t(mm),e&&t(Fe),b(Ko),b(Yo),e&&t(fm),e&&t(Se),b(Xo),b(Jo),e&&t(gm),e&&t(De),b(Qo),b(Zo),e&&t(hm),e&&t(ze),b(en),b(rn),e&&t(um),e&&t(qe),b(tn),b(on),e&&t(_m),e&&t(Oe),b(nn),b(sn),e&&t(bm),e&&t(Be),b(an),b(cn),e&&t(vm),e&&t(Ie),b(ln),b(dn),e&&t($m),e&&t(Ae),b(pn),b(mn),e&&t(Tm),e&&t(Ce),b(fn),b(gn),e&&t(ym),e&&t(Ne),b(hn),b(un),e&&t(km),e&&t(gr),b(_n),e&&t(xm),e&&t(Yr),e&&t(wm),e&&t(We),b(bn),b(vn),e&&t(Lm),e&&t(hr),b($n),b(Tn),e&&t(Em),e&&t(Ve),b(yn),b(xn),e&&t(Pm),e&&t(Me),b(wn),b(En),e&&t(Fm),e&&t(ur),b(Pn),e&&t(Sm),e&&t(Jr),e&&t(Dm),e&&t(k),b(Fn),b(Qr),b(Sn),b(Dn),b(zn),b(qn),b(Bn),b(In),b(An),e&&t(zm),e&&t(_r),b(Nn),e&&t(qm),e&&t(br),b(Wn),e&&t(Om),e&&t(G),b(Mn),b(jn),b(Gn),e&&t(Bm),e&&t($r),b(Hn),e&&t(Im),e&&t(H),b(Rn),b(Un),b(Kn),e&&t(Am),e&&t(q),b(Yn),b(Zn),b(es),e&&t(Cm),e&&t(R),b(rs),b(ts),b(os),e&&t(Nm),e&&t(yr),b(ns),e&&t(Wm),e&&t(Ge),b(ss),e&&t(Vm),e&&t(He),b(is),e&&t(Mm),e&&t(kr),b(ls),e&&t(jm),e&&t(O),b(ds),b(lt),b(ps),b(ms),b(fs),e&&t(Gm),e&&t(U),b(gs),b(ft),b(hs)}}}const ax={local:"utilities-for-generation",sections:[{local:"generate-outputs",sections:[{local:"transformers.generation.GreedySearchDecoderOnlyOutput",title:"GreedySearchOutput"},{local:"transformers.generation.SampleDecoderOnlyOutput",title:"SampleOutput"},{local:"transformers.generation.BeamSearchDecoderOnlyOutput",title:"BeamSearchOutput"},{local:"transformers.generation.BeamSampleDecoderOnlyOutput",title:"BeamSampleOutput"}],title:"Generate Outputs"},{local:"transformers.LogitsProcessor",title:"LogitsProcessor"},{local:"transformers.StoppingCriteria",title:"StoppingCriteria"},{local:"transformers.Constraint",title:"Constraints"},{local:"transformers.BeamScorer",title:"BeamSearch"},{local:"transformers.top_k_top_p_filtering",title:"Utilities"},{local:"transformers.TextStreamer",title:"Streamers"}],title:"Utilities for Generation"};function ix(xr){return rx(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class fx extends J0{constructor(T){super();Q0(this,T,ix,sx,Z0,{})}}export{fx as default,ax as metadata};
